<?php
/*
*
* @name banners_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: banners_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}


class banners_block extends blockgets_block
{
	function init()
	{
		global $template, $db;

		$this->tpl_name = 'banners_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$sql = 'SELECT *
			FROM ' . BLG_LISTS_DATA_TABLE . '
			WHERE list_id = ' . $data['list_id'] . '
			ORDER BY RAND()';
		$result = $db->sql_query_limit($sql, 1);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		build_img_path($row['link_img_url'], $this->master->path . 'images/banners/');

		$template->assign_vars(array(	
			'S_BANNER_IMG' 			=> '<img src="' . $row['link_img_url'] . '" width="' . $row['link_img_width'] . '" height="' . $row['link_img_height'] . '" title="' . $row['link_title'] . '" alt="" />',
			'S_BANNER_DESCRIPTION' 	=> $row['link_title'],
			'S_SHOW_DESCRIPTION'	=> $data['show_desc'],
			'U_BANNER_URL' 			=> $row['link_url'],		
		));

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
		return true;
	}

	function get_config()
	{
		$this->display_vars = array(
			'list_id'		=> array('lang' => 'BANNERS_LIST',	'validate' => 'int',	'type' => 'custom', 'function' => 'blg_lists_select', 'params' => array('{KEY}', 'banner', '{CONFIG_VALUE}'),  'default' => 0),
			'show_desc'		=> array('lang' => 'BANNERS_DESC',	'validate' => 'bool',	'type' => 'radio:yes_no', 'default' => 0),
		);

		return true;
	}
}

?>
