<?php
/*
*
* @name banners_multiple_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: banners_multiple_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}


class banners_multiple_block extends blockgets_block
{
	function init()
	{
		global $template, $db;

		$this->tpl_name = 'banners_multiple_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$sql = 'SELECT *
			FROM ' . BLG_LISTS_DATA_TABLE . '
			WHERE list_id = ' . $data['list_id'] . '
			ORDER BY link_order ASC';
		$result = $db->sql_query_limit($sql, $data['banner_number']);

		//Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('banners');

		while($row = $db->sql_fetchrow($result))
		{
			build_img_path($row['link_img_url'], $this->master->path . 'images/banners/');

			$template->assign_block_vars('banners', array(	
				'S_IMG' 				=> '<img src="' . $row['link_img_url'] . '" width="' . $row['link_img_width'] . '" height="' . $row['link_img_height'] . '" title="' . $row['link_title'] . '" alt="" />',
				'S_DESCRIPTION' 		=> $row['link_title'],
				'S_SHOW_DESCRIPTION'	=> $data['show_desc'],
				'U_URL' 				=> $row['link_url'],		
			));
		}
		$db->sql_freeresult($result);

		$template->assign_vars(array(
			'S_BLOCK_HEIGHT'		=> (($data['list_type'] == BLG_SCROLL_V) ? $data['block_height'] : 'auto'),
			'S_MARQUEE_DIRECTION'	=> (($data['list_type'] == BLG_NO_SCROLL || $data['list_type'] == BLG_SCROLL_H) ? 'left' : 'up'),
			'S_MARQUEE_ALIGN'		=> (($data['list_type'] == BLG_SCROLL_H) ? 'left' : 'center'),
			'S_MARQUEE_TYPE'		=> (($data['list_type'] == BLG_NO_SCROLL) ? 'static' : 'scroll'),
			'S_MARQUEE_SPEED'		=> $data['scroll_fps'],
		));

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
		return true;
	}

	function get_config()
	{
		$this->display_vars = array(
			'list_id'		=> array('lang' => 'BANNERS_LIST',		'validate' => 'int',	'type' => 'custom', 'function' => 'blg_lists_select', 'params' => array('{KEY}', 'banner', '{CONFIG_VALUE}'),  'default' => 0),
			'show_desc'		=> array('lang' => 'BANNERS_DESC',		'validate' => 'bool',	'type' => 'radio:yes_no', 'default' => 0),
			'list_type'		=> array('lang' => 'BANNERS_LS_TYPE',	'validate' => 'int',	'type' => 'select', 'function' => 'banner_listtype_select',	'params' => array('{CONFIG_VALUE}')),
			'banner_number'	=> array('lang' => 'BANNERS_NUMBER',	'validate' => 'int',	'type' => 'text:4:3',	'default' => 5),
			'block_height'	=> array('lang' => 'BANNERS_B_HEIGHT',	'validate' => 'int',	'type' => 'text:4:3',	'default' => 50),
			'scroll_fps'	=> array('lang' => 'MARQUEE_SPEED',		'validate' => 'int:1:10',	'type' => 'text:3:2',	'default' => 2),
		);

		return true;
	}
}

?>
