<?php
/*
*
* @name calendar_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: calendar_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class calendar_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $template, $auth, $phpEx;

		$this->tpl_name = 'calendar_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$extra_params = array(
			'jblgm=calendar',
			'fd=' . (int)$data['first_day'],
			'se=' . (int)$data['show_events'],
			'sb=' . (int)$data['show_birthdays'],
			'mn=' . (int)$data['months_number']
		);

		$template->assign_vars(array(
			'S_CAN_CREATE_EVENT'	=> ($auth->acl_get('u_blockgets_events') ? true : false),
			'U_CALENDAR'			=> append_sid($this->master->root_path . "calendar.$phpEx"),
			'S_EXTRA'				=> implode('&', $extra_params),
			'S_SHOW_EVENTS'			=> (int)$data['show_events'],
		));

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
		return true;
	}

	function get_config()
	{
		global $user;

		$options = 'Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday';
		$options = strtr($options, $user->lang['datetime']);
		$options = explode(', ', $options);
	
		$this->display_vars = array(
			'show_events'		=> array('lang' => 'CALENDAR_EVENTS',		'validate' => 'bool',		'type' => 'radio:yes_no',	'default' => 1),
			'show_birthdays'	=> array('lang' => 'CALENDAR_BIRTHDAYS',	'validate' => 'bool',		'type' => 'radio:yes_no',	'default' => 1),
			'first_day'			=> array('lang' => 'CALENDAR_FIRST_DAY',	'validate' => 'int',		'type' => 'select',	'function' => 'blg_make_select',	'params' => array($options, '{CONFIG_VALUE}', false),	'default' => 0),
			'months_number'		=> array('lang' => 'CALENDAR_MONTHS',		'validate' => 'int:1:12', 	'type' => 'text:5:3', 'default' => 1),
		);

		return true;
	}
}
?>
