<?php
/*
*
* @name clock_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: clock_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class clock_block extends blockgets_block
{
	var $clock_dir = 'swf/clocks/';

	function init()
	{
		global $template;

		$this->tpl_name = 'clock_block';
		$clock_file = $this->master->root_path . $this->clock_dir . $this->content;

		if(!file_exists($clock_file))
		{
			return false;
		}

		$template->assign_var('S_CLOCK_URL', $clock_file);

		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		global $template;

		$clock_url = request_var('clock_url', $block_row['block_content']);
	
		if($mode == 'submit')
		{
			$new['block_content'] = $clock_url;
			return;
		}

		if ($dir = @opendir($this->master->root_path . $this->clock_dir))
		{
			$clocks = array();
			while (($file = @readdir($dir)) !== false)
			{
				if (preg_match('#^([^&\'"<>]+)\.swf$#i', $file, $match))
				{
					$clocks[$file] = array(
						'file'	=> $file,
						'name'	=> ucfirst(str_replace('_', ' ', $match[1])),
					);
				}
			}
			closedir($dir);
			asort($clocks);
		}

		$s_clock_select = '';
		foreach($clocks as $clock)
		{
			$selected = (($clock['file'] == $clock_url) ? ' selected="selected"' : '');
			$s_clock_select .= '<option value="' . $clock['file'] . '"' . $selected . '>' . $clock['name'] . '</option>';
		}

		$template->assign_vars(array(
			'S_CLOCK_SELECT'		=> $s_clock_select,
			'S_CLOCK_PATH'			=> $this->master->root_path . $this->clock_dir,
		));

		return true;
	}

	function get_config()
	{
		$this->tpl_name = 'acp_clock_block';
		return true;
	}
}
?>
