<?php
/*
*
* @name cloud_tag_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: cloud_tag_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class cloud_tag_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $template, $db, $user, $phpEx;

		$this->tpl_name = 'cloud_tag_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		switch($data['list_mode'])
		{
			case 'search':
				$sql = 'SELECT word_text
					FROM ' . SEARCH_WORDLIST_TABLE . '
					ORDER BY word_count DESC';
				$result = $db->sql_query_limit($sql, $data['max_words']);

				while($row = $db->sql_fetchrow($result))
				{
					$tag_size = ($data['animation']) ?  rand(10, 16) : rand(8, 22);

					$template->assign_block_vars('clouds', array(
						'S_TAG_NAME'	=> $row['word_text'],
						'S_TAG_SIZE'	=> $tag_size,
						'U_TAG_URL'		=> append_sid("{$phpbb_root_path}search.$phpEx", "i=search&amp;mode=search&amp;keywords=" . urlencode($row['word_text'])),
					));
				}
			break;

			case 'users':
				$sql = 'SELECT user_id, username
					FROM ' . USERS_TABLE . '
					WHERE user_type <> ' . USER_IGNORE . '
					ORDER BY user_posts DESC';
				$result = $db->sql_query_limit($sql, $data['max_words']);

				while($row = $db->sql_fetchrow($result))
				{
					$tag_size = ($data['animation']) ?  rand(10, 16) : rand(8, 22);

					$template->assign_block_vars('clouds', array(
						'S_TAG_NAME'	=> $row['username'],
						'S_TAG_SIZE'	=> $tag_size,
						'U_TAG_URL'		=> append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=viewprofile&amp;u=" . $row['user_id']),
					));
				}
			break;

			default:
				return false;
			break;
		}
		$db->sql_freeresult($result);

		$template->assign_var('S_SHOW_ANIMATION', $data['animation']);

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
		return true;
	}

	function get_config()
	{
		$modes = array('search' => 'MODE_SEARCH',	'users'	=> 'MODE_USERS');

		$this->display_vars = array(
			'animation'		=> array('lang' => 'CLOUD_ANIMATION',	'validate' => 'bool',		'type' => 'radio:yes_no', 'default' => 1),
			'max_words'		=> array('lang' => 'CLOUD_WORDS',		'validate' => 'int:1:50',	'type' => 'text:4:3', 'default' => 25),
			'list_mode'		=> array('lang' => 'CLOUD_MODE',		'validate' => 'string',		'type' => 'select', 'function' => 'blg_make_select', 'params' => array($modes, '{CONFIG_VALUE}'),  'default' => 'search'),
		);

		return true;
	}
}
?>
