<?php
/*
*
* @name dockmenu_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: dock_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class dockmenu_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $db, $template, $user;

		$this->tpl_name = 'dockmenu_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		// Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('menu_row');

		// Get de menu links
		$sql = 'SELECT *
			FROM ' . BLG_LISTS_DATA_TABLE . '
			WHERE list_id = ' . $data['menu_id'] . '
			AND link_type = ' . LIST_LINK . '
			ORDER BY link_order ASC';
		$result = $db->sql_query($sql);

		while($row = $db->sql_fetchrow($result))
		{
			if(!blg_group_auth($row['link_groups']))
			{
				continue;
			}

			build_img_path($row['link_img_url'], $this->master->path . 'images/icons/');

			// If is internal link, append root path and user sid
			if(strpos($row['link_url'], 'http') !== 0)
			{
				$row['link_url'] = append_sid($phpbb_root_path . $row['link_url'], false, true, $user->session_id);
			}

			if(isset($user->lang[$row['link_title']]))
			{
				$row['link_title'] = $user->lang[$row['link_title']];
			}

			$template->assign_block_vars('menu_row', array(
				'S_TITLE'		=> $row['link_title'],
				'S_ICON'		=> '<img src="' . $row['link_img_url'] . '" title="' . $row['link_title'] . '" alt="" />',
				'S_WINDOW'		=> $row['link_window'],
				'U_LINK'		=> $row['link_url'],
			));
		}

		$template->assign_vars(array(
			'DOCK_ITEM_WIDTH'		=> $data['item_width'],
			'DOCK_ITEM_MAXWIDTH'	=> round($data['item_width'] + (($data['item_width'] * 60) / 100)),
		));

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'menu_id'		=> array('lang' => 'DISPLAY_MENU',	'validate' => 'int',		'type' => 'custom',	'function' => 'blg_lists_select',	'params' => array('{KEY}', 'menu', '{CONFIG_VALUE}')),
			'item_width'	=> array('lang' => 'ICON_WIDTH',	'validate' => 'int:16:250',	'type' => 'text:4:3',	'default' => 40),
		);

		return true;
	}
}
?>
