<?php
/*
*
* @name frame_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: frame_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class frame_block extends blockgets_block
{
	function init()
	{
		global $template;

		$this->tpl_name = 'frame_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}


		$template->assign_vars(array(
			'S_FRAME_MIMETYPE'	=> $data['frame_mimetype'],
			'S_FRAME_WIDTH'		=> ($data['frame_width']) ? $data['frame_width'] : '',
			'S_FRAME_HEIGHT'	=> ($data['frame_height']) ? $data['frame_height'] : '',
			'U_FRAME_URL'		=> $data['frame_url'],
		));

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		global $config;

		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$mimetypes = array(
			'text/plain'					=> 'MIME_PLAIN',
			'text/html'						=> 'MIME_HTML',
			'application/pdf'				=> 'MIME_PDF',
			'application/x-shockwave-flash'	=> 'MIME_FLASH',
		);

		$this->display_vars = array(
			'frame_mimetype' 		=> array('lang' => 'FRAME_MIMETYPE',		'validate' => 'string', 'type' => 'select', 'function' => 'blg_make_select', 'params' => array($mimetypes, '{CONFIG_VALUE}'),	'default' => 'text/html'),
			'frame_url'  			=> array('lang' => 'FRAME_URL',				'validate' => 'string:1:255',  	'type' => 'text:50:255',	'default' => ''),
			'frame_width'  			=> array('lang' => 'FRAME_WIDTH',			'validate' => 'int',  	'type' => 'text:5:4',	'default' => 0),
			'frame_height'  		=> array('lang' => 'FRAME_HEIGHT',			'validate' => 'int',  	'type' => 'text:5:4',	'default' => 0),
		);

		return true;
	}
}

?>
