<?php
/*
*
* @name google_translate_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: google_translate_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class google_translate_block extends blockgets_block
{
	function init()
	{
		global $template, $user;

		$this->tpl_name = 'google_translate_block';

		if(!$this->content)
		{
			return false;
		}

		//Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('translate');

		$langs = explode(',', $this->content);

		foreach($langs as $iso)
		{
			if($iso != $user->lang_name)
			{
				$template->assign_block_vars('translate', array(
					'S_ISO'		=> $iso,
					'S_LANG'	=> $this->master->locale_lang($iso, 'name'),
				));
			}
		}

		$template->assign_vars(array(
			'S_GOOGLE_LOGO'			=> $this->master->root_path . 'images/mini-google.png',
			'GOOGLE_TRANSLATE_URL'	=> $this->master->get_board_path('page'),
			'GOOGLE_USER_LANG'		=> $user->lang_name,
		));

		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		global $template;

		$flags_path	= $this->master->root_path . 'images/flags/';

		if($mode == 'submit')
		{
			$new['block_content'] = implode(',', request_var('langs', array('' => '')));
			return;
		}

		$langs = explode(',', $block_row['block_content']);
		
		$this->master->locale_lang('_get', 'name');

		foreach($this->master->lang_names as $iso => $langname)
		{
			if($langname)
			{
				$langname = explode(' * ', $langname);

				$template->assign_block_vars('translate', array(
					'S_ISO'			=> $iso,
					'S_LANG'		=> $langname[0] . (file_exists($flags_path . $iso . '.png') ? ' <img src="' . $flags_path . $iso . '.png" alt="" />' : ''),
					'S_LANG_EN'		=> (!empty($langname[1]) ? $langname[1] : ''),
					'S_SELECTED'	=> in_array($iso, $langs) ? true : false,
				));
			}
		}

		$template->assign_var('S_GOOGLE_LOGO', $this->master->root_path . 'images/mini-google.png');

		return true;
	}

	function get_config()
	{
		$this->tpl_name = 'acp_google_translate_block';
		return true;
	}
}
?>
