<?php
/*
*
* @name latest_bots_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: latest_bots_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class latest_bots_block extends blockgets_block
{
	function init()
	{
		global $template, $db, $user;

		$this->tpl_name = 'latest_bots_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$sql = 'SELECT username, user_colour, user_lastvisit
			FROM ' . USERS_TABLE . '
			WHERE user_type = ' . USER_IGNORE . '
			AND user_id <> ' . ANONYMOUS . '
			AND user_lastvisit > 0
			ORDER BY user_lastvisit DESC';
		$result = $db->sql_query_limit($sql, $data['max_bots']);

		while($row = $db->sql_fetchrow($result))
		{
			$template->assign_block_vars('bots', array(
				'BOT_NAME'		=> get_username_string('no_profile', 0, $row['username'], $row['user_colour']),
				'BOT_VISIT'		=> $user->format_date($row['user_lastvisit']),
			));
		}
		$db->sql_freeresult($result);

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'max_bots'		=> array('lang' => 'BOTS_NUMBER',	'validate' => 'int:1',	'type' => 'text:4:3',	'default' => 5),
		);

		return true;
	}
}

?>
