<?php
/*
*
* @name latest_members_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: latest_members_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class latest_members_block extends blockgets_block
{
	function init()
	{
		global $template, $db, $user;

		$this->tpl_name = 'latest_members_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$sql = 'SELECT user_id, username, user_regdate, user_colour
			FROM ' . USERS_TABLE . '
			WHERE ' . $db->sql_in_set('user_type', array(USER_IGNORE, USER_INACTIVE), true) . '
			ORDER BY user_regdate DESC';
	
		$result = $db->sql_query_limit($sql, $data['max_users']);

		//Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('member');

		while($row = $db->sql_fetchrow($result))
		{
			$template->assign_block_vars('member', array(
				'S_USER_FULL'	=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
				'JOINED'		=> format_short_date($row['user_regdate']),
			));
		}
		$db->sql_freeresult($result);

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'max_users'		=> array('lang' => 'MEMBERS_NUMBER',	'validate' => 'int:1',	'type' => 'text:4:3',	'default' => 10),
		);

		return true;
	}
}

?>
