<?php
/*
*
* @name latest_unread_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: latest_unread_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class latest_unread_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $template, $db, $user, $auth, $phpEx;

		$this->tpl_name = 'latest_unread_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$topics = array_keys(get_unread_topics(false, '', '', (int)$data['topic_limit']));

		if(!empty($topics))
		{
			$sql = 'SELECT forum_id, topic_id, topic_title, topic_time, topic_poster,
				topic_first_poster_name, topic_first_poster_colour, topic_last_post_id
				FROM ' . TOPICS_TABLE . '
				WHERE ' . $db->sql_in_set('topic_id', $topics);
			$result = $db->sql_query($sql);

			// Delete the array in the template if exists, prevent errors between blocks
			$template->destroy_block_vars('topic_row');

			while($row = $db->sql_fetchrow($result))
			{
				if(!$auth->acl_get('f_read', $row['forum_id']))
				{
					continue;
				}

				$u_viewtopic = $phpbb_root_path . "viewtopic.$phpEx?f=" . $row['forum_id'];
				
				if(!$row['forum_id'])
				{
					$u_viewtopic .= 't=' . $row['topic_id'];
				}

				$template->assign_block_vars('topic_row', array(
					'S_TITLE'			=> $row['topic_title'],
					'S_AUTHOR_FULL'		=> get_username_string('full', $row['topic_poster'], $row['topic_first_poster_name'], $row['topic_first_poster_colour']),
					'S_DATE'			=> $user->format_date($row['topic_time']),

					'U_VIEWTOPIC'		=> append_sid($u_viewtopic . '&amp;p=' . $row['topic_last_post_id'] . '#p' . $row['topic_last_post_id']),
				));
			}
			$db->sql_freeresult($result);
		}

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'topic_limit'	=> array('lang' => 'LU_LIMIT',	'validate' => 'int',	'type' => 'text:4:3',	'default' => 10),
		);

		return true;
	}
}

?>
