<?php
/*
*
* @name leaders_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: leaders_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class leaders_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $template, $db, $auth, $user, $phpEx;

		$this->tpl_name = 'leaders_block';

		$user_ary = $auth->acl_get_list(false, array('a_', 'm_'), false);

		$admin_id_ary = $mod_id_ary = array();
		foreach($user_ary as $forum_id => $forum_ary)
		{
			foreach($forum_ary as $auth_option => $id_ary)
			{
				if ($auth_option == 'a_')
				{
					$admin_id_ary = array_merge($admin_id_ary, $id_ary);
				}
				else
				{
					$mod_id_ary = array_merge($mod_id_ary, $id_ary);
				}
			}
		}
		unset($user_ary);

		$admin_id_ary	= array_unique($admin_id_ary);
		$mod_id_ary		= array_unique($mod_id_ary);

		// Admin group id...
		$sql = 'SELECT group_id
			FROM ' . GROUPS_TABLE . "
			WHERE group_name = 'ADMINISTRATORS'";
		$result = $db->sql_query($sql);
		$admin_group_id = (int) $db->sql_fetchfield('group_id');
		$db->sql_freeresult($result);

		$sql = $db->sql_build_query('SELECT', array(
			'SELECT'	=> 'u.user_id, u.group_id as default_group, u.username, u.username_clean, g.group_id, g.group_name, g.group_colour, g.group_type, ug.user_id as ug_user_id',

			'FROM'		=> array(
				USERS_TABLE		=> 'u',
				GROUPS_TABLE	=> 'g'
			),

			'LEFT_JOIN'	=> array(
				array(
					'FROM'	=> array(USER_GROUP_TABLE => 'ug'),
					'ON'	=> 'ug.group_id = g.group_id AND ug.user_pending = 0 AND ug.user_id = ' . $user->data['user_id']
				)
			),

			'WHERE'		=> $db->sql_in_set('u.user_id', array_unique(array_merge($admin_id_ary, $mod_id_ary)), false, true) . '
				AND u.group_id = g.group_id',

			'ORDER_BY'	=> 'g.group_name ASC, u.username_clean ASC'
		));
		$result = $db->sql_query($sql);

		while($row = $db->sql_fetchrow($result))
		{
			$which_row = (in_array($row['user_id'], $admin_id_ary)) ? 'admin' : 'mod';

			// We sort out admins not within the 'Administrators' group.
			// Else, we will list those as admin only having the permission to view logs for example.
			if($which_row == 'admin' && $row['default_group'] != $admin_group_id)
			{
				// Remove from admin_id_ary, because the user may be a mod instead
				unset($admin_id_ary[array_search($row['user_id'], $admin_id_ary)]);

				if(!in_array($row['user_id'], $mod_id_ary))
				{
					continue;
				}

				$which_row = 'mod';
			}

			// The person is moderating several "public" forums, therefore the person should be listed, but not giving the real group name if hidden.
			if ($row['group_type'] == GROUP_HIDDEN && !$auth->acl_gets('a_group', 'a_groupadd', 'a_groupdel') && $row['ug_user_id'] != $user->data['user_id'])
			{
				$group_name = $user->lang['GROUP_UNDISCLOSED'];
				$u_group = '';
			}
			else
			{
				$group_name = ($row['group_type'] == GROUP_SPECIAL) ? $user->lang['G_' . $row['group_name']] : $row['group_name'];
				$u_group = append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=group&amp;g=' . $row['group_id']);
			}

			if (!$auth->acl_gets('u_viewprofile', 'a_user', 'a_useradd', 'a_userdel'))
			{
				$u_user = $row['username'];
			}
			else
			{
				$u_user = '<a href="' . get_username_string('profile', $row['user_id'], $row['username']) . '">' . $row['username'] . '</a>';
			}

			$template->assign_block_vars($which_row . '_row', array(
				'GROUP_NAME'		=> $group_name,
				'GROUP_COLOR'		=> $row['group_colour'],
				'U_GROUP'			=> $u_group,

				'USERNAME_FULL'		=> $u_user,
			));
		}
		$db->sql_freeresult($result);

		return true;
	}

	function configure()
	{
	}

	function get_config()
	{
		return false;
	}
}

?>
