<?php
/*
*
* @name link_us_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: link_us_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class link_us_block extends blockgets_block
{
	function init()
	{
		global $template, $config, $user;

		$this->tpl_name = 'link_us_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$path = $this->master->get_board_path();

		if($data['banner_url'])
		{
			build_img_path($data['banner_url'], $path['board_url'] . $this->master->path . 'images/banners/', false);
			$link_text = '<img src="' . $data['banner_url'] . '" style="border:0;" alt="' . $config['sitename'] . '" />';
		}
		else
		{
			$link_text = $config['sitename'];
		}

		$link_text = '<a href="' . $path['page_url'] . '" onclick="window.open(this.href); return false;" title="' . $config['sitename'] . ' :: ' . $config['site_desc'] . '">' . $link_text . '</a>';

		$template->assign_vars(array(
			'LINK_US_TXT'		=> $user->lang('LINK_US_TXT', $config['sitename']),
			'U_LINK_US'			=> htmlentities($link_text, ENT_QUOTES, 'UTF-8'),
			'U_LINK_US_BANNER'  => $link_text,
		));

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'banner_url'	=> array('lang' => 'US_BANNER',	'validate' => 'string',	'type' => 'text:50:255',	'default' => 'canidev-banner.png'),
		);

		return true;
	}
}
?>
