<?php
/*
*
* @name login_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: login_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class login_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $template, $config, $user, $phpEx;

		$this->tpl_name = 'login_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$rank_title = $rank_image = $rank_image_src = '';
		get_user_rank($user->data['user_rank'], $user->data['user_posts'], $rank_title, $rank_image, $rank_image_src);

		$s_hidden_fields = array(
			'sid'		=> $user->session_id,
			'redirect'	=> $this->master->get_board_path('page'),
		);
		
		$s_last_visit	= ($user->data['user_id'] != ANONYMOUS) ? $user->format_date($user->data['session_last_visit']) : '';
		$break			= ($this->config['autofit']) ? '<br />' : '';

		$template->assign_vars(array(
			'U_SEND_PASSWORD' 		=> ($config['email_enable']) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'mode=sendpassword') : '',
			'U_RESEND_ACTIVATION'	=> ($config['require_activation'] == USER_ACTIVATION_SELF && $config['email_enable']) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'mode=resend_act') : '',
			'U_TERMS_USE'			=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'mode=terms'),
			'U_PRIVACY'				=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'mode=privacy'),

			'S_DISPLAY_FULL_LOGIN'	=> $data['full_login'],
			'S_DISPLAY_REGISTER'	=> $data['show_register'],
			'S_LAST_VISIT'			=> $user->lang('YOU_LAST_VISIT', $break . $s_last_visit),
			'S_CURRENT_TIME'		=> $user->lang('CURRENT_TIME', $break . $user->format_date(time(), false, true)),
		
			'S_LOGIN_HIDDEN_FIELDS'	=> build_hidden_fields($s_hidden_fields),
			'S_LOGIN_ACTION'		=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'mode=login'),
			
			'S_SHORT_MODE'			=> $this->config['autofit'],

			'USER_AVATAR'			=> get_user_avatar($user->data['user_avatar'], $user->data['user_avatar_type'], $user->data['user_avatar_width'], $user->data['user_avatar_height']),
			'USERNAME_FULL'     	=> get_username_string('full', $user->data['user_id'], $user->data['username'], $user->data['user_colour']),
			'USER_RANK_TITLE'		=> $rank_title,
			'USER_RANK_IMG'			=> $rank_image,

			'U_BOOKMARKS'           => append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=main&amp;mode=bookmarks'),
			'U_SUBSCRIBED'          => append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=main&amp;mode=subscribed'),
		));

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'full_login'	=> array('lang' => 'FULL_LOGIN',	'validate' => 'bool',	'type' => 'radio:yes_no',	'default' => 1),
			'show_register'	=> array('lang' => 'SHOW_REGISTER',	'validate' => 'bool',	'type' => 'radio:yes_no',	'default' => 1),
		);

		return true;
	}
}
?>
