<?php
/*
*
* @name menu_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: menu_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class menu_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $db, $template, $user;

		$this->tpl_name = 'menu_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		// Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('menu_row');

		// Get de menu links
		$sql = 'SELECT *
			FROM ' . BLG_LISTS_DATA_TABLE . '
			WHERE list_id = ' . $data['menu_id'] . '
			ORDER BY link_order ASC';
		$result = $db->sql_query($sql);

		while($row = $db->sql_fetchrow($result))
		{
			if(!blg_group_auth($row['link_groups']))
			{
				continue;
			}

			build_img_path($row['link_img_url'], $this->master->path . 'images/icons/');

			// If is internal link, append root path and user sid
			if(strpos($row['link_url'], 'http') !== 0)
			{
				$row['link_url'] = append_sid($phpbb_root_path . $row['link_url'], false, true, $user->session_id);
			}

			$template->assign_block_vars('menu_row', array(
				'IS_CAT'		=> ($row['link_type'] == LIST_CAT) ? true : false,

				'S_TITLE'		=> (isset($user->lang[$row['link_title']]) ? $user->lang[$row['link_title']] : $row['link_title']),
				'S_ICON'		=> '<img src="' . $row['link_img_url'] . '" width="' . $row['link_img_width'] . '" height="' . $row['link_img_height'] . '" alt="" />',
				'S_WINDOW'		=> $row['link_window'],
				'U_LINK'		=> $row['link_url'],
			));
		}
		$db->sql_freeresult($result);

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'menu_id'	=> array('lang' => 'DISPLAY_MENU',	'validate' => 'int',	'type' => 'custom',	'function' => 'blg_lists_select',	'params' => array('{KEY}', 'menu', '{CONFIG_VALUE}')),
		);

		return true;
	}
}
?>
