<?php
/*
*
* @name most_poster_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: most_poster_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class most_poster_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $template, $db, $user, $phpEx;

		$this->tpl_name = 'most_poster_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		//Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('most_poster');

		if($data['poster_range'] == 'none')
		{
			$sql = 'SELECT *
				FROM ' . USERS_TABLE . '
				WHERE user_type <> ' . USER_IGNORE . '
				AND user_posts <> 0
				ORDER BY user_posts DESC';
		}
		else
		{
			$stamp = strtotime('-1 ' . $data['poster_range'], $user->time_now);

			$sql = 'SELECT COUNT(p.post_id) AS post_count, u.*
				FROM ' . POSTS_TABLE . ' p
				LEFT JOIN ' . USERS_TABLE . ' u ON(u.user_id = p.poster_id)
				WHERE p.post_approved = 1
				AND p.poster_id <> ' . ANONYMOUS . "
				AND p.post_time >= $stamp
				GROUP BY p.poster_id
				ORDER BY post_count DESC";
		}

		$result = $db->sql_query_limit($sql, (int)$data['poster_limit']);

		while($row = $db->sql_fetchrow($result))
		{
			// Do the relevant calculations
			$memberdays = max(1, round((time() - $row['user_regdate']) / 86400));
			$posts_per_day = $row['user_posts'] / $memberdays;

			$template->assign_block_vars('most_poster', array(
				'USERNAME'		=> get_username_string('no_profile', $row['user_id'], $row['username'], $row['user_colour']),
				'USER_FULL'		=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
				'AVATAR'		=> get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']),
				'POSTS'			=> $user->lang('MEMBER_POSTS', $row['user_posts'], $posts_per_day),
				'REGDATE'		=> format_short_date($row['user_regdate']),

				'U_FIND_POSTS'	=> append_sid("{$phpbb_root_path}search.$phpEx", 'author_id=' . $row['user_id'] . '&amp;sr=posts'),
				'U_WWW'   		=> $row['user_website'],
			));
		}
		$db->sql_freeresult($result);

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$options = array(
			'none'	=> 'ALL_POSTS',
			'day'	=> 'LAST_DAY',
			'week' 	=> 'LAST_WEEK',
			'month'	=> 'LAST_MONTH',
			'year'	=> 'LAST_YEAR',
		);

		$this->display_vars = array(
			'poster_limit'		=> array('lang' => 'POSTER_LIMIT',	'validate' => 'int:1:20',	'type' => 'text:4:3',	'default' => 5),
			'poster_range'		=> array('lang' => 'POST_RANGE',	'validate' => 'string',		'type' => 'select',	'function' => 'blg_make_select',	'params' =>	array($options, '{CONFIG_VALUE}'),	'default' => 'none'),
		);

		return true;
	}
}
?>
