<?php
/*
*
* @name online_friends_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: online_friends_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class online_friends_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $db, $config, $user, $template;

		$this->tpl_name = 'online_friends_block';

		//Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('friends_online');
		$template->destroy_block_vars('friends_offline');

		$users = array();

		$time = (time() - (intval($config['load_online_time']) * 60));

		$sql = 'SELECT u.user_id, u.username, u.username_clean, u.user_colour, s.session_time, s.session_viewonline
			FROM ' . ZEBRA_TABLE . ' z
			LEFT JOIN ' . USERS_TABLE . ' u ON (u.user_id = z.zebra_id)
			LEFT JOIN ' . SESSIONS_TABLE . ' s ON (s.session_user_id = z.zebra_id)
			WHERE z.user_id = ' . $user->data['user_id'] . '
			AND z.friend = 1';
		$result = $db->sql_query($sql);
		while($row = $db->sql_fetchrow($result))
		{
			$users[$row['username_clean']] = $row;
		}
		$db->sql_freeresult($result);

		if(empty($users))
		{
			$template->assign_var('S_ZEBRA', false);
			return true;
		}

		ksort($users);

		foreach($users as $clean => $row)
		{
			$switch = ($row['session_time'] >= ($time - ((int) ($time % 30))) && $row['session_viewonline']) ? 'online' : 'offline';

			$template->assign_block_vars("friends_$switch", array(
				'USERNAME_FULL'	=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour'])
			));
		}

		$template->assign_var('S_ZEBRA', true);

		return true;
	}

	function configure()
	{
	}

	function get_config()
	{
		return false;
	}
}

?>
