<?php
/*
*
* @name paypal_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: paypal_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class paypal_block extends blockgets_block
{
	function init()
	{
		global $template, $user;

		$this->tpl_name = 'paypal_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$default_img = 'https://www.paypal.com/' . $this->master->locale_lang() . '/i/btn/btn_donate_LG.gif';
		
		$amount_options = '';
		if(!empty($data['amounts']))
		{
			$amounts = explode(';', $data['amounts']);
			
			foreach($amounts as $amount)
			{
				$amount_options .= sprintf('<option value="%1$.2f">%1$.2f</option>', $amount);
			}
		}
		
		$template->assign_vars(array(
			'S_PAYPAL_ITEM'		=> $data['item'],
			'S_PAYPAL_ACCOUNT'	=> $data['account'],
			'S_PAYPAL_MSG'		=> $this->generate_text_display($data['msg']),
			'S_PAYPAL_IMG'		=> (!empty($data['button_img']) ? $data['button_img'] : $default_img),
			'S_PAYPAL_AMOUNTS'	=> $amount_options,
		));
		
		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		global $config, $user;

		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);

				$bbcode = $this->bbcode('get');
				decode_message($new['msg'], $bbcode['uid']);
			break;

			case 'submit':
				$user->add_lang('posting');

				generate_text_for_storage($new['msg'], $uid, $bitfield, $flags, $config['allow_bbcode'], true, $config['allow_smilies']);
				$this->bbcode('set', $uid, $bitfield);

				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'item'			=> array('lang' => 'PAYPAL_ITEM',		'validate' => 'string:5:100',	'type' => 'text:40:100',	'default' => 'paypal'),
			'account'		=> array('lang' => 'PAYPAL_ACCOUNT',	'validate' => 'string:6:100',	'type' => 'text:30:100',	'default' => 'account@paypal.com'),
			'msg'			=> array('lang' => 'PAYPAL_MSG',		'type' => 'custom',	'function' => 'blg_build_editor',	'params' => array('{CONFIG_VALUE}', 'acp_block_form', '{KEY}', 10, 5)),
			'button_img'	=> array('lang' => 'PAYPAL_IMG',		'validate' => 'string:0:255',	'type' => 'text:50:255',	'default' => ''),
			'amounts'		=> array('lang' => 'PAYPAL_AMOUNTS',	'validate' => 'string:0:255',	'type' => 'text:50:255',	'default' => '5;10;15;20;25;30;40;50;75;100;200;300;400;500;750;1000'),
		);

		return true;
	}
}
?>
