<?php
/*
*
* @name player_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: player_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class player_block extends blockgets_block
{
	function init()
	{
		global $template, $db, $phpEx;

		$this->tpl_name = 'player_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}
		
		if(!function_exists('create_player'))
		{
			include($this->master->root_path . "player.$phpEx");	
		}
		
		create_player($data, $this->config['block_id'], false);

		unset($data);
		return true;
	}
	
	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['tracks'] = utf8_normalize_nfc(request_var('track', array('' => ''), true));

				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$dialog_items = array(
			array('TRACK_TITLE'),
			array('TRACK_URL', array('/^http[s]?:\/\/[^:]+:([0-9]{1,4})$/', '/^http[s]?:\/\/(.*)\.(asx|m3u|mp3|pls|wav)$/'))
		);

		$this->display_vars = array(
			'autoplay'			=> array('lang' => 'PLAYER_AUTOPLAY',	'validate' => 'bool',		'type' => 'radio:yes_no',	'default' => 1),
			'playlist'			=> array('lang' => 'PLAYER_PLAYLIST',	'validate' => 'bool',		'type' => 'radio:yes_no',	'default' => 1),
			'tracks'			=> array('lang' => 'PLAYER_TRACKLIST',	'type' => 'custom', 		'function' => 'blg_build_list',	'params' => array('tracklist', 'track', '{CONFIG_VALUE}', $dialog_items)),
		);

		return true;
	}
}

?>
