<?php
/*
*
* @name poll_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: poll_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class poll_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $db, $template, $config, $user, $auth, $phpEx;

		$this->tpl_name = 'poll_pollrandom_block';

		$user->add_lang('viewtopic');

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		// Initial var setup
		$topic_id	= $data['topic_id'];
		$voted_id	= request_var('poll_vote_id', array('' => 0));
		$view		= request_var('view', '');
		$update		= request_var('update_vote', false);
		$request_id = request_var('request_id', 0);

		// Do we have a topic id?
		if(!$topic_id)
		{
			return false;
		}

		// Check if the request if the same of block id (prevent interaction between block)
		if($update && $request_id != $this->config['block_id'])
		{
			$update = false;
		}

		$sql = 'SELECT t.*, f.forum_password, f.forum_status
			FROM ' . TOPICS_TABLE . ' t
			LEFT JOIN ' . FORUMS_TABLE . " f ON(f.forum_id = t.forum_id)
			WHERE t.topic_id = $topic_id
			AND topic_approved = 1 AND poll_start > 0";

		$result = $db->sql_query($sql);
		$topic_data = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		if(!$topic_data)
		{
			return true;
		}

		$forum_id = (int) $topic_data['forum_id'];

		// Start auth and password check
		if (!$auth->acl_get('f_read', $forum_id) || $topic_data['forum_password'])
		{
			return true;
		}

		// General Viewtopic URL for return links
		$viewtopic_url = append_sid("{$phpbb_root_path}viewtopic.$phpEx?f=$forum_id&amp;t=$topic_id");

		$sql = 'SELECT o.*, p.bbcode_bitfield, p.bbcode_uid
			FROM ' . POLL_OPTIONS_TABLE . ' o, ' . POSTS_TABLE . " p
			WHERE o.topic_id = $topic_id
				AND p.post_id = {$topic_data['topic_first_post_id']}
				AND p.topic_id = o.topic_id
			ORDER BY o.poll_option_id";
		$result = $db->sql_query($sql);

		$poll_info = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$poll_info[] = $row;
		}
		$db->sql_freeresult($result);

		$cur_voted_id = array();
		if ($user->data['is_registered'])
		{
			$sql = 'SELECT poll_option_id
				FROM ' . POLL_VOTES_TABLE . '
				WHERE topic_id = ' . $topic_id . '
					AND vote_user_id = ' . $user->data['user_id'];
			$result = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result))
			{
				$cur_voted_id[] = $row['poll_option_id'];
			}
			$db->sql_freeresult($result);
		}
		else
		{
			// Cookie based guest tracking ... I don't like this but hum ho
			// it's oft requested. This relies on "nice" users who don't feel
			// the need to delete cookies to mess with results.
			if (isset($_COOKIE[$config['cookie_name'] . '_poll_' . $topic_id]))
			{
				$cur_voted_id = explode(',', $_COOKIE[$config['cookie_name'] . '_poll_' . $topic_id]);
				$cur_voted_id = array_map('intval', $cur_voted_id);
			}
		}

		$s_can_vote = (((!sizeof($cur_voted_id) && $auth->acl_get('f_vote', $forum_id)) ||
			($auth->acl_get('f_votechg', $forum_id) && $topic_data['poll_vote_change'])) &&
			(($topic_data['poll_length'] != 0 && $topic_data['poll_start'] + $topic_data['poll_length'] > time()) || $topic_data['poll_length'] == 0) &&
			$topic_data['topic_status'] != ITEM_LOCKED &&
			$topic_data['forum_status'] != ITEM_LOCKED) ? true : false;
		$s_display_results = (!$s_can_vote || ($s_can_vote && sizeof($cur_voted_id)) || $view == 'viewpoll') ? true : false;


		if($update && $s_can_vote)
		{
			$redirect_url = request_var('redirect', $viewtopic_url);

			if (!sizeof($voted_id) || sizeof($voted_id) > $topic_data['poll_max_options'])
			{
				meta_refresh(5, $redirect_url);

				$message = (!sizeof($voted_id)) ? 'NO_VOTE_OPTION' : 'TOO_MANY_VOTE_OPTIONS';
				$message = $user->lang[$message] . '<br /><br />' . sprintf($user->lang['RETURN_PAGE'], '<a href="' . $redirect_url . '">', '</a>');

				trigger_error($message);
			}

			foreach($voted_id as $option)
			{
				if (in_array($option, $cur_voted_id))
				{
					continue;
				}

				$sql = 'UPDATE ' . POLL_OPTIONS_TABLE . '
					SET poll_option_total = poll_option_total + 1
					WHERE poll_option_id = ' . (int) $option . '
						AND topic_id = ' . (int) $topic_id;
				$db->sql_query($sql);

				if ($user->data['is_registered'])
				{
					$sql_ary = array(
						'topic_id'			=> (int) $topic_id,
						'poll_option_id'	=> (int) $option,
						'vote_user_id'		=> (int) $user->data['user_id'],
						'vote_user_ip'		=> (string) $user->ip,
					);

					$sql = 'INSERT INTO  ' . POLL_VOTES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
					$db->sql_query($sql);
				}
			}

			foreach ($cur_voted_id as $option)
			{
				if (!in_array($option, $voted_id))
				{
					$sql = 'UPDATE ' . POLL_OPTIONS_TABLE . '
						SET poll_option_total = poll_option_total - 1
						WHERE poll_option_id = ' . (int) $option . '
							AND topic_id = ' . (int) $topic_id;
					$db->sql_query($sql);

					if ($user->data['is_registered'])
					{
						$sql = 'DELETE FROM ' . POLL_VOTES_TABLE . '
							WHERE topic_id = ' . (int) $topic_id . '
								AND poll_option_id = ' . (int) $option . '
								AND vote_user_id = ' . (int) $user->data['user_id'];
						$db->sql_query($sql);
					}
				}
			}

			if ($user->data['user_id'] == ANONYMOUS && !$user->data['is_bot'])
			{
				$user->set_cookie('poll_' . $topic_id, implode(',', $voted_id), time() + 31536000);
			}

			$sql = 'UPDATE ' . TOPICS_TABLE . '
				SET poll_last_vote = ' . time() . "
				WHERE topic_id = $topic_id";
			$db->sql_query($sql);

			meta_refresh(5, $redirect_url);
			trigger_error($user->lang['VOTE_SUBMITTED'] . '<br /><br />' . sprintf($user->lang['RETURN_PAGE'], '<a href="' . $redirect_url . '">', '</a>'));
		}

		$poll_total = 0;
		$poll_bbcode = false;

		foreach ($poll_info as $poll_option)
		{
			$poll_total += $poll_option['poll_option_total'];
		}

		if ($poll_info[0]['bbcode_bitfield'])
		{
			$poll_bbcode = new bbcode();
		}

		for ($i = 0, $size = sizeof($poll_info); $i < $size; $i++)
		{
			$poll_info[$i]['poll_option_text'] = censor_text($poll_info[$i]['poll_option_text']);
			$poll_info[$i]['poll_option_text'] = str_replace("\n", '<br />', $poll_info[$i]['poll_option_text']);

			if ($poll_bbcode !== false)
			{
				$poll_bbcode->bbcode_second_pass($poll_info[$i]['poll_option_text'], $poll_info[$i]['bbcode_uid'], $poll_option['bbcode_bitfield']);
			}

			$poll_info[$i]['poll_option_text'] = smiley_text($poll_info[$i]['poll_option_text']);
		}

		$topic_data['poll_title'] = censor_text($topic_data['poll_title']);
		$topic_data['poll_title'] = str_replace("\n", '<br />', $topic_data['poll_title']);

		if ($poll_bbcode !== false)
		{
			$poll_bbcode->bbcode_second_pass($topic_data['poll_title'], $poll_info[0]['bbcode_uid'], $poll_info[0]['bbcode_bitfield']);
		}
		$topic_data['poll_title'] = smiley_text($topic_data['poll_title']);

		unset($poll_bbcode);

		$vote_url = $this->master->get_board_path('page');

		$poll_end = $topic_data['poll_length'] + $topic_data['poll_start'];

		//Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('poll');

		$template->assign_block_vars('poll', array(
			'S_POLL_QUESTION'		=> $topic_data['poll_title'],
			'S_TOTAL_VOTES' 		=> $poll_total,
			'S_POLL_LEFT_CAP_IMG'	=> $user->img('poll_left'),
			'S_POLL_RIGHT_CAP_IMG'	=> $user->img('poll_right'),
			'S_MAX_VOTES'			=> ($topic_data['poll_max_options'] == 1) ? $user->lang['MAX_OPTION_SELECT'] : sprintf($user->lang['MAX_OPTIONS_SELECT'], $topic_data['poll_max_options']),
			'S_POLL_LENGTH'			=> ($topic_data['poll_length']) ? sprintf($user->lang[($poll_end > time()) ? 'POLL_RUN_TILL' : 'POLL_ENDED_AT'], $user->format_date($poll_end)) : '',
			'S_CAN_VOTE'			=> $s_can_vote,
			'S_DISPLAY_RESULTS'		=> $s_display_results,
			'S_IS_MULTI_CHOICE'		=> ($topic_data['poll_max_options'] > 1) ? true : false,
			'U_POLL_ACTION'			=> $vote_url,
			'U_POLL_RESULTS'		=> $viewtopic_url,

			'S_HIDDEN_FIELDS'		=> build_hidden_fields(array(
				'request_id'	=> $this->config['block_id'],
				'redirect'		=> $vote_url,
			)),
		));

		foreach ($poll_info as $poll_option)
		{
			$option_pct = ($poll_total > 0) ? $poll_option['poll_option_total'] / $poll_total : 0;
			$option_pct_txt = sprintf("%.1d%%", ($option_pct * 100));

			$template->assign_block_vars('poll.poll_option', array(
				'POLL_OPTION_ID' 		=> $poll_option['poll_option_id'],
				'POLL_OPTION_CAPTION' 	=> $poll_option['poll_option_text'],
				'POLL_OPTION_RESULT' 	=> $poll_option['poll_option_total'],
				'POLL_OPTION_PERCENT' 	=> $option_pct_txt,
				'POLL_OPTION_PCT'		=> round($option_pct * 100),
				'POLL_OPTION_IMG' 		=> $user->img('poll_center', $option_pct_txt, sprintf("%.1d%%", ($option_pct * 80))),
				'POLL_OPTION_VOTED'		=> (in_array($poll_option['poll_option_id'], $cur_voted_id)) ? true : false)
			);
		}

		unset($poll_end, $poll_info, $voted_id);

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		global $db;

		$sql = 'SELECT topic_id, topic_title
			FROM ' . TOPICS_TABLE . '
			WHERE topic_approved > 0 AND poll_start > 0';
		$result = $db->sql_query($sql);

		$options = array();
		while($row = $db->sql_fetchrow($result))
		{
			$options[$row['topic_id']] = truncate_string($row['topic_title'], 80, 255, false, '...');
		}
		$db->sql_freeresult($result);
	
		$this->display_vars = array(
			'topic_id'		=> array('lang' => 'DISPLAY_POLL',	'validate' => 'int',	'type' => 'select',	'function' => 'blg_make_select',	'params' => array($options, '{CONFIG_VALUE}', false, 'NO_POLLS')),
		);

		return true;
	}
}
?>
