<?php
/*
*
* @name quote_of_day_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: quote_of_day_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class quote_of_day_block extends blockgets_block
{
	function init()
	{
		global $template, $db, $user, $phpEx;

		$this->tpl_name = 'quote_of_day_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}
		
		if(empty($data['quotes']))
		{
			return false;
		}
		
		$last_id = $new_id = (isset($data['last_id']) ? $data['last_id'] : -1);
		
		if($data['all_day'])
		{
			if(!isset($data['last_time']))
			{
				$data['last_time'] = time();
				$new_id = 0;
			}
			else
			{
				$now	= getdate(time() + $user->timezone + $user->dst - date('Z'));
				$date	= getdate($data['last_time'] + $user->timezone + $user->dst - date('Z'));
				
				if($date['mday'] != $now['mday'] || $date['mon'] != $now['mon'] || $date['year'] != $now['year'])
				{
					$data['last_time'] = time();
					$new_id++;
				}
			}
			
			$quote = $this->find_quote($data, $new_id);
		}
		else
		{
			$data['last_time'] = time();
			$new_id++;

			$quote = $this->find_quote($data, $new_id);
		}
		
		// Update the last id and last time if neccessary
		if($new_id != $last_id)
		{
			$data['last_id'] = $new_id;
			
			$this->display_vars = $data;

			$sql = 'UPDATE ' . BLG_BLOCK_TABLE . "
				SET block_content = '" . $this->serialize($data) . "'
				WHERE block_id = " . $this->config['block_id'];
			$db->sql_query($sql);
		}
		
		list($text, $author) = blg_explode_list($quote, 2);
		
		$template->assign_vars(array(
			'S_QUOTE_TEXT'		=> $text,
			'S_QUOTE_AUTHOR'	=> ($data['show_author']) ? $author : '',
		));

		unset($data);
		return true;
	}
	
	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['quotes'] = utf8_normalize_nfc(request_var('quote', array('' => ''), true));
				$add = array();
				
				if(isset($block_row['last_time']))
				{
					$add['last_time'] = $block_row['last_time'];
				}
				
				if(isset($block_row['last_id']))
				{
					$add['last_id'] = $block_row['last_id'];
				}

				$new['block_content'] = $this->serialize($new, $add);
			break;
		}
	}

	function get_config()
	{
		$dialog_items = array(
			array('QUOTE_TEXT', array('/.+/')),
			array('QUOTE_AUTHOR')
		);

		$this->display_vars = array(
			'all_day'			=> array('lang' => 'QUOTES_ALL_DAY',		'validate' => 'bool',	'type' => 'radio:yes_no', 'default' => 1),
			'rand'				=> array('lang' => 'QUOTES_RAND',			'validate' => 'bool',	'type' => 'radio:yes_no', 'default' => 0),
			'show_author'		=> array('lang' => 'QUOTES_SHOW_AUTHOR',	'validate' => 'bool',	'type' => 'radio:yes_no', 'default' => 1),
			'quotes'			=> array('lang' => 'QUOTES_LIST',			'type' => 'custom', 	'function' => 'blg_build_list',	'params' => array('quotelist', 'quote', '{CONFIG_VALUE}', $dialog_items)),
		);

		return true;
	}
	
	function find_quote($data, &$new_id)
	{
		if($data['rand'])
		{
			$new_id = array_rand($data['quotes'], 1);
		}
		
		if(!isset($data['quotes'][$new_id]))
		{
			$new_id = 0;
		}
		
		return $data['quotes'][$new_id];
	}
}

?>
