<?php
/*
*
* @name random_member_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: random_member_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class random_member_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $template, $db, $user, $phpEx;

		$this->tpl_name = 'random_member_block';

		$sql = 'SELECT *
			FROM ' . USERS_TABLE . '
			WHERE ' . $db->sql_in_set('user_type', array(USER_IGNORE, USER_INACTIVE), true) . '
			ORDER BY RAND()';
		$result = $db->sql_query_limit($sql, 1);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		// Do the relevant calculations
		$memberdays = max(1, round((time() - $row['user_regdate']) / 86400));
		$posts_per_day = $row['user_posts'] / $memberdays;

		//Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('random_member');

		$template->assign_block_vars('random_member', array(
			'USERNAME'		=> get_username_string('no_profile', $row['user_id'], $row['username'], $row['user_colour']),
			'USER_FULL'		=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
			'AVATAR'		=> get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']),
			'POSTS'			=> ($row['user_posts']) ? sprintf($user->lang['MEMBER_POSTS'], $row['user_posts'], $posts_per_day) : '0',
			'REGDATE'		=> format_short_date($row['user_regdate']),

			'U_FIND_POSTS'	=> append_sid("{$phpbb_root_path}search.$phpEx", 'author_id=' . $row['user_id'] . '&amp;sr=posts'),
			'U_WWW'   		=> $row['user_website'],
		));

		return true;
	}

	function configure()
	{
	}

	function get_config()
	{
		return false;
	}
}

?>
