<?php
/*
*
* @name ranks_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: ranks_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class ranks_block extends blockgets_block
{
	function init()
	{
		global $phpbb_root_path, $db, $config, $template;

		$this->tpl_name = 'ranks_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$sql = 'SELECT r.*
			FROM ' . RANKS_TABLE . ' r';

		if(!$data['show_orphan'])
		{
			$sql .= ' LEFT JOIN ' . USERS_TABLE . ' u ON(u.user_rank = r.rank_id)
				WHERE u.user_id IS NOT NULL';
		}

		if($data['only_special'])
		{
			$sql .= (($data['show_orphan']) ? ' WHERE' : ' AND') . ' r.rank_special = 1';
		}

		$sql .= ' ORDER BY r.rank_special DESC, r.rank_title ASC';

		//Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('rank');

		$result = $db->sql_query($sql);
		while($row = $db->sql_fetchrow($result))
		{
			$template->assign_block_vars('rank', array(
				'S_TITLE'		=> $row['rank_title'],
				'S_IMG_SRC'		=> ($row['rank_image']) ? $phpbb_root_path . $config['ranks_path'] . '/' . $row['rank_image'] : '',
				'S_MIN_POSTS'	=> $row['rank_min'],
				'IS_SPECIAL'	=> ($row['rank_special']) ? true : false,
			));
		}
		$db->sql_freeresult($result);

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'show_orphan'	=> array('lang' => 'ORPHAN_RANKS',			'validate' => 'bool',	'type' => 'radio:yes_no',	'default' => 1),
			'only_special'	=> array('lang' => 'ONLY_SPECIAL_RANKS',	'validate' => 'bool',	'type' => 'radio:yes_no',	'default' => 0),
		);

		return true;
	}
}

?>
