<?php
/*
*
* @name scroll_message_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: scroll_message_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class scroll_message_block extends blockgets_block
{
	function init()
	{
		global $template;

		$this->tpl_name = 'scroll_message_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		//Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('message');

		$template->assign_block_vars('message', array(
			'DIRECTION' 	=> $data['marquee_direction'],
			'SPEED' 	    => $data['marquee_speed'],
			'SCROLLDELAY' 	=> $data['marquee_scrolldelay'], 
			'ALIGN' 		=> $data['marquee_align'],        
			'BGCOLOR' 		=> $data['marquee_bgcolor'],  
			'HEIGHT' 		=> (($data['marquee_direction'] == 'left' || $data['marquee_direction'] == 'right') ? 'auto' : $data['marquee_height']),
			'PADDING'		=> $data['marquee_padding'],
			'TEXT'			=> $this->generate_text_display($data['marquee_text']),
		));

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		global $config, $user;

		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);

				$bbcode = $this->bbcode('get');
				decode_message($new['marquee_text'], $bbcode['uid']);
			break;

			case 'submit':
				$user->add_lang('posting');

				$new['marquee_text'] = html_truncate($new['marquee_text'], 1000);

				generate_text_for_storage($new['marquee_text'], $uid, $bitfield, $flags, $config['allow_bbcode'], true, $config['allow_smilies']);
				$this->bbcode('set', $uid, $bitfield);

				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'marquee_direction' 	=> array('lang' => 'MARQUEE_DIRECTION',		'validate' => 'string', 'type' => 'select', 'function' => 'make_scroll_select', 'params' => array('{CONFIG_VALUE}', 'direction'),	'default' => 'left'),
			'marquee_speed'  		=> array('lang' => 'MARQUEE_SPEED',			'validate' => 'int',  	'type' => 'text:3:2',	'default' => 2),
			'marquee_scrolldelay'  	=> array('lang' => 'MARQUEE_SCROLLDELAY',	'validate' => 'int',  	'type' => 'text:3:2',	'default' => 50),
			'marquee_align'  		=> array('lang' => 'MARQUEE_ALIGN', 		'validate' => 'string', 'type' => 'select', 'function' => 'make_scroll_select', 'params' => array('{CONFIG_VALUE}', 'align'),	'default' => 'center'),
			'marquee_bgcolor'  		=> array('lang' => 'MARQUEE_BGCOLOR',		'validate' => 'string', 'type' => 'text:12:10',	'default' => ''),
			'marquee_height'  		=> array('lang' => 'MARQUEE_HEIGHT',		'validate' => 'int', 	'type' => 'text:4:3',	'default' => 20),
			'marquee_padding'  		=> array('lang' => 'MARQUEE_PADDING',		'validate' => 'string', 'type' => 'text:25:24',	'default' => '2px'),
			'marquee_text'			=> array('lang' => 'MARQUEE_TEXT',			'type' => 'custom',	'function' => 'blg_build_editor',	'params' => array('{CONFIG_VALUE}', 'acp_block_form', '{KEY}', 15, 5)),
		);

		return true;
	}
}

?>
