<?php
/*
*
* @name style_select_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: style_select_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class style_select_block extends blockgets_block
{
	function init()
	{
		global $template, $db, $user, $config;

		$this->tpl_name = 'style_select_block';

		$sql = 'SELECT style_id, style_name
			FROM ' . STYLES_TABLE . '
			WHERE style_active = 1 
			ORDER BY style_name ASC';
		$result = $db->sql_query($sql);

		$style_select = '<option selected="selected" disabled="disabled">' . $user->lang['STYLE_SELECT'] . '</option>';
		$num_styles = 0;

		while($row = $db->sql_fetchrow($result))
		{
			$selected = ($user->theme['style_id'] == $row['style_id']) ? ' selected="selected"' : '';
			$style_select .= '<option value="' . $row['style_id'] . '"' . $selected . '>&nbsp;' . $row['style_name'] . '&nbsp;</option>';

			$num_styles++;
		}
		$db->sql_freeresult($result);

		$u_action	= $this->master->get_board_path('page');
		$style		= request_var('style', '');

		$template->assign_vars(array(
			'STYLE_SELECT' 		=> $style_select,
			'S_TOTAL_STYLES'	=> $num_styles,
			'CAN_SAVE_STYLE'	=> ($user->data['is_registered'] && !$config['override_user_style']) ? true : false,

			'U_STYLE_ACTION'	=> $u_action,
			'U_STYLE_DEFAULT'	=> (($style && $style != $user->data['user_style']) ? preg_replace(array("#style=$style(&amp;|&|$)+#", '#\?$#'), '', $u_action) : ''),
		));

		return true;
	}

	function configure()
	{
	}

	function get_config()
	{
		return false;
	}
}
?>
