<?php
/*
*
* @name welcome_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: welcome_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class welcome_block extends blockgets_block
{
	function init()
	{
		global $template, $user;

		$this->tpl_name = 'welcome_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}

		$label	= (!empty($user->data['is_registered']) ? 'member' : 'guest');

		$template->assign_var('S_WELCOME_CONTENT', $this->generate_text_display($data["{$label}_text"]));

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		global $config, $user, $phpbb_root_path, $phpEx;

		$bbcode = $this->bbcode('get');

		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);

				decode_message($new['guest_text'], $bbcode['uid']);
				decode_message($new['member_text'], $bbcode['uid']);
			break;

			case 'submit':
				$user->add_lang('posting');

				$bbcode_bitfield = '';
				
				if (!class_exists('parse_message'))
				{
					include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
				}

				$message_parser = new parse_message();
				
				if($bbcode['uid'])
				{
					$message_parser->bbcode_uid = $bbcode['uid'];
				}

				/* Parse guest message */
				if($new['guest_text'])
				{
					$message_parser->message = html_truncate($new['guest_text'], 1000, '', true);
					$message_parser->parse($config['allow_bbcode'], true, $config['allow_smilies']);
					$bbcode_bitfield = $bbcode_bitfield | $message_parser->bbcode_bitfield;
					
					$new['guest_text'] = $message_parser->message;
				}
				
				/* Parse member message */
				if($new['member_text'])
				{
					$message_parser->message = html_truncate($new['member_text'], 1000, '', true);
					$message_parser->parse($config['allow_bbcode'], true, $config['allow_smilies']);
					$bbcode_bitfield = $bbcode_bitfield | $message_parser->bbcode_bitfield;
					
					$new['member_text'] = $message_parser->message;
				}
				
				$this->bbcode('set', $message_parser->bbcode_uid, $bbcode_bitfield);

				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$this->display_vars = array(
			'guest_text'	=> array('lang' => 'WELCOME_GUEST',		'type' => 'custom',	'function' => 'blg_build_editor',	'params' => array('{CONFIG_VALUE}', 'acp_block_form', '{KEY}', 20, 50)),
			'member_text'	=> array('lang' => 'WELCOME_MEMBER',	'type' => 'custom',	'function' => 'blg_build_editor',	'params' => array('{CONFIG_VALUE}', 'acp_block_form', '{KEY}', 20, 50)),
		);

		return true;
	}
}
?>
