<?php
/*
*
* @name youtube_block.php
* @package phpBB3 cBB Blockgets
* @version $Id: youtube_block.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class youtube_block extends blockgets_block
{
	function init()
	{
		global $template;

		$this->tpl_name = 'youtube_block';

		if(($data = $this->unserialize()) === false)
		{
			return false;
		}
		
		if(empty($data['video_source']))
		{
			return false;
		}
		
		$src_list = $data['video_source'];

		list($v_width, $v_height) = explode('x', $data['video_size'], 2);

		// Delete the array in the template if exists, prevent errors between blocks
		$template->destroy_block_vars('yt_video');

		if($data['random_display'])
		{
			$rand = rand(0, (count($src_list)-1));
			$src_list = array($src_list[$rand]);
		}

		$first = true;
		foreach($src_list as $src)
		{
			list($title, $url) = blg_explode_list($src, 2);

			if(preg_match('#(http[s]?://)([a-z]+)\.youtube.com/watch\?[^v\=]?v\=([a-zA-Z0-9\-_]+).*#', $url, $match))
			{
				$add = ($data['video_autoplay'] && $first) ? '&amp;autoplay=1' : '';

				$template->assign_block_vars('yt_video', array(
					'WIDTH'		=> $v_width,
					'HEIGHT'	=> $v_height,
					'SRC'		=> $match[1] . $match[2] . '.youtube.com/v/' . $match[3] . '?version=3&amp;rel=0' . $add,
				));

				$first = false;
			}
		}

		$template->assign_vars(array(
			'S_AUTOPLAY'	=> $data['video_autoplay'],
			'S_SHORT_MODE'	=> $this->config['autofit'],
		));

		unset($data);
		return true;
	}

	function configure($mode, $block_row, &$new, &$submit)
	{
		switch($mode)
		{
			case 'validate':
				$new = $this->unserialize($block_row['block_content'], true, $new);
			break;

			case 'submit':
				$new['video_source'] = utf8_normalize_nfc(request_var('source', array('' => ''), true));

				$new['block_content'] = $this->serialize($new);
			break;
		}
	}

	function get_config()
	{
		$sizes = array('300x255', '425x349', '480x390', '640x510', '960x750');

		foreach($sizes as $id => $size)
		{
			$sizes[$size] = $size;
			unset($sizes[$id]);
		}
		
		$dialog_items = array(
			array('YT_VIDEO_TITLE'),
			array('YT_VIDEO_URL', array('/^http[s]?:\/\/[a-z]+\.youtube.com\/watch\?[^v\=]?v\=[a-zA-Z0-9\-_]+.*$/'))
		);

		$this->display_vars = array(
			'random_display'	=> array('lang' => 'YT_RANDOM_DISPLAY',	'validate' => 'bool',	'type' => 'radio:yes_no', 'default' => 1),
			'video_autoplay'	=> array('lang' => 'YT_AUTOPLAY',		'validate' => 'bool',	'type' => 'radio:yes_no', 'default' => 1),
			'video_size'		=> array('lang' => 'YT_VIDEO_SIZE',	 	'type' => 'select',	'function' => 'blg_make_select',	'params' => array($sizes, '{CONFIG_VALUE}')),
			'video_source'		=> array('lang' => 'YT_VIDEO_SOURCE',	'type' => 'custom', 'function' => 'blg_build_list',	'params' => array('sourcelist', 'source', '{CONFIG_VALUE}', $dialog_items)),
		);

		return true;
	}
}

?>
