<?php
/*
*
* @name blockgets.php
* @package phpBB3 cBB Blockgets
* @version $Id: blockgets.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/*
 * cBB Blockgets Main Class
*/
class blockgets
{
	var $active		= false;
	var $enabled	= false;
	var $lang_locale	= array();
	var $lang_names		= array();
	var $page		= false;
	var $head		= array();

	var $path		= 'blockgets/';
	var $home_page	= 'home.php';
	var $home_path	= './';

	var $root_path;
	var $template;

	var $block_position_names = array('', 'left', 'center', 'right', 'top', 'bottom');

	/**
	* Init class
	*/
	function blockgets()
	{
		global $config, $phpbb_root_path, $phpEx, $table_prefix;
			
		$this->root_path = $phpbb_root_path . $this->path;

		if(!defined('IN_INSTALL') && !empty($config['blg_version']) && file_exists($this->root_path . "includes/constants.$phpEx"))
		{
			include($this->root_path . "includes/constants.$phpEx");
			$this->enabled = $this->active = (!empty($config['blg_enabled']) ? true : false);
		}
	}
	
	function set_home($new_page = false, $new_path = false)
	{
		$this->home_page	= ($new_page !== false) ? $new_page : $this->home_page;
		$this->home_path	= ($new_path !== false) ? $new_path : $this->home_path;
	}
	
	function setup($mode = 'main')
	{
		global $phpbb_root_path, $db, $user, $template, $phpEx;
		global $config, $auth, $SID, $_EXTRA_URL;

		switch($mode)
		{
			case 'main':
				if($this->enabled)
				{
					// Update de counter
					if(!defined('ADMIN_START'))
					{
						$time = (time() - (int)$config['blg_counter_interval']);
						if($time > $user->data['session_time'] || $user->data['session_start'] == $user->time_now)
						{
							$config['blg_counter_visit_count'] = (int)$config['blg_counter_visit_count'] + 1;
							
							set_config('blg_counter_visit_count', $config['blg_counter_visit_count']);
						}
					}
					
					// Add common language
					if(!defined('ADMIN_START') || empty($user->data['session_admin']))
					{
						$user->add_lang('mods/' . $this->path . 'main');
					}
					
					// Ok, check the page
					$this->load_page();

					if(defined('ADMIN_START') || defined('IN_ERROR_HANDLER'))
					{
						$this->active = false;
					}

					// Set global data in template
					$template->assign_vars(array(
						'BLG_ENABLED'		=> $this->active,
						'BLG_ON_BOARD'		=> ($this->active && $config['blg_on_board']) ? true : false,
		
						'BLG_ALLOW_COLLAPSE'	=> (int)$config['blg_collapse_blocks'],
						'BLG_BACKGROUND'		=> $this->page['page_background'],
						'BLG_HIDE_HEADER'		=> ($this->page['page_header']) ? false : true,
						'BLG_RSZ_GO'			=> (int)$config['blg_resize_enabled'],
						'BLG_RSZ_ON_POST'		=> (int)$config['blg_resize_on_post'],
						'BLG_RSZ_WIDTH'			=> (int)$config['blg_image_max_width'],
						'BLG_SLIDERBARS'		=> ($this->page['page_sliderbars']) ? true : false,
						'BLG_PAGE_ID'			=> $this->page['page_id'],

						'L_BLG_HOME'		=> (isset($user->lang[$config['blg_home_title']]) ? $user->lang[$config['blg_home_title']] : $config['blg_home_title']),
						'S_COOKIE_NAME'		=> $config['cookie_name'],
						'T_BLOCKGETS_PATH'	=> $this->root_path,
						
						'U_BLG_ACTION'		=> $phpbb_root_path . $user->page['page'],
						'U_BLG_HOME'		=> ($config['blg_home_enabled']) ? append_sid($phpbb_root_path . (($this->home_path != './') ? $this->home_path : '') . $this->home_page) : '',
					));

					/* Execute ajax if neccessary */
					if($this->active)
					{
						$this->parse_ajax();
					}
				}
				
				// Redirect pages if neccessary or not allowed
				$board_url = $this->get_board_path('board_url');
				
				if(defined('BLG_HOME_PAGE'))
				{
					if(!$this->active)
					{
						redirect(append_sid("{$board_url}index.$phpEx"));
					}
				}
				else if($this->enabled && $phpbb_root_path == './' && $user->page['page_name'] == "index.$phpEx")
				{
					if($config['blg_home_as_principal'] && !preg_match('#' . $user->page['script_path'] . '[a-z]+\.[a-z]+#', $_SERVER['REQUEST_URI']))
					{
						redirect(append_sid($board_url . (($this->home_path != './') ? $this->home_path : '') . $this->home_page));
					}
				}
				
				// Set default headers
				include($phpbb_root_path . $this->path . "includes/default_headers.$phpEx");
				
				foreach($overall_headers as $header)
				{
					call_user_func_array(array($this, 'set_header'), $header);
				}
			break;

			case 'style':
				$style = request_var('style', 0);

				if($this->active)
				{
					$sql = 'SELECT style_id
						FROM ' . STYLES_TABLE . "
						WHERE style_active = 1
						AND style_id = $style";
					$result = $db->sql_query($sql);
					$style = (int)$db->sql_fetchfield('style_id');
					$db->sql_freeresult($result);

					if($style)
					{
						if(!empty($_GET['default']) && $user->data['is_registered'] && !$config['override_user_style'] && $style != $user->data['user_style'])
						{
							// Update user style
							$sql = 'UPDATE ' . USERS_TABLE . "
								SET user_style = $style
								WHERE user_id = " . $user->data['user_id'];
							$db->sql_query($sql);
						}
						else if(!$auth->acl_get('a_styles') && $user->data['user_style'] != $style)
						{
							$SID .= '&amp;style=' . $style;
							$_EXTRA_URL = array('style=' . $style);
						}
					}
				}

				return ($style) ? $style : 0;
			break;
		}
	}

	/**
	* load blocks and put into template
	*/
	function load_blocks()
	{
		global $phpbb_root_path, $db, $user, $template, $config, $phpEx;
		
		if(!$this->enabled || !$this->active || empty($this->page) || defined('BLG_IN_AJAX'))
		{
			return;
		}
		
		// Include here the display functions if not defined
		if(!function_exists('get_user_avatar'))
		{
			include("{$phpbb_root_path}includes/functions_display.$phpEx");
		}

		// Include here the bbcode class to not include in each block :)
		if (!class_exists('bbcode'))
		{
			include("{$phpbb_root_path}includes/bbcode.$phpEx");
		}

		// Load the blocks
		$sql = 'SELECT *
			FROM ' . BLG_BLOCK_TABLE . '
			WHERE block_enabled = 1
			AND block_page = ' . $this->page['page_id'] . '
			ORDER BY block_position ASC, block_order ASC';
		$result_block = $db->sql_query($sql);

		$forum_block_order	= 0;
		while($block_row = $db->sql_fetchrow($result_block))
		{
			$class_name		= $block_row['block_alias'];
			$block_filename	= $this->root_path . "block/$class_name.$phpEx";

			if($class_name != 'forum_content' && !file_exists($block_filename))
			{
				continue;
			}

			// Check block group
			if(!blg_group_auth($block_row['block_groups']))
			{
				continue;
			}
			
			/* If the current column is disabled, don't load the block -.- */
			$block_position = $this->block_position_names[$block_row['block_position']];
			
			if(in_array($block_position, array('left', 'right')) && empty($this->page["{$block_position}_column_width"]))
			{
				continue;
			}

			if($block_row['block_position'] && $block_row['block_position'] > 0 && $block_row['block_position'] < 6)
			{
				if($class_name == 'forum_content')
				{
					$forum_block_order = $block_row['block_order'];
					continue;
				}

				if(file_exists($block_filename) && !class_exists($class_name))
				{
					include($block_filename);
				}

				if(!class_exists($class_name))
				{
					continue;
				}

				// Initialize and load the block
				$block_class = new $class_name($block_row);
				$block_class->content = $block_row['block_content'];

				if($block_class->init() === false)
				{
					unset($block_class);
					continue;
				}

				if(!$block_row['block_img'])
				{
					$block_row['block_img'] = 'small/blank.gif';
				}

				build_img_path($block_row['block_img'], $this->path . 'images/icons/');

				// Put block into general template to display
				$template->assign_block_vars("{$block_position}_blockrow", array(
					'BLOCK_ID'    		=> $block_row['block_id'],
					'BLOCK_TITLE'		=> (isset($user->lang[$block_row['block_title']]) ? $user->lang[$block_row['block_title']] : $block_row['block_title']),
					'BLOCK_CONTENT'		=> $this->assign_display($block_class),
					'BLOCK_IMG'			=> '<img src="' . $block_row['block_img'] . '" height="16" width="16" alt="" />',
					'BLOCK_STYLE'		=> ($block_row['block_style']) ? $block_row['block_style'] : BLOCK_STYLE_DEFAULT,
					'COLLAPSABLE'		=> ($config['blg_collapse_blocks'] && $block_row['allow_collapse']) ? true : false,
					
					'AFTER_FORUM'		=> ($forum_block_order != 0 && $block_row['block_order'] > $forum_block_order) ? true : false,
				));
			}

			unset($block_class);
		}
		$db->sql_freeresult($result_block);

		$template->assign_vars(array(
			'LEFT_COLUMN_WIDTH'		=> $this->page['left_column_width'],
			'RIGHT_COLUMN_WIDTH'	=> $this->page['right_column_width'],

			'DISPLAY_FORUM_BLOCK'	=> ($forum_block_order == 0) ? false : true,
		));
	}
	
	/* */
	function set_page($page = '')
	{
		if($page)
		{
			$this->page = (string)$page;
		}
	}

	/**
	* Select the page to show if avaliable
	*/
	function load_page()
	{
		global $db, $user, $cache, $config, $phpbb_root_path, $phpEx;
		
		// Get cached pages
		if (($page_cache = $cache->get('_blockgets_pages')) === false)
		{
			$page_cache = array(
				'pages' => array(
					PAGE_HOME 	=> array(),
					PAGE_FORUM 	=> array(),
					PAGE_CUSTOM	=> array(),
				),
				'alias'		=> array(),
			);

			// Get pages
			$sql = 'SELECT *
				FROM ' . BLG_PAGES_TABLE;
			$result = $db->sql_query($sql);
			while ($row = $db->sql_fetchrow($result))
			{
				$page_cache['pages'][$row['page_type']][$row['page_id']] = $row;
				$page_cache['alias'][$row['page_alias']] = $row['page_id'];
			}
			$db->sql_freeresult($result);

			$cache->put('_blockgets_pages', $page_cache);
		}
		
		if(defined('BLG_HOME_PAGE'))
		{
			/* If previous page was defined use it, else, request a value */
			$page = (!empty($this->page) && is_string($this->page)) ? $this->page : request_var('p', '');
			
			if($page)
			{
				$page_type = PAGE_CUSTOM;

				if(preg_match('#^[0-9]+$#', $page))
				{
					$page_id = (int)$page;
				}
				else
				{
					$page_id = (isset($page_cache['alias'][$page]) ? $page_cache['alias'][$page] : 0);
				}
			}
			else
			{
				$page_type	= PAGE_HOME;
				$page_id	= (isset($page_cache['alias']['home']) ? $page_cache['alias']['home'] : 0);
			}
		}
		else
		{
			$page_type = PAGE_FORUM;
			$page_alias = str_replace(".$phpEx", '', $user->page['page_name']);
			$page_id = (isset($page_cache['alias'][$page_alias]) ? $page_cache['alias'][$page_alias] : 0);
		}
		
		if(isset($page_cache['pages'][$page_type][$page_id]))
		{
			$this->page = $page_cache['pages'][$page_type][$page_id];
		}
			
		if(empty($this->page) || empty($this->page['page_enabled']) || ($page_type == PAGE_FORUM && (!$config['blg_on_board'] || $user->page['page_dir'])))
		{
			$this->active = false;
			return false;
		}

		// Check page group
		if(!blg_group_auth($this->page['page_groups']))
		{
			if(defined('BLG_HOME_PAGE'))
			{
				redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
			}

			$this->active = false;
			return false;
		}
		
		return true;
	}
	
	function get_title()
	{
		global $user;
		
		if(!isset($this->page['page_title']))
		{
			return '';
		}

		if(isset($user->lang[$this->page['page_title']]))
		{
			return $user->lang[$this->page['page_title']];
		}
		
		return $this->page['page_title'];
	}

	/*
	* Get the correct board path
	*/
	function get_board_path($rtn = 'full', $strip_tags = false)
	{
		global $phpbb_root_path, $config, $user;

		$url = generate_board_url(true) . $config['script_path'];
		$url .= ((substr($url, -1) != '/') ? '/' : '');

		$root		= preg_replace('#^\./(.*)$#', "\\1", $phpbb_root_path);
		$page_url	= str_replace($root, '', $url);

		$page	= (($strip_tags !== false) ? build_url($strip_tags) : $user->page['page']);
		$page	= append_sid($page_url . str_replace(array($phpbb_root_path, '../'), '', $page));

		// Delete duplicated entries
		if(strpos($page, '?') !== false)
		{
			list($page, $url_query) = explode('?', $page);

			if(!empty($url_query))
			{
				$url_query = explode('&', str_replace('&amp;', '&', $url_query));
				$url_query = array_unique($url_query);

				$page .= '?' . implode('&amp;', $url_query);
			}
		}

		$data = array(
			'board_url' => $url,
			'page_url'	=> $page_url,
			'page'		=> $page,
		);

		if($rtn == 'full')
		{
			return $data;
		}
		else if(isset($data[$rtn]))
		{
			return $data[$rtn];
		}

		return false;
	}

	/**
	* Compile the template for each block
	*/
	function assign_display($block_class, $display = false)
	{
		global $template;
		
		$block_id = $block_class->config['block_id'];

		if(!$block_id || !$block_class->tpl_name)
		{
			return '';
		}

		$template->assign_var('BLOCK_ID', $block_id);

		$template->set_filenames(array('blg_tpl' => $this->path . 'block/' . $block_class->tpl_name . '.html'));
		
		if($display)
		{
			$template->display('blg_tpl');
			return true;
		}

		return $template->assign_display('blg_tpl');
	}

	/**
	* locale_lang
	* Get the local lang code from user lang code
	*
	* @param string	$lang_name . The lang iso name to find or '_set' param to only load the files
	* @param string	$type . (iso|names). The type of data to proccess
	* @return string|bool . Returns the locale lang or the default lang if not exists. false on '_set' or error
	*/
	function locale_lang($lang_name = false, $type = 'iso')
	{
		global $user, $phpbb_root_path, $phpEx;
		
		if(!$lang_name)
		{
			$lang_name = $user->lang_name;
		}

		switch($type)
		{
			case 'iso':
				if(empty($this->lang_locale))
				{
					include($this->root_path . "includes/lang_locale.$phpEx");
					$this->lang_locale = &$lang_locale;
					
					unset($lang_locale);
				}

				if($lang_name != '_get')
				{
					return (isset($this->lang_locale[$lang_name]) ? $this->lang_locale[$lang_name] : 'en_US');
				}
			break;
			
			case 'name':
				if(empty($this->lang_names))
				{
					include($this->root_path . "includes/lang_names.$phpEx");
					$this->lang_names = &$lang_names;
					
					unset($lang_names);
				}

				if($lang_name != '_get')
				{
					return (isset($this->lang_names[$lang_name]) ? $this->lang_names[$lang_name] : '');
				}
			break;
		}
		
		return false;
	}
	
	function parse_ajax()
	{
		global $phpbb_root_path, $phpbb_admin_path, $phpEx;
		global $db, $user, $cache, $auth, $template, $config;
		
		$module		= request_var('jblgm', '');
		$is_hook	= (strpos($module, 'hook_') !== false) ? true : false;
		$is_block	= (isset($_POST['jblg']) && is_numeric($module)) ? true : false;

		if(isset($_POST['jblg']) || $is_hook || $is_block)
		{
			if($is_block)
			{
				$filename = $this->root_path . "includes/blocks.$phpEx";
			}
			else
			{
				$filename = $this->root_path . (($is_hook) ? 'includes/hooks/' : '') . $module . ".$phpEx";
			}
			
			if(file_exists($filename))
			{
				define('BLG_IN_AJAX', true);
				include($filename);
			}
			
			garbage_collection();
			exit_handler();
		}
	}
	
	function set_header($type, $filename, $path = 'blockgets', $ie = '', $file_version = '')
	{
		global $phpbb_root_path, $user;

		$board_path	= (defined('PHPBB_USE_BOARD_URL_PATH') && PHPBB_USE_BOARD_URL_PATH) ? $this->get_board_path('board_url') : $phpbb_root_path;
		$filepath	= '';
		
		switch($path)
		{
			case 'admin':
				global $phpbb_admin_path;
				$filepath = $phpbb_admin_path . 'style/';
			break;

			case 'blockgets':
				$filepath = $board_path . $this->path . 'src/';
			break;
			
			case 'template':
				$filepath = $board_path . 'styles/' . $user->theme['template_path'] . '/template/';
			break;
			
			case 'theme':
				$filepath = $board_path . 'styles/' . $user->theme['theme_path'] . '/theme/';
			break;
		}
		
		$b = ($ie) ? $ie : 'overall';

		if(!isset($this->head[$b]))
		{
			$this->head[$b] = array();
		}

		$this->head[$b][$type][] = array($filepath . $filename, $path, $file_version);
	}
	
	function build_header()
	{
		global $template, $config;

		if(empty($this->head))
		{
			return false;
		}

		$blg_head_tpl = array(
			'css'		=> '<link href="%s" rel="stylesheet" type="text/css" />',
			'js'		=> '<script src="%s" type="text/javascript"></script>',
		);
		
		$result = array();
		
		// Build headers
		foreach($this->head as $row_type => $rows)
		{
			$result1 = array();
			
			foreach($rows as $type => $data)
			{
				if(!in_array($type, array_keys($blg_head_tpl)))
				{
					continue;
				}
				
				foreach($data as $id => $row)
				{
					if(defined('IN_ADMIN') && ($row[1] == 'theme' || $row[1] == 'template') || !defined('IN_ADMIN') && $row[1] == 'admin')
					{
						continue;
					}
					
					if(strpos($row[0], 'jquery') === false && $row[1] != 'external')
					{
						$row[0] .= '?v=' . (($row[2]) ? $row[2] : $config['blg_version']);
					}
					
					$string = sprintf($blg_head_tpl[$type], $row[0]);
					
					if($row_type != 'overall')
					{
						$result1[] = $string;
						continue;
					}

					$result[] = $string;
				}
				
				$result[] = '';
			}
			
			// IE headers
			if(sizeof($result1))
			{
				$result[] = '<!--[if ' . $row_type . ']>';
				
				$result = array_merge($result, $result1);
				
				$result[] = '<![endif] -->';
			}

			unset($this->head[$row_type]);
		}
		
		$template->assign_var('S_BLG_HEADER', implode("\n", $result));
	}
}

class blockgets_block
{
	var $content;
	var $tpl_name;
	var $display_vars;
	var $master;
	
	var $config = array();
	var $data	= array();
	
	function blockgets_block($block = false)
	{
		global $blockgets, $config;

		$this->master = $blockgets;
		
		if($block !== false)
		{
			$block_position = $this->master->block_position_names[$block['block_position']];

			$this->config = array(
				'block_id'			=> $block['block_id'],
				'bbcode_uid'		=> $block['bbcode_uid'],
				'bbcode_bitfield'	=> $block['bbcode_bitfield'],
				
				'autofit'			=> ($config['blg_block_autofit'] && in_array($block_position, array('left', 'right')) ? true : false),
			);
		}
	}
	
	function setup($lang)
	{
		global $user, $phpEx;

		$lang_file = 'mods/' . $this->master->path . 'block/' . $lang;
		$filename = $user->lang_path . $user->lang_name . "/$lang_file.$phpEx";
		
		if(file_exists($filename))
		{
			$user->add_lang($lang_file);
		}
	}

	// Get the extra params and serialize it.
	function serialize($new_config, $add_data = false)
	{
		$block_content = array();

		if(is_array($this->display_vars))
		{
			$keys = array_keys($this->display_vars);

			foreach($keys as $key)
			{
				if(isset($new_config[$key]))
				{
					$block_content[$key] = $new_config[$key];
				}
			}
		}
		
		if(is_array($add_data))
		{
			$block_content = array_merge($block_content, $add_data);
		}

		if(sizeof($block_content))
		{
			return @serialize($block_content);
		}

		return '';
	}

	/**
	 * unserialize
	 * Get the block extra params
	 *
	 * @param string $content . The block extra content
	 * @param bool $allow_empty  . Defines whether the function can return a blank value
	 * @param array $new . The new configuration, has preference from $content always (overwrite)
	 * @return array . An array containing the extra params
	*/
	function unserialize($content = false, $allow_empty = false, $new = false)
	{
		$data = array();
		
		/* Use block content if not specific content defined */
		if($content === false)
		{
			$content = $this->content;
		}

		/* Convert the string into an array */
		if($content)
		{
			$data = @unserialize($content);
		}

		if($data === false || (empty($data) && !$allow_empty))
		{
			return false;
		}

		if(!is_array($data))
		{
			$data = array();
		}

		if(is_array($new))
		{
			$data = array_merge($data, $new);
		}

		return $data;
	}

	/**
	 * generate_text_display
	 * Generate display for the text on the blocks using HTML, smilies, bbcode, template and language vars.
	 *
	 * @param string	$text . The input text to proccess.
	 * @return string . The result text.
	*/
	function generate_text_display($text)
	{
		global $template, $user;
		
		$bbcode = $this->bbcode('get');

		$text = censor_text($text);

		// If bbcode is present, parse it, else, accept HTML
		if(!empty($bbcode['bitfield']))
		{
			$bb = new bbcode($bbcode['bitfield']);
			$bb->bbcode_second_pass($text, $bbcode['uid'], $bbcode['bitfield']);
			$text = bbcode_nl2br($text);

			unset($bb);
		}
		else
		{
			$text = htmlspecialchars_decode($text);
		}

		// Parse smilies
		$text = smiley_text($text);

		// Parse language and template vars
		if(strpos($text, '{') !== false)
		{
			// If current user is a guest, Show "Guest" and not "Anonymous" as username
			if($user->data['user_id'] == ANONYMOUS)
			{
				$text = str_replace('{S_USERNAME}', '{L_GUEST}', $text);
			}
		
			$text = preg_replace('#\{L_([A-Z0-9_-]+)\}#e', "isset(\$user->lang['\$1']) ? \$user->lang['\$1'] : '\$1'", $text);
			$text = preg_replace('#\{([A-Z0-9_-]+)\}#e', "isset(\$template->_rootref['\$1']) ? \$template->_rootref['\$1'] : ''", $text);
		}

		return $text;
	}
	
	/**
	* bbcode
	* Manage the block's bbcodes
	*
	* @param string	$mode . (get|set|delete)
	* @param string	$add . Extra string to apply in the bbcode name
	* @param string	$uid . The bbcode_uid to set
	* @param string $bitfield . The bbcode_bitfield to set
	* @return bool|array . Returns true on success, false on failure and array in "get" mode
	*/
	function bbcode($mode, $uid = '', $bitfield = '')
	{
		global $db;

		switch($mode)
		{
			case 'get':
				return array(
					'uid'		=> (isset($this->config['bbcode_uid']) ? $this->config['bbcode_uid'] : ''),
					'bitfield'	=> (isset($this->config['bbcode_bitfield']) ? $this->config['bbcode_bitfield'] : ''),
				);
			break;

			case 'set':
			case 'delete':
				if(!$uid || !$bitfield || $mode == 'delete')
				{
					$uid = $bitfield = '';
				}

				$this->config['bbcode_uid'] = $uid;
				$this->config['bbcode_bitfield'] = $bitfield;
			break;

			default:
				return false;
			break;
		}

		return true;
	}
}

/**
 * html_truncate
 * Truncates string while retaining special characters if going over the max length
 *
 * @param string	$input . The text to truncate to the given length.
 * @param int		$limit . Maximum length of string
 * @param string	$append . String to be appended
 * @param bool		$count_all . Defines if count all or only plain text
*/
if(!function_exists('html_truncate'))
{
	function html_truncate($input = '', $limit = 0, $append = '', $count_all = false)
	{
		$check_len = ($count_all) ? utf8_strlen($input) : utf8_strlen(strip_tags($input));

		if(!$input || $limit <= 0 || $check_len <= $limit)
		{
			return $input;
		}

		$splits = preg_split('#(</?[^>]*/?>)#', $input, -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);

		$text		= '';
		$open_tag	= false;

		foreach($splits as $split)
		{
			// If no open tag, open it if necessary
			if($open_tag === false)
			{
				if(preg_match('#^<([a-zA-Z]+).*>#', $split, $match))
				{
					if(utf8_substr($match[0], -2) !== '/>')
					{
						$open_tag = $match[1];
					}
				}
			}

			// Close tag, if the current
			if($open_tag !== false)
			{
				if($split === "</$open_tag>")
				{
					$open_tag = false;
				}
			}

			// Adjust the string
			if($open_tag === false && $split[0] != '<')
			{ 
				$length = ($count_all) ? utf8_strlen($text) : utf8_strlen(strip_tags($text));

				if(($length + utf8_strlen($split)) > $limit)
				{
					$split = utf8_substr($split, 0, $limit - $length);
				}
			}

			$text .= $split;

			// If exceed the limit and no open tags finish here,
			// and it is looking backwards to remove the tag open.
			$check_len = ($count_all) ? utf8_strlen($text) : utf8_strlen(strip_tags($text));
			if($check_len >= $limit)
			{
				if($open_tag !== false)
				{
					$tag = '<' . $open_tag; 
					$text = utf8_substr($text, 0, utf8_strrpos($text, $tag));
				}
		
				break;
			}
		}

		return $text . (($append) ? $append : '');
	}
}

/**
 * build_img_path
 * Parse the url and append de internal path if neccessary
 *
 * @param string $img . The original img path/name
 * @param string $internal_dir . The internal dir to append, relative to forum path
 * @param bool $include_root . Defines whether the $phpbb_root_path variable will be included in the path
*/
function build_img_path(&$img, $internal_dir = '', $include_root = true)
{
	global $phpbb_root_path;

	if(strpos($img, 'http') !== 0)
	{
		$img = (($include_root) ? $phpbb_root_path : '') . $internal_dir . $img;
	}
}

/**
 * format_short_date
 * Create short date from the user date format to use in blocks
 *
 * @param int	$time . The time point number
 * @param bool	$allow_timezone . Define if use the user timezone or not
*/
function format_short_date($time, $allow_timezone = true)
{
	global $user;

	$format = preg_replace('#[aABgGhHisueIOPTZcrU,\|:]+#', '', $user->data['user_dateformat']);

	if(!$allow_timezone)
	{
		return strtr(date($format, $time), $user->lang['datetime']);
	}

	return $user->format_date($time, $format);
}

function blg_group_auth($groups)
{
	global $user;

	$group_ary = explode(',', $groups);

	if($groups == 'all' || in_array($user->data['group_id'], $group_ary))
	{
		return true;
	}
	
	return false;
}

function blg_explode_list($item, $force_items = false)
{
	$sep = '#!';

	if(strpos($item, $sep) !== false)
	{
		$r = explode($sep, $item);
	}
	else
	{
		$r = array($item);
	}
	
	if($force_items !== false && count($r) < $force_items)
	{
		while(count($r) < $force_items)
		{
			$r[] = '';
		}
	}
	
	return $r;
}
?>
