<?php
/*
*
* @name calendar.php
* @package phpBB3 cBB Blockgets
* @version $Id: calendar.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if(!defined('BLG_IN_AJAX'))
{
	define('IN_PHPBB', true);
	$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
	$phpEx = substr(strrchr(__FILE__, '.'), 1);
	include($phpbb_root_path . 'common.' . $phpEx);

	// Start session management
	$user->session_begin();
	$auth->acl($user->data);
	$user->setup('posting');
	
	if(empty($blockgets))
	{
		exit;
	}

	$action = request_var('action', '');
	$action = (isset($_POST['add']) ? 'add' : $action);
	$action = (isset($_POST['delete']) ? 'delete' : $action);
	$action = (isset($_POST['cancel']) ? 'cancel' : $action);

	if(!$action)
	{
		$action = 'list';
	}

	if(in_array($action, array('add', 'edit', 'cancel', 'delete', 'list')))
	{
		if(!$auth->acl_get('u_blockgets_events'))
		{
			trigger_error('NO_AUTH_EVENTS');
		}

		$event_id 	= request_var('id', 0);
		$time 		= request_var('time', 0);

		$submit 	= (isset($_POST['submit'])) ? true : false;

		$start		= request_var('start', 0);
		$marked		= request_var('mark', array(0));
		$keywords	= utf8_normalize_nfc(request_var('keywords', '', true));

		// Sort keys
		$sort_days	= request_var('st', 0);
		$sort_key	= request_var('sk', 't');
		$sort_dir	= request_var('sd', 'd');

		$event_data = $error = array();
		$eyear = $emonth = $eday = 0;

		// Default hidden fields
		$hidden_fields = array(
			'time'		=> $time,
			'action'	=> $action
		);

		// Build default url
		$u_action = $blockgets->root_path . "calendar.$phpEx";

		$params = array('keywords' => $keywords, 'time' => $time, 'st' => $sort_days, 'sk' => $sort_key, 'sd' => $sort_dir);
		foreach($params as $id => $param)
		{
			if($param)
			{
				$u_action .= ((strpos($u_action, '?') === false) ? '?' : '&amp;') . "$id=$param";
			}
		}
		unset($params);

		$redirect_url = request_var('redirect', append_sid($blockgets->root_path . "calendar.$phpEx", 'action=list'));

		switch($action)
		{
			case 'cancel':
				redirect($redirect_url);
			break;

			case 'edit':
				$sql = 'SELECT *
					FROM ' . BLG_EVENTS_TABLE . "
					WHERE event_id = $event_id";
				$result = $db->sql_query($sql);
				$event_data = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if(!$event_data)
				{
					trigger_error('NO_EVENTS');
				}

				list($eyear, $emonth, $eday) = explode('-', date('Y-m-d', $event_data['event_time']));

			// no break

			case 'add':
				include("{$phpbb_root_path}includes/functions_posting.$phpEx");

				// HTML, BBCode, Smilies, Images and Flash status
				$bbcode_status	= ($config['allow_bbcode']) ? true : false;
				$smilies_status	= ($config['allow_smilies']) ? true : false;
				$img_status		= ($bbcode_status) ? true : false;
				$url_status		= ($config['allow_post_links']) ? true : false;
				$flash_status	= false;
				$quote_status	= false;

				$event_data['event_title']		= utf8_normalize_nfc(request_var('event_title', (($action == 'edit') ? $event_data['event_title'] : ''), true));
				$event_data['event_message']	= utf8_normalize_nfc(request_var('message', (($action == 'edit') ? $event_data['event_message'] : ''), true));

				if($time)
				{
					list($eyear, $emonth, $eday) = explode('-', date('Y-m-d', $time));
				}

				$eday		= request_var('eday', $eday);
				$emonth		= request_var('emonth', $emonth);
				$eyear		= request_var('eyear', $eyear);

				if($submit)
				{
					// check form
					if (!check_form_key('posting'))
					{
						$error[] = $user->lang['FORM_INVALID'];
					}

					// Check title
					if (utf8_clean_string($event_data['event_title']) === '')
					{
						$error[] = $user->lang['EMPTY_EVENT_TITLE'];
					}

					if (!sizeof($error))
					{
						$sql_ary = array(
							'user_id'		=> $user->data['user_id'],
							'event_title'	=> $event_data['event_title'],
							'event_message'	=> $event_data['event_message'],
							'event_time'	=> strtotime("$eyear/$emonth/$eday"),
						);

						if($action == 'add')
						{
							$sql = 'INSERT INTO ' . BLG_EVENTS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
							$message = 'EVENT_ADDED';
						}
						else
						{
							$sql = 'UPDATE ' . BLG_EVENTS_TABLE . '
								SET ' . $db->sql_build_array('UPDATE', $sql_ary) . "
								WHERE event_id = $event_id";
							$message = 'EVENT_EDITED';
						}

						$db->sql_query($sql);

						meta_refresh(3, $redirect_url);
						trigger_error($user->lang[$message] . '<br /><br />' . sprintf($user->lang['RETURN_EVENT_LIST'], '<a href="' . $redirect_url . '">', '</a>'));
					}
				}

				// Generate date select
				$s_day_options = $s_month_options = $s_year_options = '';
				for ($i = 1; $i < 32; $i++)
				{
					if($i < 13)
					{
						$selected = ($i == $emonth) ? ' selected="selected"' : '';
						$s_month_options .= "<option value=\"$i\"$selected>$i</option>";
					}

					$selected = ($i == $eday) ? ' selected="selected"' : '';
					$s_day_options .= "<option value=\"$i\"$selected>$i</option>";
				}

				$now = getdate();
				for ($i = $now['year']; $i <= $now['year'] + 50; $i++)
				{
					$selected = ($i == $eyear) ? ' selected="selected"' : '';
					$s_year_options .= "<option value=\"$i\"$selected>$i</option>";
				}
				unset($now);

				// Generate smiley listing
				generate_smilies('inline', 0);

				add_form_key('posting');

				$template->assign_vars(array(
					'S_IN_EVENT'	=> true,
					'ERROR'			=> (sizeof($error)) ? implode('<br />', $error) : '',

					'S_DAY_OPTIONS'		=> $s_day_options,
					'S_MONTH_OPTIONS'	=> $s_month_options,
					'S_YEAR_OPTIONS'	=> $s_year_options,

					'S_BBCODE_ALLOWED'	=> $bbcode_status,
					'S_SMILIES_ALLOWED'	=> $smilies_status,
					'S_BBCODE_IMG'		=> $img_status,
					'S_LINKS_ALLOWED'	=> $url_status,
					'S_BBCODE_FLASH'	=> $flash_status,
					'S_BBCODE_QUOTE'	=> $quote_status,

					'S_EVENT_TITLE'		=> $event_data['event_title'],
					'S_EVENT_MESSAGE'	=> $event_data['event_message'],

					'U_BACK'			=> $redirect_url,
				));

				$hidden_fields += array(
					'redirect' 	=> append_sid($u_action, 'action=list' . (($start) ? "&amp;start=$start" : '')),
					'id'		=> $event_id,
				);
			break;

			case 'delete':
				if(!empty($marked))
				{
					if (confirm_box(true))
					{
						$sql = 'DELETE FROM ' . BLG_EVENTS_TABLE . '
							WHERE ' . $db->sql_in_set('event_id', $marked);
						$db->sql_query($sql);

						meta_refresh(3, $redirect_url);
						$message = $user->lang['EVENTS_REMOVED'] . '<br /><br />' . sprintf($user->lang['RETURN_EVENT_LIST'], '<a href="' . $redirect_url . '">', '</a>');
						trigger_error($message);
					}
					else
					{
						confirm_box(false, 'DELETE_EVENT', build_hidden_fields(array(
								'mark'		=> $marked,
								'redirect'	=> $redirect_url,
								'action'	=> $action,
							))
						);
					}

					break;
				}

			$action = 'list';
			// no break;

			case 'list':
				// Sorting
				$limit_days		= array(0 => $user->lang['ALL_EVENTS'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);
				$sort_by_text	= array('u' => $user->lang['EVENT_TITLE'], 't' => $user->lang['EVENT_TIME']);
				$sort_by_sql	= array('u' => 'e.event_title', 't' => 'e.event_time');

				$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);

				$min_event_time = (($sort_days) ? strtotime(date('Y/m/d', time() - ($sort_days * 86400))) : 0);

				$sql_where = 'WHERE e.event_time ' . (($time) ? "= $time" : ">= $min_event_time");
				$sql_sort_order = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

				$sql_like_exp = array();
				if($keywords)
				{
					$keywords_ary = explode(' ', str_replace('+', ' ', $keywords));
					foreach($keywords_ary as $k)
					{
						$sql_like_exp[] = "UPPER(e.event_title) LIKE '%" . $db->sql_escape(strtoupper($k)) . "%'";
					}
				}

				$sql_like_exp = (!empty($sql_like_exp) ? ' AND (' . implode(' OR ', $sql_like_exp) . ')' : '');

				// First, count total items
				$sql = 'SELECT COUNT(*) as total
					FROM ' . BLG_EVENTS_TABLE . " e
					$sql_where $sql_like_exp";
				$result = $db->sql_query($sql);
				$event_count = (int)$db->sql_fetchfield('total');
				$db->sql_freeresult($result);

				// Ok, get the items
				$sql = 'SELECT e.*, u.username, u.user_colour
					FROM ' . BLG_EVENTS_TABLE . ' e
					LEFT JOIN ' . USERS_TABLE . " u ON(u.user_id = e.user_id)
					$sql_where
					$sql_like_exp
					ORDER BY $sql_sort_order";
				$result = $db->sql_query_limit($sql, $config['topics_per_page'], $start);

				while($row = $db->sql_fetchrow($result))
				{
					$template->assign_block_vars('event', array(
						'ID'		=> $row['event_id'],
						'TITLE'		=> $row['event_title'],
						'USER'		=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
						'DATE'		=> format_short_date($row['event_time'], false),

						'U_EDIT'	=> append_sid($u_action, 'action=edit&amp;id=' . $row['event_id']),
					));
				}
				$db->sql_freeresult($result);

				$u_action = append_sid($u_action, 'action=list');

				$template->assign_vars(array(
					'S_ON_PAGE'		=> on_page($event_count, $config['topics_per_page'], $start),
					'PAGINATION'	=> generate_pagination($u_action, $event_count, $config['topics_per_page'], $start, true),

					'S_DISPLAY_SEARCHBOX'	=> ($auth->acl_get('u_search') && $config['load_search']) ? true : false,

					'S_LIMIT_DAYS'	=> $s_limit_days,
					'S_SORT_KEY'	=> $s_sort_key,
					'S_SORT_DIR'	=> $s_sort_dir,
					'S_KEYWORDS'	=> $keywords,
				));

				$hidden_fields['redirect'] = $u_action . (($start) ? "&amp;start=$start" : '');
			break;
		}

		$page_title = (($action) ? $user->lang[strtoupper($action) . '_EVENT'] : $user->lang['EVENTS']);

		$template->assign_vars(array(
			'L_TITLE'		=> (($action == 'list' && $time) ? sprintf($user->lang['EVENT_LIST_OF'], format_short_date($time, false)) : $page_title),
			'S_HAS_TIME'	=> ($time) ? true : false,

			'U_ACTION'		=> append_sid($blockgets->root_path . "calendar.$phpEx"),

			'S_HIDDEN_FIELDS'	=> build_hidden_fields($hidden_fields),
		));

		$template->assign_block_vars('navlinks', array(
			'FORUM_NAME'	=> $user->lang['CALENDAR_EVENTS'],
			'U_VIEW_FORUM'	=> append_sid($blockgets->root_path . "calendar.$phpEx", 'action=list'),
		));

		page_header($page_title);

		$template->set_filenames(array(
			'body' => 'blockgets/calendar_events.html'
		));

		page_footer();
	}
}
else
{
	$calendar = new calendar();

	$calendar->get_events();
	$calendar->create_calendar();

	$template->assign_var('S_IN_CALENDAR', true);

	$template->set_filenames(array(
		'body' => 'blockgets/block/calendar_block.html'
	));

	$template->display('body');

	garbage_collection();
	exit_handler();
}


/*
* Calendar main class
*/
class calendar
{
	var $first_day;
	var $total_calendar		= 1;
	var $created_calendar	= 0;
	var $show_events;
	var $load_birthdays;

	var $time;
	var $time_now;
	var $now;
	var $events;

	var $container 			= '<div id="event-{S_TIME}">{S_EVENTS}</div>';
	var $event_container	= '<hr /><div><b style="font-size:1.1em;">{S_TITLE}</b><br /> {S_CONTENT} </div><br />';

	/**
	* Initialize some variables
	*/
	function calendar()
	{
		global $user;

		$action = request_var('action', '');

		$this->first_day		= request_var('fd', 0);
		$this->show_events		= request_var('se', 0);
		$this->load_birthdays	= request_var('sb', 0);
		$this->total_calendar	= request_var('mn', 1);

		$this->now = getdate(time() + $user->timezone + $user->dst - date('Z'));

		// The time of actual month (always set on first day)
		$this->time_now = request_var('time_now', time());
		$this->time = $this->time_now = strtotime(date('Y/m/01', $this->time_now), $this->time_now);

		switch($action)
		{
			case 'next':
				$this->time = strtotime('+1 month', $this->time_now);
			break;

			case 'prev':
				$this->time = strtotime("-{$this->total_calendar} month", $this->time_now);
			break;
		}
	}

	/*
	* create calendar
	* Build the month form (days, weeks)
	*/
	function create_calendar()
	{
		global $template, $user;

		$day_names = array('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');

		$days = $this->get_month();

		$template->assign_block_vars('calendar', array(
			'S_MONTH'			=> strtr(date('F Y', $this->time), $user->lang['datetime']),

			'S_HIDDEN_FIELDS'	=> build_hidden_fields(array(
				'time_now'	=> $this->time,
			)),
		));

		$i = 0;
		$in_header = true;
		while($i < 7)
		{
			$day = '';
			$day_time = 0;

			if($in_header)
			{
				$d = $i + $this->first_day;
				if($d > 6)
				{
					$d = $d-7;
				}

				$l_day  = $day_names[$d];

				$day = utf8_substr($user->lang['datetime'][$l_day], 0, 2);
			}
			else if(isset($days[0]))
			{
				if($this->get_week_day($days[0]['week_day']) == $i)
				{
					$day = $days[0]['day'];
					$day_time = $days[0]['day_time'];
					array_shift($days);
				}
			}

			$template->assign_block_vars('calendar.days', array(
				'IS_HEADER'		=> $in_header,
				'IS_TODAY'		=> (date('j-n-Y', $this->now[0]) == date('j-n-Y', $day_time)) ? true : false,
				'S_EVENT'		=> (isset($this->events[$day_time]) ? 'true' : 'false'),
				'S_DATA'		=> $day_time,
				'S_DAY'			=> $day,
				'NEW_LINE'		=> ($i == 0) ? true : false,
			));

			if(isset($days[0]) && $i == 6)
			{
				$in_header = false;
				$i = 0;
				continue;
			}
			$i++;
		}

		$this->created_calendar++;

		if($this->total_calendar > $this->created_calendar)
		{
			$this->time = strtotime("+1 month", $this->time);
			$this->create_calendar();
		}
	}

	/**
	* get_events
	* Get the calendar events and birthdays and put into template
	*/
	function get_events()
	{
		global $db, $phpbb_root_path, $user, $template, $config;

		if(!$this->show_events)
		{
			return;
		}

		$start_time	= $this->time;
		$end_time	= strtotime("+{$this->total_calendar} month", $start_time);

		$this->events = $month_years = array();

		// Get events
		$sql = 'SELECT *
			FROM ' . BLG_EVENTS_TABLE . "
			WHERE event_time BETWEEN $start_time AND $end_time";
		$db->sql_query($sql);

		$result = $db->sql_query($sql);

		while($row = $db->sql_fetchrow($result))
		{
			$c_time = $row['event_time'];

			if(!isset($this->events[$c_time]))
			{
				$this->events[$c_time] = array();
			}

			$this->events[$c_time][] = array(
				'title'		=> $row['event_title'],
				'content'	=> $row['event_message']
			);
		}
		$db->sql_freeresult($result);

		// Get time period for birthdays
		if($this->load_birthdays && $config['allow_birthdays'])
		{
			$birthday_ary = array();
			$sql_where = '';
			$t = $start_time;

			for($i = 0; $i < $this->total_calendar; $i++)
			{
				if($i > 0)
				{
					$t = strtotime("+{$i} month", $start_time);
				}

				$month_years[date('n', $t)] = $t;

				$sql_where .= (($sql_where) ? ' OR ' : '') . "u.user_birthday LIKE '%-" . sprintf('%2d', date('n', $t)) . "-%'";
			}

			$sql = 'SELECT u.user_id, u.username, u.user_colour, u.user_birthday
				FROM ' . USERS_TABLE . ' u
				LEFT JOIN ' . BANLIST_TABLE . " b ON (u.user_id = b.ban_userid)
				WHERE (b.ban_id IS NULL OR b.ban_exclude = 1)
				AND ($sql_where)
				AND u.user_type IN (" . USER_NORMAL . ', ' . USER_FOUNDER . ')';
			$result = $db->sql_query($sql);

			while($row = $db->sql_fetchrow($result))
			{
				list($bday, $bmonth, $byear) = explode('-', str_replace(' ', '', $row['user_birthday']));

				$t_year = (isset($month_years[$bmonth]) ? $month_years[$bmonth] : $this->time);
				$c_time = strtotime(date('Y', $t_year) . "/$bmonth/$bday");
				$age = $this->now['year'] - (int)$byear;

				if(!isset($birthday_ary[$c_time]))
				{
					$birthday_ary[$c_time] = array();
				}

				if($age)
				{
					$birthday_ary[$c_time][] = get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']) . " ($age)";
				}
			}
			$db->sql_freeresult($result);

			foreach($birthday_ary as $e_time => $e_data)
			{
				$this->events[$e_time][] = array(
					'title'		=> $user->lang('BIRTHDAYS_NUM', count($e_data)),
					'content'	=> implode(', ', $e_data),
				);
			}
		}

		// Compose the events into template
		// Use internal template to prevent style errors and to proccess the text only 1 time (Best perfomance) :)
		$event_content = '';
		foreach($this->events as $e_time => $e_data)
		{
			$content = '';

			foreach($e_data as $data)
			{
				$content .= str_replace(array('{S_TITLE}', '{S_CONTENT}'), array($data['title'], $data['content']), $this->event_container);
			}

			$event_content .= str_replace(array('{S_TIME}', '{S_EVENTS}'), array($e_time, $content), $this->container);
		}

		if($event_content)
		{
			generate_text_for_storage($event_content, $uid, $bitfield, $flags, $config['allow_bbcode'], $config['allow_post_links'], $config['allow_smilies']);
			$event_content = generate_text_for_display($event_content, $uid, $bitfield, $flags);

			$template->assign_var('S_EVENT_CONTAINER', $event_content);
		}
	}

	private function get_month() 
	{
		list($myear, $mmonth, $month_days) = explode(',', date("Y,n,t", $this->time));

		$day = array();
    
		for($i = 1; $i < $month_days +1; $i++) 
		{
			$day_time = strtotime("$myear/$mmonth/$i");

			$day[] = array(
				'day'		=> $i,
				'week_day'	=> (int)date('w', $day_time),
				'day_time'	=> $day_time,
			);
		}

		return $day;
	}

	private function get_week_day($day)
	{
		$day = (int)$day;

		$seg = $day - $this->first_day;

		if($seg < 0)
		{
			return $seg + 7;
		}

		if($seg > 6)
		{
			return $seg -7;
		}

		return $seg;
	}
}

?>
