<?php
/**
*
* @package index.php
* @package Installer cBB Blockgets
* @version $Id: index.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
define('IN_INSTALL', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

/* Include installer */
include('./includes/installer.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

// Initialize installer
$installer = create_installer();
$installer->setup(array('mods/blockgets/installer', 'mods/blockgets/acp'));

$installer->mod_title		= 'cBB Blockgets';
$installer->new_version		= '1.0.3';
$installer->required_phpbb	= '3.0.8';

// Main files
$installer->assign_files(array(
	'constants'			=> $phpbb_root_path . 'blockgets/includes/constants.' . $phpEx,
	'schema_install'	=> './schemas/schema_install.' . $phpEx,
	'schema_update'		=> './schemas/schema_update.' . $phpEx,
));

/* Values to obtain installed version */
$installer->version_key		= 'blg_version';

/* Global MOD ID in the canidev web */
$installer->mod_id = 'cbb-blockgets';

/* Have documentation? */
$installer->load_doc = true;

/* Define installer logo */
$installer->logo = $phpbb_root_path . 'blockgets/images/cbb-blockgets-logo.png';

/* Initialize */
$installer->load();
?>
