<?php
/**
*
* @package install_update.php
* @package cBB Blockgets Installer
* @version $Id: install_update.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
*/
if(!defined('IN_PHPBB') || !defined('IN_INSTALL'))
{
	exit;
}

/**
* Installation
* @package install
*/
class install_update extends installer
{
	var $subs = array('intro', 'update', 'final');

	function main()
	{
		global $user, $phpbb_root_path, $phpEx;

		switch ($this->sub)
		{
			case 'intro':
				$this->page_title = 'INTRO';
				
				$this->get_installed_version($current_version);
				
				$this->assign_vars(array(
					'BODY_TITLE'	=> 'UPDATE_INTRO',
					'BODY'			=> array('UPDATE_INTRO_BODY', $this->mod_title, $current_version, $this->new_version)
				));
				
				$this->buttons['_update'] = 'UPDATE_START';

			break;
			
			case 'update':
				$this->page_title = 'INSTALL';

				$checks = array(
					array('legend1',	'UPDATE_RESULTS'),

					array('DATABASE',		false, $this->perform_update()),
				);
				
				// Check if and error occurs
				if($this->build_checks($checks, 'UPDATE'))
				{
					$this->buttons['_final'] = 'NEXT_STEP';
				}
			break;

			case 'final':
				$this->page_title = 'UPDATE_SUCCEFULL';

				// clear cache
				$this->umil->cache_purge();

				$this->assign_vars(array(
					'BODY_TITLE'	=> 'UPDATE_SUCCEFULL',
					'S_NOTICE'		=> array('UPDATE_SUCCEFULL_EXPLAIN', $this->mod_title, $this->new_version),
				));
				
				$this->buttons['link2'] = array('LOGIN', append_sid($phpbb_root_path . 'adm/index.' . $phpEx, 'i=blockgets&amp;mode=config', true, $user->session_id));
			break;
		}

		$this->assign_vars('S_TITLE', 'UPDATE');
	}
	
	function perform_update()
	{
		$update_error = false;

		$this->get_installed_version($current_version);

		include($this->package_files['schema_update']);
		
		set_config($this->version_key, $this->new_version);
		
		return ($update_error) ? false : true;
	}
	
	function update_block_config($block_ary)
	{
		global $db, $phpbb_root_path, $phpEx;
		
		if(!is_array($block_ary))
		{
			$block_ary = array($block_ary);
		}

		foreach($block_ary as $block_alias)
		{
			$filename = $phpbb_root_path . 'blockgets/block/' . $block_alias . ".$phpEx";

			if(file_exists($filename) && !class_exists($block_alias))
			{
				include($filename);
			}

			if(!class_exists($block_alias))
			{
				continue;
			}

			$block_class = new $block_alias();
			$has_config = $block_class->get_config();

			if(!$has_config || !is_array($block_class->display_vars))
			{
				continue;
			}

			$sql = 'SELECT block_id, block_content
				FROM ' . BLG_BLOCK_TABLE . "
				WHERE block_alias = '$block_alias'";
			$result = $db->sql_query($sql);

			while($row = $db->sql_fetchrow($result))
			{
				$block_content = @unserialize($row['block_content']);

				if(!is_array($block_content))
				{
					$block_content = array();
				}

				$keys = array_diff_key($block_class->display_vars, $block_content);

				if(!sizeof($keys))
				{
					continue;
				}

				foreach($keys as $key => $null)
				{
					if(!isset($block_class->display_vars[$key]['default']))
					{
						continue;
					}

					$block_content[$key] = $block_class->display_vars[$key]['default'];
				}

				$sql = 'UPDATE ' . BLG_BLOCK_TABLE . "
					SET block_content = '" . @serialize($block_content) . "'
					WHERE block_id = " . $row['block_id'];
				$db->sql_query($sql);
			}
			$db->sql_freeresult($result);

			unset($block_class);
		}
	}
}
?>