<?php
/*
*
* @name schema_install.php
* @package phpBB3 cBB Blockgets
* @version $Id: schema_install.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

if(!defined('IN_PHPBB') || !defined('IN_INSTALL'))
{
	exit;
}


$this->schema = array(
	/* Table definitions */
	'table_add' => array(
		BLG_BLOCK_TABLE => array(
			'COLUMNS' => array(
				'block_id'			=> array('UINT:3', NULL, 'auto_increment'),
				'block_title'		=> array('VCHAR', ''),
				'block_content'		=> array('TEXT', ''),
				'block_alias'		=> array('VCHAR', ''),
				'block_img'			=> array('VCHAR', ''),
				'block_order'		=> array('UINT:3', NULL),
				'block_position'	=> array('BOOL', NULL),
				'block_page'		=> array('UINT:3', 0),
				'block_enabled' 	=> array('BOOL', 1),
				'block_style'		=> array('UINT:2', BLOCK_STYLE_DEFAULT),
				'block_groups'		=> array('VCHAR:50', '0'),
				'allow_collapse'	=> array('BOOL', 1),
				'bbcode_bitfield'	=> array('VCHAR', ''),
				'bbcode_uid'		=> array('VCHAR:8', ''),
			),
			'PRIMARY_KEY'	=> 'block_id',
		),

		BLG_EVENTS_TABLE => array(
			'COLUMNS' => array(
				'event_id'			=> array('UINT:8', NULL, 'auto_increment'),
				'user_id'			=> array('UINT:8', 0),
				'event_title'		=> array('VCHAR', ''),
				'event_message'		=> array('TEXT', ''),
				'event_time'		=> array('UINT:11', 0),
			),
			'PRIMARY_KEY'	=> 'event_id',
		),

		BLG_LISTS_TABLE => array(
			'COLUMNS' => array(
				'list_id'			=> array('UINT:3', NULL, 'auto_increment'),
				'list_name'			=> array('VCHAR:100', ''),
				'list_type'			=> array('VCHAR:100', ''),
			),
			'PRIMARY_KEY'	=> 'list_id',
		),

		BLG_LISTS_DATA_TABLE => array(
			'COLUMNS' => array(
				'link_id'			=> array('UINT:4', NULL, 'auto_increment'),
				'list_id'			=> array('UINT:3', 0),
				'link_title'		=> array('VCHAR', ''),
				'link_url'			=> array('VCHAR', ''),
				'link_img_url'		=> array('VCHAR', ''),
				'link_img_width'	=> array('UINT:3', 0),
				'link_img_height'	=> array('UINT:3', 0),
				'link_window'		=> array('BOOL', 0),
				'link_groups'		=> array('VCHAR:50', '0'),
				'link_order'		=> array('UINT:3', 1),
				'link_type'			=> array('BOOL', 0),
			),
			'PRIMARY_KEY'	=> 'link_id',
		),
		
		BLG_PAGES_TABLE => array(
			'COLUMNS' => array(
				'page_id'				=> array('UINT:3', NULL, 'auto_increment'),
				'page_type'				=> array('BOOL', 2),
				'page_alias'			=> array('VCHAR', ''),
				'page_title'			=> array('VCHAR', ''),
				'page_enabled'			=> array('BOOL', 1),
				'page_groups'			=> array('VCHAR:50', '0'),
				'page_background'		=> array('VCHAR', ''),
				'left_column_width'		=> array('UINT:4', 0),
				'right_column_width'	=> array('UINT:4', 0),
				'page_header'			=> array('BOOL', 1),
				'page_sliderbars'		=> array('BOOL', 1),
			),
			'PRIMARY_KEY'	=> 'page_id',
		),
	),

	/* SQL definitions */
	'row_insert' => array(
		CONFIG_TABLE	=> array(
			array('config_name' => 'blg_enabled',				'config_value' => 1,		'is_dynamic' => 0),
			array('config_name' => 'blg_on_board',				'config_value' => 0,		'is_dynamic' => 0),
			array('config_name' => 'blg_home_as_principal',		'config_value' => 0,		'is_dynamic' => 0),
			array('config_name' => 'blg_collapse_blocks',		'config_value' => 1,		'is_dynamic' => 0),
			array('config_name' => 'blg_block_autofit',			'config_value' => 1,		'is_dynamic' => 0),
			array('config_name' => 'blg_resize_enabled',		'config_value' => 1,		'is_dynamic' => 0),
			array('config_name' => 'blg_resize_on_post',		'config_value' => 1,		'is_dynamic' => 0),
			array('config_name' => 'blg_image_max_width',		'config_value' => 450,		'is_dynamic' => 0),
			array('config_name' => 'blg_counter_start_date',	'config_value' => time(),	'is_dynamic' => 0),
			array('config_name' => 'blg_counter_interval',		'config_value' => 1800,		'is_dynamic' => 0),
			array('config_name' => 'blg_counter_visit_count',	'config_value' => 0,		'is_dynamic' => 1),
			array('config_name' => 'blg_home_enabled',			'config_value' => 1,		'is_dynamic' => 0),
			array('config_name' => 'blg_home_title',			'config_value' => $user->lang['PORTAL'],	'is_dynamic' => 0),
			array('config_name' => 'blg_version',				'config_value' => $this->new_version,				'is_dynamic' => 0),
		),
		
		BLG_PAGES_TABLE => array(
			array(
				'page_type'				=> PAGE_HOME,
				'page_alias'			=> 'home',
				'page_title'			=> $user->lang['PORTAL'],
				'page_groups'			=> 'all',
				'page_background'		=> '',
				'left_column_width'		=> 180,
				'right_column_width'	=> 180,
			),
			array(
				'page_type'				=> PAGE_FORUM,
				'page_alias'			=> 'index',
				'page_title'			=> 'INDEX',
				'page_groups'			=> 'all',
				'page_background'		=> '',
				'left_column_width'		=> 180,
				'right_column_width'	=> 180,
			),
			array(
				'page_type'				=> PAGE_FORUM,
				'page_alias'			=> 'viewforum',
				'page_title'			=> 'FORUMS',
				'page_groups'			=> 'all',
				'page_background'		=> '',
				'left_column_width'		=> 180,
				'right_column_width'	=> 180,
			),
			array(
				'page_type'				=> PAGE_FORUM,
				'page_alias'			=> 'viewtopic',
				'page_title'			=> 'TOPICS',
				'page_groups'			=> 'all',
				'page_background'		=> '',
				'left_column_width'		=> 180,
				'right_column_width'	=> 180,
			),
		),

		BLG_BLOCK_TABLE	=> array(
			array(
				'block_title'		=> 'FORUM',
				'block_content'		=> '',
				'block_alias'		=> 'forum_content',
				'block_img'			=> '',
				'block_order'		=> 1,
				'block_position'	=> 2,
				'block_page'		=> 2,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> 'FORUM',
				'block_content'		=> '',
				'block_alias'		=> 'forum_content',
				'block_img'			=> '',
				'block_order'		=> 1,
				'block_position'	=> 2,
				'block_page'		=> 3,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> 'FORUM',
				'block_content'		=> '',
				'block_alias'		=> 'forum_content',
				'block_img'			=> '',
				'block_order'		=> 1,
				'block_position'	=> 2,
				'block_page'		=> 4,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['menu_title'],
				'block_content'		=> serialize(array('menu_id' => 1)),
				'block_alias'		=> 'menu_block',
				'block_img'			=> 'small/layout.png',
				'block_order'		=> 1,
				'block_position'	=> 1,
				'block_page'		=> 1,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['clock_title'],
				'block_content'		=> 'tri_amber.swf',
				'block_alias'		=> 'clock_block',
				'block_img'			=> 'small/clock.png',
				'block_order'		=> 2,
				'block_position'	=> 1,
				'block_page'		=> 1,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['link_us_title'],
				'block_content'		=> serialize(array('banner_url' => 'canidev-banner.png')),
				'block_alias'		=> 'link_us_block',
				'block_img'			=> 'small/folder_link.png',
				'block_order'		=> 3,
				'block_position'	=> 1,
				'block_page'		=> 1,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['welcome_title'],
				'block_content'		=> serialize(array(
					'guest_text'	=> htmlspecialchars($user->lang['WELCOME_GUEST'], ENT_COMPAT, 'UTF-8'),
					'member_text'	=> htmlspecialchars($user->lang['WELCOME_MEMBER'], ENT_COMPAT, 'UTF-8'),
				)),
				'block_alias'		=> 'welcome_block',
				'block_img'			=> 'small/group.png',
				'block_order'		=> 1,
				'block_position'	=> 2,
				'block_page'		=> 1,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['dockmenu_title'],
				'block_content'		=> serialize(array('menu_id' => 2, 'item_width' => 40)),
				'block_alias'		=> 'dockmenu_block',
				'block_img'			=> 'small/world.png',
				'block_order'		=> 2,
				'block_position'	=> 2,
				'block_page'		=> 1,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['recent_topics_title'],
				'block_content'		=> serialize(array('topic_limit' => 5, 'title_limit' => 50)),
				'block_alias'		=> 'recent_topics_block',
				'block_img'			=> 'small/folder_add.png',
				'block_order'		=> 3,
				'block_position'	=> 2,
				'block_page'		=> 1,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['whos_online_title'],
				'block_content'		=> serialize(array('advanced' => 1, 'usernames' => 1)),
				'block_alias'		=> 'whos_online_block',
				'block_img'			=> 'small/world.png',
				'block_order'		=> 4,
				'block_position'	=> 2,
				'block_page'		=> 1,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['login_title'],
				'block_content'		=> serialize(array('full_login' => 1, 'show_register' => 1)),
				'block_alias'		=> 'login_block',
				'block_img'			=> 'small/user.png',
				'block_order'		=> 1,
				'block_position'	=> 3,
				'block_page'		=> 1,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['stats_title'],
				'block_content'		=> serialize(array('stats_inline' => 0, 'user_stats' => 1)),
				'block_alias'		=> 'stats_block',
				'block_img'			=> 'small/chart_bar.png',
				'block_order'		=> 2,
				'block_position'	=> 3,
				'block_page'		=> 1,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['login_title'],
				'block_content'		=> serialize(array('full_login' => 1, 'show_register' => 1)),
				'block_alias'		=> 'login_block',
				'block_img'			=> 'small/user.png',
				'block_order'		=> 1,
				'block_position'	=> 3,
				'block_page'		=> 2,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['most_poster_title'],
				'block_content'		=> serialize(array('poster_limit' => 5, 'poster_range' => 'none')),
				'block_alias'		=> 'most_poster_block',
				'block_img'			=> 'small/user_add.png',
				'block_order'		=> 2,
				'block_position'	=> 3,
				'block_page'		=> 2,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['login_title'],
				'block_content'		=> serialize(array('full_login' => 1, 'show_register' => 1)),
				'block_alias'		=> 'login_block',
				'block_img'			=> 'small/user.png',
				'block_order'		=> 1,
				'block_position'	=> 3,
				'block_page'		=> 3,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
			array(
				'block_title'		=> $user->lang['blocks']['login_title'],
				'block_content'		=> serialize(array('full_login' => 1, 'show_register' => 1)),
				'block_alias'		=> 'login_block',
				'block_img'			=> 'small/user.png',
				'block_order'		=> 1,
				'block_position'	=> 3,
				'block_page'		=> 4,
				'block_groups'		=> 'all',
				'bbcode_bitfield'	=> '',
				'bbcode_uid'		=> '',
			),
		),

		BLG_LISTS_TABLE	=> array(
			array('list_name' => $user->lang['MAIN_MENU'],		'list_type' => 'menu'),
			array('list_name' => $user->lang['DOCK_MENU'],		'list_type' => 'menu'),
			array('list_name' => $user->lang['RECOMMENDED'],	'list_type' => 'banner'),
		),

		BLG_LISTS_DATA_TABLE	=> array(
			array(
				'list_id'			=> 1,
				'link_title'		=> $user->lang['P_MAIN'],
				'link_url'			=> '',
				'link_img_url'		=> 'small/blank.gif',
				'link_img_width'	=> 0,
				'link_img_height'	=> 0,
				'link_window'		=> 0,
				'link_groups'		=> 'all',
				'link_order'		=> 1,
				'link_type'			=> LIST_CAT,
			),
			array(
				'list_id'			=> 1,
				'link_title'		=> 'Portal',
				'link_url'			=> 'home.php',
				'link_img_url'		=> 'small/house.png',
				'link_img_width'	=> 16,
				'link_img_height'	=> 16,
				'link_window'		=> 0,
				'link_groups'		=> 'all',
				'link_order'		=> 2,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 1,
				'link_title'		=> $user->lang['INDEX'],
				'link_url'			=> 'index.php',
				'link_img_url'		=> 'small/layout_content.png',
				'link_img_width'	=> 16,
				'link_img_height'	=> 16,
				'link_window'		=> 0,
				'link_groups'		=> 'all',
				'link_order'		=> 3,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 1,
				'link_title'		=> $user->lang['FAQ'],
				'link_url'			=> 'faq.php',
				'link_img_url'		=> 'small/information.png',
				'link_img_width'	=> 16,
				'link_img_height'	=> 16,
				'link_window'		=> 0,
				'link_groups'		=> 'all',
				'link_order'		=> 4,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 1,
				'link_title'		=> $user->lang['SEARCH'],
				'link_url'			=> 'search.php',
				'link_img_url'		=> 'small/zoom.png',
				'link_img_width'	=> 16,
				'link_img_height'	=> 16,
				'link_window'		=> 0,
				'link_groups'		=> '2,4,5,7',
				'link_order'		=> 5,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 1,
				'link_title'		=> $user->lang['P_ADMIN'],
				'link_url'			=> '',
				'link_img_url'		=> 'small/blank.gif',
				'link_img_width'	=> 0,
				'link_img_height'	=> 0,
				'link_window'		=> 0,
				'link_groups'		=> '4,5',
				'link_order'		=> 6,
				'link_type'			=> LIST_CAT,
			),
			array(
				'list_id'			=> 1,
				'link_title'		=> $user->lang['P_MCP'],
				'link_url'			=> 'mcp.php',
				'link_img_url'		=> 'small/shape_square_go.png',
				'link_img_width'	=> 16,
				'link_img_height'	=> 16,
				'link_window'		=> 0,
				'link_groups'		=> '4,5',
				'link_order'		=> 7,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 1,
				'link_title'		=> $user->lang['P_ACP'],
				'link_url'			=> 'adm/index.php',
				'link_img_url'		=> 'small/shape_square_go.png',
				'link_img_width'	=> 16,
				'link_img_height'	=> 16,
				'link_window'		=> 0,
				'link_groups'		=> '5',
				'link_order'		=> 8,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 2,
				'link_title'		=> 'Portal',
				'link_url'			=> 'portal.php',
				'link_img_url'		=> 'big/home.png',
				'link_img_width'	=> 48,
				'link_img_height'	=> 48,
				'link_window'		=> 0,
				'link_groups'		=> 'all',
				'link_order'		=> 1,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 2,
				'link_title'		=> $user->lang['INDEX'],
				'link_url'			=> 'index.php',
				'link_img_url'		=> 'big/documents.png',
				'link_img_width'	=> 48,
				'link_img_height'	=> 48,
				'link_window'		=> 0,
				'link_groups'		=> 'all',
				'link_order'		=> 2,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 2,
				'link_title'		=> $user->lang['FAQ'],
				'link_url'			=> 'faq.php',
				'link_img_url'		=> 'big/float.png',
				'link_img_width'	=> 48,
				'link_img_height'	=> 48,
				'link_window'		=> 0,
				'link_groups'		=> 'all',
				'link_order'		=> 3,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 2,
				'link_title'		=> $user->lang['SEARCH'],
				'link_url'			=> 'search.php',
				'link_img_url'		=> 'big/box.png',
				'link_img_width'	=> 48,
				'link_img_height'	=> 48,
				'link_window'		=> 0,
				'link_groups'		=> 'all',
				'link_order'		=> 4,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 3,
				'link_title'		=> $user->lang['PHPBB_TITLE'],
				'link_url'			=> 'http://www.phpbb.com',
				'link_img_url'		=> 'phpBB.gif',
				'link_img_width'	=> 88,
				'link_img_height'	=> 31,
				'link_window'		=> 0,
				'link_groups'		=> '0',
				'link_order'		=> 1,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 3,
				'link_title'		=> $user->lang['XAMPP_TITLE'],
				'link_url'			=> 'http://www.apachefriends.org/es/xampp.html',
				'link_img_url'		=> 'xampp.gif',
				'link_img_width'	=> 88,
				'link_img_height'	=> 31,
				'link_window'		=> 0,
				'link_groups'		=> '0',
				'link_order'		=> 2,
				'link_type'			=> LIST_LINK,
			),
			array(
				'list_id'			=> 3,
				'link_title'		=> $user->lang['SOURCEFORGE_TITLE'],
				'link_url'			=> 'http://sourceforge.net',
				'link_img_url'		=> 'sourceforge.net.gif',
				'link_img_width'	=> 88,
				'link_img_height'	=> 31,
				'link_window'		=> 0,
				'link_groups'		=> '0',
				'link_order'		=> 3,
				'link_type'			=> LIST_LINK,
			),
		),
	),

	//Define modules to install
	'module_check' => 0, // $this->schema['modules'] array ID to check or false to disable

	'modules' => array(
		array('acp', 0, 'ACP_BLOCKGETS'),
		
		array('acp', 'ACP_BLOCKGETS', 'ACP_BLOCKGETS_GENERAL'),
		array('acp', 'ACP_BLOCKGETS_GENERAL', array(
			'module_basename'	=> 'blockgets',
			'modes'				=> array('config', 'extra'),
		)),
		
		array('acp', 'ACP_BLOCKGETS', 'ACP_BLOCKGETS_LISTS'),
		array('acp', 'ACP_BLOCKGETS_LISTS', array(
			'module_basename'	=> 'blockgets_lists',
			'modes'				=> array('menu', 'banner'),
		)),
		
		array('acp', 'ACP_BLOCKGETS', 'ACP_BLOCKGETS_PAGES'),
		array('acp', 'ACP_BLOCKGETS_PAGES', array(
			'module_basename'	=> 'blockgets_pages',
			'modes'				=> array('pages', 'blocks'),
		)),
	),

	// Define permissions to add and set
	'permission_add' => array(
		array('a_blockgets_manage', true),
		array('u_blockgets_events', true),
	),

	'permission_set' => array(
		array('ROLE_ADMIN_FULL', 'a_blockgets_manage'),
		array('ROLE_USER_FULL', 'u_blockgets_events'),
	)
);
?>
