<?php
/**
*
* @name acp_blockgets.php
* @package acp cBB Blockgets
* @version $Id: acp_blockgets.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_blockgets
{
	var $u_action;

	function main($id, $mode)
	{
		global $phpbb_root_path, $user, $template, $config, $phpEx;
		global $blockgets;
		
		if(!defined('BLG_VERSION'))
		{
			trigger_error('Module not accessible');
		}

		$user->add_lang('mods/' . $blockgets->path . 'acp');

		$this->tpl_name = $blockgets->path . 'acp_blockgets';

		$action = request_var('action', '');
		$action = (isset($_POST['counter_reset']) ? 'counter_reset' : $action);

		$submit = (isset($_POST['submit'])) ? true : false;

		switch($action)
		{
			case 'editor':
				$this->tpl_name		= $blockgets->path . 'acp_editor';
				$this->page_title	= 'BLG_FULL_EDITOR';

				$user->add_lang('posting');
				
				$template->assign_vars(array(
					'BLG_IN_EDITOR'		=> true,
					'MAX_FONT_SIZE'		=> (int) $config['max_post_font_size'],
					'S_BBCODE_ALLOWED'	=> ($config['allow_bbcode']) ? true : false,
					'S_LINKS_ALLOWED'	=> ($config['allow_post_links']) ? true : false,
					'S_SMILIES_ALLOWED'	=> ($config['allow_smilies']) ? true : false,

					'S_KEY'		=> request_var('k', ''),
					'S_FORM'	=> request_var('f', ''),
				));
				
				if($config['allow_smilies'])
				{
					if (!function_exists('generate_smilies'))
					{
						include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
					}
					generate_smilies('inline', 0);
				}
				
				// Build headers
				if(!isset($editor_headers))
				{
					include($phpbb_root_path . $blockgets->path . "includes/default_headers.$phpEx");
				}
				
				foreach($editor_headers as $header)
				{
					call_user_func_array(array($blockgets, 'set_header'), $header);
				}

				return;
			break;

			case 'view_icons':
			case 'view_banners':
				$this->tpl_name		= $blockgets->path . 'acp_icons_view';
				$this->page_title	= 'BLG_IMAGES_TITLE';

				//Get icons and banners
				if($action == 'view_icons')
				{
					$base_dir = $blockgets->path . 'images/icons';
					$icon_ary = array(
						'SMALL_ICONS'	=> $this->get_icons($base_dir, 'small'),
						'BIG_ICONS'		=> $this->get_icons($base_dir, 'big'),
					);
				}
				else
				{
					$icon_ary = array(
						'BANNERS'	=> $this->get_icons($blockgets->path . 'images/banners')
					);
				}

				foreach($icon_ary as $title => $icons)
				{
					$template->assign_block_vars('iconrow', array(
						'S_TITLE'	=> $user->lang[$title],
					));

					foreach($icons as $icon)
					{
						$template->assign_block_vars('iconrow.icon', $icon);
					}
				}

				$template->assign_vars(array(
					'BLG_IN_ADMIN'	=> true,
					'S_KEY'			=> request_var('k', ''),
					'S_FORM'		=> request_var('f', ''),
				));
				return;
			break;

			case 'counter_reset':
				if(confirm_box(true))
				{
					set_config('blg_counter_visit_count', 0);
					set_config('blg_counter_start_date', time());
				}
				else
				{
					confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
						'i'			=> $id,
						'mode'		=> $mode,
						'action'	=> $action,
					)));
				}
			break;
		}

		switch($mode)
		{
			case 'config':
				$display_vars = array(
					'title'	=> 'BLG_CONFIG',
					'vars'	=> array(
						'legend1'					=> 'ACP_BLG_CONFIG',
						'blg_enabled'				=> array('lang' => 'BLG_ENABLED',			'validate' => 'bool',	'type' => 'radio:yes_no'),
						'blg_on_board'				=> array('lang' => 'BLG_ON_BOARD',			'validate' => 'bool',	'type' => 'radio:yes_no'),
						'blg_home_as_principal'		=> array('lang' => 'HOME_AS_PRINCIPAL',		'validate' => 'bool',	'type' => 'radio:yes_no'),
						'blg_collapse_blocks'		=> array('lang' => 'BLG_COLLAPSE',			'validate' => 'bool',	'type' => 'radio:yes_no'),
						'blg_block_autofit'			=> array('lang' => 'BLG_BLOCK_AUTOFIT',		'validate' => 'bool',	'type' => 'radio:yes_no'),
					)
				);
			break;

			case 'extra':
				include($blockgets->root_path . "includes/functions_acp.$phpEx");

				$display_vars = array(
					'title'	=> 'BLG_EXTRA',
					'vars'	=> array(
						'legend1'				=> 'COUNTER',
						'blg_counter_interval'		=> array('lang' => 'COUNTER_INTERVAL',		'validate' => 'int:300:7200',	'type' => 'text:4:5'),
						'blg_counter_reset'			=> array('lang' => 'COUNTER_RESET',			'validate' => 'bool',			'type' => 'custom', 'function' => 'blg_counter_rst'),

						'legend2'				=> 'IMAGE_RESIZE',
						'blg_resize_enabled'		=> array('lang' => 'IMAGE_RESIZE_ENABLED',	'validate' => 'bool',	'type' => 'radio:yes_no'),
						'blg_resize_on_post'		=> array('lang' => 'IMAGE_RESIZE_POST',		'validate' => 'bool',	'type' => 'radio:yes_no'),
						'blg_image_max_width'		=> array('lang' => 'IMAGE_RESIZE_WIDTH',	'validate' => 'int',	'type' => 'text:3:4'),
					)
				);
			break;
		}
		
		$this->page_title = $display_vars['title'] . '_TITLE';

		$cfg_array = (isset($_REQUEST['config'])) ? request_var('config', array('' => '')) : $config;
		$error = array();

		// We validate the complete config if whished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);

		// Do not write values if there is an error
		if(sizeof($error))
		{
			$submit = false;
		}

		// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
		foreach ($display_vars['vars'] as $config_name => $null)
		{
			if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
			{
				continue;
			}

			if ($submit)
			{
				set_config($config_name, $cfg_array[$config_name]);
			}
			
			$config[$config_name] = $cfg_array[$config_name];
		}

		if ($submit)
		{
			add_log('admin', 'LOG_BLG_CONFIG');
			$template->assign_var('NOTICE', $user->lang['BLG_CONFIG_UPDATED']);
		}

		// Check version
		if($mode == 'config')
		{
			if (($latest_version_info = $this->obtain_latest_version_info(request_var('versioncheck_force', false))) !== false)
			{
				$latest_version_info = explode("\n", $latest_version_info, 2);

				$latest_version = trim($latest_version_info[0]);
				$current_version = (isset($config['blg_version']) ? $config['blg_version'] : '1.0.0');

				$template->assign_vars(array(
					'S_VERSION_NOT_UP_TO_DATE'	=> version_compare($current_version, $latest_version, '<') ? true : false,

					'U_VERSIONCHECK_FORCE'	=> $this->u_action . '&amp;versioncheck_force=1',
					'U_MORE_INFORMATION'	=> (isset($latest_version_info[1]) ? trim($latest_version_info[1]) : ''),
				));
			}
		}
		
		$template->assign_vars(array(
			'BLG_IN_ADMIN'		=> true,

			'L_TITLE'			=> $user->lang[$this->page_title],
			'L_TITLE_EXPLAIN'	=> $user->lang[$display_vars['title'] . '_EXPLAIN'],

			'U_ACTION'			=> $this->u_action,
		));
		
		if(sizeof($error))
		{
			$template->assign_vars(array(
				'NOTICE_ERROR'	=> true,
				'NOTICE'		=> implode('<br />', $error),
			));
		}

		foreach($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);
				continue;
			}

			$type = explode(':', $vars['type']);

			$content = build_cfg_template($type, $config_key, $config, $config_key, $vars);
			if (empty($content))
			{
				continue;
			}

			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'		=> (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '',
				'CONTENT'		=> $content,
			));

			unset($display_vars['vars'][$config_key]);
		}
	}

	function get_icons($path = '', $subpath = '')
	{
		global $phpbb_root_path;

		if(!$path)
		{
			return array();
		}

		if ($dir = @opendir($phpbb_root_path . $path . '/' . $subpath))
		{
			$block_images = array();
			while (($file = readdir($dir)) !== false)
			{
				if (preg_match('#^([^&\'"<>]+)\.(?:gif|png|jpg|jpeg)$#i', $file, $match))
				{
					$block_images[$file] = array(
						'FILE'		=> $subpath . '/' . $file,
						'NAME'		=> ucfirst(str_replace('_', ' ', $match[1])),
						'FILENAME'	=> $phpbb_root_path . $path . (($subpath) ? "/$subpath" : '') . '/' . $file,
					);
				}
			}
			closedir($dir);
			asort($block_images);
		}

		return $block_images;
	}

	/**
	 * Obtains the latest version information of cBB Blockgets
	 *
	 * @param bool $force_update Ignores cached data. Defaults to false.
	 * @param int $ttl Cache version information for $ttl seconds. Defaults to 259200 (72 hours).
	 *
	 * @return string | false Version info on success, false on failure.
	 */
	function obtain_latest_version_info($force_update = false, $ttl = 259200)
	{
		global $cache;

		$info = $cache->get('blg_versioncheck');

		if ($info === false || $force_update)
		{
			$errstr = '';
			$errno = 0;

			$info = get_remote_file('canidev.com', '/app/info', 'cbb-blockgets-10x.txt', $errstr, $errno);

			if ($info === false)
			{
				$cache->destroy('blg_versioncheck');
				return false;
			}

			$cache->put('blg_versioncheck', $info, $ttl);
		}

		return $info;
	}
}
?>
