<?php
/**
*
* @name acp_blockgets_lists.php
* @package acp cBB Blockgets
* @version $Id: acp_blockgets_lists.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_blockgets_lists
{
	var $u_action;

	function main($id, $mode)
	{
		global $phpbb_root_path, $db, $user, $template, $blockgets, $phpEx;
		
		if(!defined('BLG_VERSION'))
		{
			trigger_error('Module not accessible');
		}

		$user->add_lang('mods/' . $blockgets->path . 'acp');

		$action = request_var('action', '');
		$action = (isset($_POST['add_list']) ? 'add_list' : $action);
		$action = (isset($_POST['edit_list_name']) ? 'edit_list_name' : $action);
		$action = (isset($_POST['add_item']) ? 'add_item' : $action);
		$action = (isset($_POST['save_position']) ? 'save_position' : $action);

		$submit = (isset($_POST['submit'])) ? true : false;

		$list_id = request_var('list_id', 0);
		$link_id = request_var('id', 0);
		
		$notice = array();

		switch($mode)
		{
			case 'menu':
				$img_path		= $blockgets->root_path . 'images/icons/';
				$preview_size	= 30;
				
				$f_ary = array(
					LIST_CAT	=> 'CAT',
					LIST_LINK	=> 'LINK'
				);

				$display_vars = array(
					'legend1'			=> 'LIST_LINK_EDIT',
					'link_type'			=> array('lang' => 'LINK_TYPE',		'validate' => 'int',	'type' => 'select',	'function' => 'blg_make_select',	'params' => array($f_ary, '{CONFIG_VALUE}'), 'default' => 1),
					'link_title'		=> array('lang' => 'LINK_TITLE',	'validate' => 'string:1:150',	'type' => 'text:30:150'),
					'link_url'			=> array('lang' => 'LINK_URL',		'validate' => 'string',			'type' => 'text:30:255'),
					'link_img_url'		=> array('lang' => 'IMG_CURRENT',	'type' => 'custom',		'function' => 'blg_img_template',	'params' => array('acp_blockgets_lists', '{KEY}', 'current', '{CONFIG_VALUE}'),	'default' => 'small/blank.gif'),
					'link_img_new'		=> array('lang' => 'IMG_NEW',		'type' => 'custom',		'function' => 'blg_img_template',	'params' => array('acp_blockgets_lists', '{KEY}', 'new', '{CONFIG_VALUE}')),
					'link_groups'		=> array('lang' => 'LINK_GROUP',	'type' => 'custom',		'function' => 'blg_groups_select',	'params' => array('link_groups', '{CONFIG_VALUE}')),
					'link_window'		=> array('lang' => 'LINK_WINDOW',	'validate' => 'bool',	'type' => 'radio:yes_no'),
				);
			break;

			case 'banner':
				$img_path		= $blockgets->root_path . 'images/banners/';
				$preview_size	= 150;

				$display_vars = array(
					'legend1'			=> 'LIST_BANNER_EDIT',
					'link_title'		=> array('lang' => 'BANNER_DESC',	'validate' => 'string',			'type' => 'text:30:255'),
					'link_url'			=> array('lang' => 'BANNER_URL',	'validate' => 'string:1:255',	'type' => 'text:30:255'),
					'link_img_url'		=> array('lang' => 'IMG_CURRENT',	'type' => 'custom',		'function' => 'blg_img_template',	'params' => array('acp_blockgets_lists', '{KEY}', 'current', '{CONFIG_VALUE}', 'view_banners'),	'default' => 'no_image.gif'),
					'link_img_new'		=> array('lang' => 'IMG_NEW',		'type' => 'custom',		'function' => 'blg_img_template',	'params' => array('acp_blockgets_lists', '{KEY}', 'new', '{CONFIG_VALUE}', 'view_banners')),
				);
			break;
		}

		switch($action)
		{
			case 'delete_item':
				if(!$link_id)
				{
					break;
				}

				//Get some item data before remove
				$sql = 'SELECT list_id
					FROM ' . BLG_LISTS_DATA_TABLE . "
					WHERE link_id = $link_id";
				$result = $db->sql_query($sql);
				$list_id = (int)$db->sql_fetchfield('list_id');
				$db->sql_freeresult($result);

				//Remove the item
				$sql = 'DELETE FROM '. BLG_LISTS_DATA_TABLE . "
					WHERE link_id = $link_id";
				$db->sql_query($sql);

				// Reajust the order of the items in the same list, prevent errors
				$sql = 'SELECT link_id
					FROM ' . BLG_LISTS_DATA_TABLE . "
					WHERE list_id = $list_id
					ORDER BY link_order ASC";
				$result = $db->sql_query($sql);

				$links = array();
				while($row = $db->sql_fetchrow($result))
				{
					$links[] = $row['link_id'];
				}
				$db->sql_freeresult($result);

				if(!empty($links))
				{
					foreach($links as $id => $link)
					{
						$sql = 'UPDATE ' . BLG_LISTS_DATA_TABLE . '
							SET link_order = ' . ($id + 1) . "
							WHERE link_id = $link
							AND list_id = $list_id";
						$db->sql_query($sql);
					}
				}

				$notice = array('ITEM_REMOVED', false);

			// no break;

			case 'save_position':
				$item_positions = request_var('item', array(0 => 0));

				if($action == 'save_position' && !empty($item_positions))
				{
					$notice = array('ITEM_POSITION_UPDATED', false);
					$error = false;

					foreach($item_positions as $position => $link_id)
					{
						$sql = 'UPDATE ' . BLG_LISTS_DATA_TABLE . '
							SET link_order = ' . ((int)$position + 1) . "
							WHERE link_id = $link_id
							AND list_id = $list_id";

						if(!$db->sql_query($sql))
						{
							$error = true; 
							break;
						}
					}

					if($error)
					{
						$notice = array('ITEM_POSITION_NOT_UPDATED', true);
					}
				}
			
			//no break

			case 'edit_list':
				if(!$list_id)
				{
					$action = '';
					break;
				}

				$item_ary = array();

				// Get the list name
				$sql = 'SELECT list_name
					FROM ' . BLG_LISTS_TABLE . "
					WHERE list_id = $list_id";
				$result = $db->sql_query($sql);
				$list_name = $db->sql_fetchfield('list_name');
				$db->sql_freeresult($result);


				$sql = 'SELECT *
					FROM ' . BLG_LISTS_DATA_TABLE . "
					WHERE list_id = $list_id
					ORDER BY link_order ASC";

				$result = $db->sql_query($sql);

				while($row = $db->sql_fetchrow($result))
				{
					if($row['link_img_url'])
					{
						build_img_path($row['link_img_url'], $img_path, false);

						$item_img_size = '';
						$item_img_size .= $this->build_img_size($row['link_img_width'], $preview_size, 'width');
						$item_img_size .= $this->build_img_size($row['link_img_height'], $preview_size, 'height');
					}

					if(isset($user->lang[$row['link_title']]))
					{
						$row['link_title'] = $user->lang[$row['link_title']];
					}

					if($row['link_type'] == LIST_CAT) // is cat
					{
						$item_ary[$row['link_id']] = array(
							'title'		=> $row['link_title'],
							'subtitle'	=> $user->lang['CAT'],
							'img'		=> '',
							'disabled'	=> 1,
						);
					}
					else
					{
						$item_ary[$row['link_id']] = array(
							'title'		=> $row['link_title'],
							'subtitle'	=> $row['link_url'],
							'img'		=> ($row['link_img_url']) ? '<img src="' . $row['link_img_url'] . '" ' . $item_img_size . ' alt="" />' : '',
						);
					}
				}
				$db->sql_freeresult($result);

				foreach($item_ary as $link_id => $item_vars)
				{
					$template->assign_block_vars('item', array(
						'ID'			=> $link_id,
						'TITLE' 		=> $item_vars['title'],
						'SUBTITLE' 		=> $item_vars['subtitle'],
						'IMG' 			=> $item_vars['img'],
						'IS_DISABLED'	=> (isset($item_vars['disabled']) ? true : false),

						'U_EDIT'		=> $this->u_action . '&amp;action=edit_item&amp;id=' . $link_id,
						'U_DELETE'		=> $this->u_action . '&amp;action=delete_item&amp;id=' . $link_id,
					));
				}

				$template->assign_vars(array(
					'S_EDIT_LIST'	=> true,
					'S_LIST_NAME'	=> $list_name,

					'ALLOW_ORDER'	=> true,

					'U_ACTION'		=> $this->u_action . '&amp;action=edit_list&amp;list_id=' . $list_id,
					'U_BACK'		=> $this->u_action,
				));
			break;

			case 'edit_list_name':
				if(!$list_id)
				{
					break;
				}

			// no break

			case 'add_list':
				$list_name = utf8_normalize_nfc(request_var('list_name', '', true));

				if(!$list_name)
				{
					break;
				}

				$sql_ary = array(
					'list_name'	=> $list_name,
					'list_type'	=> $mode,
				);

				if($action == 'add_list')
				{
					$sql = 'INSERT INTO ' . BLG_LISTS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
					$message = 'ADDED';
				}
				else
				{
					$sql = 'UPDATE ' . BLG_LISTS_TABLE . '
						SET ' . $db->sql_build_array('UPDATE', $sql_ary) . "
						WHERE list_id = $list_id";
					$message = 'UPDATED';
				}

				if(!$db->sql_query($sql))
				{
					trigger_error($user->lang['LIST_NOT_' . $message] . adm_back_link($this->u_action), E_USER_WARNING);
				}

				trigger_error($user->lang['LIST_' . $message] . adm_back_link($this->u_action));
			break;

			case 'delete_list':
				if(!$list_id)
				{
					break;
				}

				if (confirm_box(true))
				{
					//Get list name before remove
					$sql = 'SELECT list_name
						FROM ' . BLG_LISTS_TABLE . "
						WHERE list_id = $list_id";
					$result = $db->sql_query($sql);
					$list_name = $db->sql_fetchfield('list_name');
					$db->sql_freeresult($result);

					// Delete all the items in this list
					$db->sql_query('DELETE FROM ' . BLG_LISTS_DATA_TABLE . " WHERE list_id = $list_id");

					// Delete the list entry
					$db->sql_query('DELETE FROM ' . BLG_LISTS_TABLE . " WHERE list_id = $list_id");

					add_log('admin', 'LOG_LIST_REMOVED', $list_name);
					trigger_error($user->lang['LIST_REMOVED'] . adm_back_link($this->u_action));
				}
				else
				{
					confirm_box(false, $user->lang['CONFIRM_DELETE_LIST'], build_hidden_fields(array(
						'list_id'	=> $list_id,
						'action'	=> 'delete_list',
					)));
				}
			break;

			case 'edit_item':
				if(!$link_id)
				{
					$action = '';
					break;
				}

				$sql = 'SELECT *
					FROM ' . BLG_LISTS_DATA_TABLE . "
					WHERE link_id = $link_id";
				$result = $db->sql_query($sql);
				$item_row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				// If no data, quit in this point
				if(!$item_row)
				{
					break;
				}

				$list_id = $item_row['list_id'];

			// no break;

			case 'add_item':
				if(!$list_id)
				{
					$action = '';
					break;
				}

				// Include basic functions
				include($blockgets->root_path . "includes/functions_acp.$phpEx");

				if(!isset($item_row))
				{
					$item_row = array();
				}

				$this->new_config = $item_row;
				$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
				$error = array();

				// We validate the complete config if whished
				validate_config_vars($display_vars, $cfg_array, $error);

				// Do not write values if there is an error
				if(sizeof($error))
				{
					$submit = false;
				}

				// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
				foreach($display_vars as $config_name => $null)
				{
					if(strpos($config_name, 'legend') !== false)
					{
						continue;
					}

					if($config_name == 'link_groups')
					{
						if(!isset($cfg_array[$config_name]) || isset($_POST[$config_name]))
						{
							$cfg_array[$config_name] = request_var($config_name, array(0));
						}

						$all_groups = (isset($_POST['all_groups'])) ? true : false;

						$cfg_array[$config_name] = ($all_groups) ? 'all' : (is_array($cfg_array[$config_name]) ? implode(',', $cfg_array[$config_name]) : $cfg_array[$config_name]);
					}

					if(!isset($cfg_array[$config_name]))
					{
						continue;
					}

					$this->new_config[$config_name] = $cfg_array[$config_name];
				}

				if($submit)
				{
					$sql_ary = $this->new_config;

					$sql_ary['list_id'] = $list_id;
					unset($sql_ary['link_id']);

					switch($mode)
					{
						case 'banner':
							$sql_ary['link_type'] = LIST_LINK;
	
						// no break

						case 'menu':
							$item_img_new = request_var('link_img_new', '');

							if($item_img_new)
							{
								$sql_ary['link_img_url'] = $item_img_new;
							}
						break;
					}

					// if image defined, get its size and include in array
					if(!empty($item_img_new))
					{
						build_img_path($item_img_new, $img_path, false);

						list($sql_ary['link_img_width'], $sql_ary['link_img_height']) = @getimagesize($item_img_new);

						$this->build_img_size($sql_ary['link_img_width'], 200);
						$this->build_img_size($sql_ary['link_img_height'], 200);
					}

					if($action == 'add_item')
					{
						$sql = 'SELECT MAX(link_order) as max_item_order
							FROM ' . BLG_LISTS_DATA_TABLE . "
							WHERE list_id = $list_id";
						$result = $db->sql_query($sql);
						$max_item_order = (int) $db->sql_fetchfield('max_item_order');
						$db->sql_freeresult($result);

						$sql_ary['link_order'] = $max_item_order + 1;
						
						$sql = 'INSERT INTO ' . BLG_LISTS_DATA_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
						$message = 'ADDED';
					}
					else
					{         
						$sql = 'UPDATE ' . BLG_LISTS_DATA_TABLE . '
							SET ' . $db->sql_build_array('UPDATE', $sql_ary) . "
							WHERE link_id = $link_id";
						$message = 'UPDATED';
					}

					$back_link = adm_back_link($this->u_action . '&amp;action=edit_list&amp;list_id=' . $list_id);

					if(!$db->sql_query($sql))
					{
						trigger_error($user->lang["ITEM_NOT_{$message}"] . $back_link, E_USER_WARNING);
					}

					trigger_error($user->lang["ITEM_{$message}"] . $back_link);
				}

				foreach($display_vars as $config_key => $vars)
				{
					if (!is_array($vars) && strpos($config_key, 'legend') === false)
					{
						continue;
					}

					if (strpos($config_key, 'legend') !== false)
					{
						$template->assign_block_vars('options', array(
							'S_LEGEND'		=> true,
							'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
						);
						continue;
					}

					$type = explode(':', $vars['type']);

					$content = build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars);
					if(empty($content))
					{
						continue;
					}

					$template->assign_block_vars('options', array(
						'KEY'			=> $config_key,
						'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
						'S_EXPLAIN'		=> (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '',
						'CONTENT'		=> $content,
					));
				}

				$template->assign_vars(array(
					'S_EDIT_ITEM'		=> true,

					'S_HIDDEN_FIELDS'	=> build_hidden_fields(array(
						'id'			=> $link_id,
						'list_id'		=> $list_id,
						'action'		=> $action,
					)),

					'U_ACTION'			=> $this->u_action,
					'U_BACK'			=> $this->u_action . '&amp;action=edit_list&amp;list_id=' . $list_id,
				));
				
				if(sizeof($error))
				{
					$notice = array(implode('<br />', $error), true);
				}
			break;
		}
		
		if(sizeof($notice))
		{
			$template->assign_vars(array(
				'NOTICE'			=> ($notice[0]) ? $user->lang($notice[0]) : '',
				'NOTICE_ERROR'		=> $notice[1],
			));
		}

		// Get the lists
		if($action != 'edit_list' && $action != 'edit_item')
		{
			$sql = 'SELECT *
				FROM ' . BLG_LISTS_TABLE . "
				WHERE list_type = '$mode'";;
			$result = $db->sql_query($sql);

			while($row = $db->sql_fetchrow($result))
			{
				$template->assign_block_vars('list', array(
					'LIST_NAME' 	=> $row['list_name'],
					'U_EDIT'		=> $this->u_action . '&amp;action=edit_list&amp;list_id=' . $row['list_id'],
					'U_DELETE'		=> $this->u_action . '&amp;action=delete_list&amp;list_id=' . $row['list_id'],
				));
			}
			$db->sql_freeresult($result);
		}

		$s_title = strtoupper($mode);

		$template->assign_vars(array(
			'BLG_IN_ADMIN'			=> true,

			'L_LIST_TITLE'			=> $user->lang["BLG_{$s_title}_TITLE"],
			'L_LIST_TITLE_EXPLAIN'	=> $user->lang["BLG_{$s_title}_TITLE_EXPLAIN"],
			'L_ADD_ITEM'			=> $user->lang[$s_title . '_ADD'],
			'L_MANAGE_ITEMS'		=> $user->lang["MANAGE_{$s_title}_ITEMS"],
			'L_SAVE_ITEM_POSITION'	=> $user->lang["SAVE_{$s_title}_POSITION"],
		));

		$this->tpl_name		= $blockgets->path . 'acp_blockgets_lists';
		$this->page_title	= "BLG_{$s_title}_TITLE";
	}
	
	/**
	 * build_img_size
	 * Adjust the image size
	 *
	 * @param int $size . The original img size
	 * @param int $maxsize . The max size allowed to the image display
	 * @param string $string . Defines the param name to apply directly into html img element (for return as a string and not as number)
	 * @return string|number . The final size
	*/
	function build_img_size(&$size, $maxsize, $string = '')
	{
		if($size == null)
		{
			$size = 0;
		}
	
		if(!empty($string))
		{
			if($size > $maxsize)
			{
				return $string . '"' . $maxsize . '" ';
			}
			return '';
		}
		else if($size > $maxsize)
		{
			$size = $maxsize;
		}
	}
}
?>
