<?php
/**
*
* @name acp_blockgets_pages.php
* @package acp cBB Blockgets
* @version $Id: acp_blockgets_pages.php,v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_blockgets_pages
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $template, $user, $phpbb_admin_path, $phpbb_root_path, $phpEx;
		global $blockgets;
		
		if(!defined('BLG_VERSION'))
		{
			trigger_error('Module not accessible');
		}
		
		include($blockgets->root_path . "includes/functions_acp.$phpEx");

		$this->tpl_name	= $blockgets->path . 'acp_blockgets_pages';
		$user->add_lang('mods/' . $blockgets->path . 'acp');
		
		$page_id 	= request_var('p', 0);
		$block_ids	= (isset($_POST['block_id_list']) ? request_var('block_id_list', array(0)) : array(request_var('b', 0)));
		$board_url	= $blockgets->get_board_path('board_url');
		
		$action	= request_var('action', '');
		$action = (isset($_POST['add']) ? 'add' : $action);

		$submit	= (isset($_POST['submit']) ? true : false);
		
		$template->assign_vars(array(
			'BLG_IN_ADMIN'		=> true,
			'ICON_DISABLE'		=> '<img src="' . $phpbb_admin_path . 'images/blockgets/offline.png" alt="' . $user->lang['DISABLE_BLOCK'] . '" title="' . $user->lang['DISABLE_BLOCK'] . '" />',
			'ICON_ENABLE'		=> '<img src="' . $phpbb_admin_path . 'images/blockgets/online.png" alt="' . $user->lang['ENABLE_BLOCK'] . '" title="' . $user->lang['ENABLE_BLOCK'] . '" />',
			'ICON_MANAGE'		=> '<img src="' . $phpbb_admin_path . 'images/blockgets/manage.png" alt="' . $user->lang['MANAGE'] . '" title="' . $user->lang['MANAGE'] . '" />',
		));
		
		// Execute ajax request if needed
		$blockgets->parse_ajax();

		switch($mode)
		{
			case 'blocks':
				$this->page_title = 'ACP_MANAGE_BLOCKS';

				if($this->manage_block($block_ids, $page_id, $action, $submit) !== false)
				{
					return;
				}
				
				if(!$page_id)
				{
					$page_ary = $this->obtain_pagelist();
					$page_options = array();

					foreach($page_ary as $page_type => $rows)
					{
						foreach($rows as $row_id => $row)
						{
							if(!$row_id)
							{
								$page_options['legend' . $page_type] = $row;
								continue;
							}
							
							$page_options[$row['page_id']] = $row['page_title'];
						}
					}
					
					$template->assign_vars(array(
						'L_TITLE'			=> $user->lang['ACP_MANAGE_BLOCKS'],
						'L_TITLE_EXPLAIN'	=> $user->lang['PAGES_SELECT_TITLE_EXPLAIN'],

						'S_SELECT_PAGE'		=> true,
						'S_PAGE_OPTIONS'	=> blg_make_select($page_options),
					));
					
					break;
				}

				// Get page data
				$sql = 'SELECT *
					FROM ' . BLG_PAGES_TABLE . "
					WHERE page_id = $page_id";
				$result = $db->sql_query($sql);
				$page_data = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				
				// If no page, redirect to page's list
				if(!$page_data)
				{
					redirect(append_sid("{$phpbb_admin_path}index.$phpEx", 'i=blockgets_pages&amp;mode=pages'));
				}
				
				$blocks_dir = $blockgets->root_path . 'block/';
				$has_forum_block = false;
				$block_row = array();

				// Load the blocks
				$sql = 'SELECT *
					FROM ' . BLG_BLOCK_TABLE . "
					WHERE block_page = $page_id
					ORDER BY block_order ASC";
					
				$result_block = $db->sql_query($sql);
				
				while($row = $db->sql_fetchrow($result_block))
				{
					$block_row[] = $row;
					
					if($row['block_alias'] == 'forum_content')
					{
						$has_forum_block = true;
					}
				}
				$db->sql_freeresult($result_block);
				
				/* If is a forum page and not block with forum content present, create it */
				if($page_data['page_type'] == PAGE_FORUM && !$has_forum_block)
				{
					$block_row[] = $this->insert_forum_block($page_id);
				}
				
				foreach($block_row as $row)
				{
					$block_filename = $blocks_dir . $row['block_alias'] . ".$phpEx";

					if($row['block_position'] && $row['block_position'] > 0 && $row['block_position'] < 6)
					{
						$block_position_name = $blockgets->block_position_names[$row['block_position']] . '_block';
						$block_action = $this->u_action . '&amp;p=' . $page_id . '&amp;b=' . $row['block_id'] . '&amp;action=';

						// Put block into general template to display
						$template->assign_block_vars($block_position_name, array(
							'BLOCK_ID'			=> $row['block_id'],
							'BLOCK_TITLE'		=> (isset($user->lang[$row['block_title']]) ? $user->lang[$row['block_title']] : $row['block_title']),
							'BLOCK_ENABLED'		=> $row['block_enabled'],

							'IS_FORUM'		=> ($block_position_name == 'center_block' && $row['block_alias'] == 'forum_content') ? true : false,

							'U_DISABLE'		=> $block_action . 'disable',
							'U_ENABLE'		=> $block_action . 'enable',
							'U_EDIT'		=> $block_action . 'edit',
							'U_DELETE'		=> $block_action . 'delete',

							'S_HIDDEN_FIELDS'	=> '<input type="hidden" name="' . $block_position_name . '[]" value="' . $row['block_id'] . '" />',
						));
					}
				}
				
				// Read all the avaliable blocks
				if($dir = @opendir($blocks_dir))
				{
					$block_html = array();
					
					/* Initialize block class to parse blocks's lang */
					$block = new blockgets_block();

					while (($file = @readdir($dir)) !== false)
					{
						if (preg_match('#^(([^&\'"<>]+)_(block|addon)+)\.php$#i', $file, $match))
						{
							/* Add lang if neccessary */
							$block->setup($match[1]);
		
							$block_html[$match[1]] = $this->get_block_info($match[2], $match[3]);
						}
					}
					closedir($dir);
					unset($block);
					
					asort($block_html);
				}

				foreach ($block_html as $alias => $info)
				{
					$s_img = $phpbb_admin_path . 'images/' . $blockgets->path . 'block/' . $alias . '.png';
					
					if(!file_exists($s_img))
					{
						$s_img = $phpbb_admin_path . 'images/' . $blockgets->path . 'block/undefined_' . $info['type'] . '.png';
					}
					
					$template->assign_block_vars('block_alias', array(
						'S_VALUE' 		=> $alias,
						'S_TITLE' 		=> $info['title'],
						'S_EXPLAIN'		=> $info['explain'],
						'S_IMG'			=> $s_img,
					));
				}	
				unset($block_html);
				
				$page_title = $page_data['page_title'];
				$page_title = (isset($user->lang[$page_title]) ? $user->lang[$page_title] : $page_title);
				
				$template->assign_vars(array(
					'L_TITLE'			=> $user->lang('PAGES_BLOCKS_TITLE', $page_title),
					'L_TITLE_EXPLAIN'	=> $user->lang('PAGES_BLOCKS_TITLE_EXPLAIN', $page_title),
					'S_BLOCK_LIST'		=> true,

					'S_HIDDEN_FIELDS'	=> build_hidden_fields(array(
						'p'				=> $page_id,
						'action'		=> '',
						'block_alias'	=> '',
					)),
					
					'U_BACK'		=> $this->u_action,
					'U_ACTION'		=> $this->u_action . '&amp;p=' . $page_id,
				));
			break;

			case 'pages':
				$this->page_title = 'ACP_MANAGE_PAGES';

				if($this->manage_page($page_id, $action, $submit) !== false)
				{
					return;
				}
				
				$page_ary = $this->obtain_pagelist();

				foreach($page_ary as $page_type => $rows)
				{
					foreach($rows as $row_id => $row)
					{
						if(!$row_id)
						{
							$template->assign_block_vars('pagerow', array(
								'S_LEGEND'		=> $user->lang[$row],
								'S_EXPLAIN'		=> $user->lang[$row . '_EXPLAIN'],
							));
							
							continue;
						}
						
						$s_url = $board_url;
						
						switch($page_type)
						{
							case PAGE_HOME:
							case PAGE_CUSTOM:
								$s_url .= (($blockgets->home_path != './') ? $blockgets->home_path : '') . $blockgets->home_page;
								
								if($page_type == PAGE_CUSTOM)
								{
									$s_url .= '?p=' . (($row['page_alias']) ? $row['page_alias'] : $row['page_id']);
								}
							break;
							
							case PAGE_FORUM:
								$s_url .= $row['page_alias'] . ".$phpEx";
							break;
						}

						$template->assign_block_vars('pagerow', array(
							'S_PAGE_TITLE'		=> (isset($user->lang[$row['page_title']]) ? $user->lang[$row['page_title']] : $row['page_title']),
							'S_URL'				=> $s_url,
							
							'U_EDIT'			=> $this->u_action . '&amp;action=edit&amp;p=' . $row['page_id'],
							'U_DELETE'			=> ($page_type != PAGE_HOME) ? $this->u_action . '&amp;action=delete&amp;p=' . $row['page_id'] : '',
							'U_MANAGE'			=> append_sid("{$phpbb_admin_path}index.$phpEx", 'i=blockgets_pages&amp;mode=blocks&amp;p=' . $row['page_id']),
						));
					}
				}
	
				$template->assign_vars(array(
					'L_TITLE'			=> $user->lang['ACP_MANAGE_PAGES'],
					'L_TITLE_EXPLAIN'	=> $user->lang['PAGES_TITLE_EXPLAIN'],
					'S_PAGE_LIST'		=> true,
				));
			break;
		}
	}
	
	function obtain_pagelist($ignore_ids = false)
	{
		global $db;

		$page_ary = array(
			PAGE_HOME		=> array('PAGE_HOME'),
			PAGE_FORUM		=> array('PAGE_FORUM'),
			PAGE_CUSTOM		=> array('PAGE_CUSTOM'),
		);
		
		$sql = 'SELECT *
			FROM ' . BLG_PAGES_TABLE . '
			ORDER BY page_type, page_title';
		$result = $db->sql_query($sql);
		while($row = $db->sql_fetchrow($result))
		{
			if($ignore_ids === false || !in_array($row['page_id'], $ignore_ids))
			{
				$page_ary[$row['page_type']][] = $row;
			}
		}
		$db->sql_freeresult($result);
		
		// Remove empty groups of pages
		foreach($page_ary as $page_type => $page_data)
		{
			if(sizeof($page_data) == 1)
			{
				unset($page_ary[$page_type]);
			}
		}
		
		return $page_ary;
	}
	
	function manage_page($page_id, $action, $submit)
	{
		global $db, $template, $user, $config, $cache, $phpbb_admin_path, $phpEx, $blockgets;

		if(!$page_id && $action != 'add')
		{
			return false;
		}
		
		$error = array();
		
		$display_vars = array(
			'legend1'			=> 'MANAGE_PAGE',
			'page_enabled'		=> array('lang' => 'PAGE_ENABLED',		'validate' => 'bool',	'type' => 'radio:yes_no'),
			'page_file'			=> array('lang' => 'PAGE_FILE',			'validate' => 'string',			'type' => 'select',		'method' => 'build_file_select'),
			'page_alias'		=> array('lang' => 'PAGE_ALIAS',		'validate' => 'string',			'type' => 'text:40:200'),
			'page_title'		=> array('lang' => 'PAGE_TITLE',		'validate' => 'string:0:200',	'type' => 'text:40:255'),
			'page_groups'		=> array('lang' => 'PAGE_GROUP',		'type' => 'custom',		'function' => 'blg_groups_select',	'params' => array('page_groups', '{CONFIG_VALUE}')),
			'page_header'		=> array('lang' => 'SHOW_HEADER',		'validate' => 'bool',	'type' => 'radio:yes_no'),
			'page_background'	=> array('lang' => 'PAGE_BACKGROUND',	'validate' => 'string',	'type' => 'text:40:255'),
			'page_sliderbars'	=> array('lang' => 'PAGE_SLIDERBARS',	'validate' => 'bool',	'type' => 'radio:yes_no'),
			
			'legend2'				=> 'COLUMN_SETTINGS',
			'left_column_width'		=> array('lang' => 'LEFT_COLUMN',	'validate' => 'int',	'type' => 'text:4:3'),
			'right_column_width'	=> array('lang' => 'RIGHT_COLUMN',	'validate' => 'int',	'type' => 'text:4:3'),
		);

		switch($action)
		{
			case 'edit':
				$sql = 'SELECT *
					FROM ' . BLG_PAGES_TABLE . "
					WHERE page_id = $page_id";
				$result = $db->sql_query($sql);
				$page_data = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				
				if(!$page_data)
				{
					return false;
				}
				unset($page_data['page_id']);
				
				// Ok, unset some variables
				switch($page_data['page_type'])
				{
					case PAGE_FORUM:
						unset($display_vars['page_title']);
					// no break

					case PAGE_HOME:
						unset($display_vars['page_alias']);
					break;
				}
				
				unset($display_vars['page_file']);

			// no break;

			case 'add':
				if($action == 'add')
				{
					// Default data for new pages
					$page_data = array(
						'page_type'		=> PAGE_CUSTOM,
						'page_alias'	=> '',
						'page_title'	=> '',
						'page_enabled'	=> 1,
						'page_groups'	=> 'all',
						
						'left_column_width'		=> 180,
						'right_column_width'	=> 180,
						'page_header'			=> 1,
						'page_sliderbars'		=> 1,
					);
				}

				if(isset($_REQUEST['config']))
				{
					$page_data = array_merge($page_data, utf8_normalize_nfc(request_var('config', array('' => ''), true)));
					$page_data['page_groups'] = request_var('page_groups', array(0));
				}

				if($submit)
				{
					// We validate the complete config if whished
					validate_config_vars($display_vars, $page_data, $error);
					
					/* check the page alias */
					if($page_data['page_alias'])
					{
						$valid_alias = false;

						if(preg_match('#^([a-z0-9_-]+)$#', $page_data['page_alias']))
						{
							$sql = 'SELECT page_id
								FROM ' . BLG_PAGES_TABLE . "
								WHERE page_alias = '" . $db->sql_escape($page_data['page_alias']) . "'
								AND page_id <> " . $page_id;
							$result = $db->sql_query($sql);
							$alias_page_id = (int)$db->sql_fetchfield('page_id');
							$db->sql_freeresult($result);
							
							if(!$alias_page_id)
							{
								$valid_alias = true;
							}
						}
						
						if(!$valid_alias)
						{
							$error[] = $user->lang['PAGE_ALIAS_ERROR'];	
						}
					}
				}

				// Do not write values if there is an error
				if(sizeof($error))
				{
					$submit = false;
				}

				if ($submit)
				{
					$message_links = '';
					$page_data['page_groups'] = (isset($_POST['all_groups']) ? 'all' : implode(',', $page_data['page_groups']));

					/* Set the page type */
					if(isset($page_data['page_file']))
					{
						if($page_data['page_file'])
						{
							$page_data = array_merge($page_data, array(
								'page_type'		=> PAGE_FORUM,
								'page_alias'	=> $page_data['page_file'],
								'page_title'	=> strtoupper($page_data['page_file']),
							));
						}
						
						unset($page_data['page_file']);
					}

					if($action == 'add')
					{
						$sql = 'INSERT INTO ' . BLG_PAGES_TABLE . $db->sql_build_array('INSERT', $page_data);
						$message = 'ADDED';
					}
					else
					{
		            	$sql = 'UPDATE ' . BLG_PAGES_TABLE . '
							SET ' . $db->sql_build_array('UPDATE', $page_data) . "
							WHERE page_id = $page_id";

		                $message = 'UPDATED';
					}
					
					$db->sql_query($sql);
					
					// Set the global values if needed
					switch($page_data['page_type'])
					{
						case PAGE_HOME:
							set_config('blg_home_enabled', $page_data['page_enabled']);
							set_config('blg_home_title', $page_data['page_title']);
						break;
						
						case PAGE_FORUM:
							/* Insert forum content block if neccessary */
							if($action == 'add')
							{
								$page_id = $db->sql_nextid();
								$this->insert_forum_block($page_id, true);
							}
						break;
					}
					
					$cache->destroy('_blockgets_pages');
	
					add_log('admin', "LOG_PAGE_$message", $user->lang($page_data['page_title']));
					$template->assign_var('NOTICE', $user->lang["PAGE_$message"]);

					return false;
				}
		
				foreach($display_vars as $config_key => $vars)
				{
					if (strpos($config_key, 'legend') !== false)
					{
						$template->assign_block_vars('options', array(
							'S_LEGEND'		=> true,
							'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
						);
						continue;
					}
		
					$type = explode(':', $vars['type']);
		
					$content = build_cfg_template($type, $config_key, $page_data, $config_key, $vars);
					if (empty($content))
					{
						continue;
					}
		
					$template->assign_block_vars('options', array(
						'KEY'			=> $config_key,
						'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
						'S_EXPLAIN'		=> (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '',
						'CONTENT'		=> $content,
					));
		
					unset($display_vars[$config_key]);
				}
				
				$title = 'PAGES_' . strtoupper($action) . '_TITLE';
				$page_title = (isset($user->lang[$page_data['page_title']]) ? $user->lang[$page_data['page_title']] : $page_data['page_title']);
				
				$template->assign_vars(array(
					'L_TITLE'			=> $user->lang($title, $page_title),
					'L_TITLE_EXPLAIN'	=> $user->lang[$title . '_EXPLAIN'],
				));
			break;
		
			case 'delete':
				if (confirm_box(true))
				{
					//Get the page title before remove
					$sql = 'SELECT page_title
						FROM ' . BLG_PAGES_TABLE . "
						WHERE page_id = $page_id";
					$result = $db->sql_query($sql);
					$page_title = $db->sql_fetchfield('page_title');
					$db->sql_freeresult($result);
					
					// Remove the page blocks
					$sql = 'DELETE FROM ' . BLG_BLOCK_TABLE . "
						WHERE block_page = $page_id";
					$db->sql_query($sql);

					// Remove the page
					$sql = 'DELETE FROM ' . BLG_PAGES_TABLE . "
						WHERE page_id = $page_id";
					$db->sql_query($sql);
					
					$cache->destroy('_blockgets_pages');

					add_log('admin', 'LOG_PAGE_REMOVED', $page_title);
					$template->assign_var('NOTICE', $user->lang['PAGE_REMOVED']);

					return false;
				}
				else
				{
					confirm_box(false, $user->lang['CONFIRM_PAGE_DELETE'], build_hidden_fields(array(
						'p'			=> $page_id,
						'action'	=> 'delete',
					)));
					
					return false;
				}
			break;
		}
		
		$template->assign_vars(array(
			'S_MANAGE_PAGE'		=> true,
			'S_PAGE_FILE_ALERT'	=> $user->lang('PAGE_FILE_ALERT', 'http://www.canidev.com/docs.php?i=cbb-blockgets-v' . $config['blg_version'] . '#page_file'),

			'S_HIDDEN_FIELDS'	=> build_hidden_fields(array(
				'p'			=> $page_id,
				'action'	=> $action,
			)),

			'U_BACK'		=> $this->u_action,
		));
		
		if(sizeof($error))
		{
			$template->assign_vars(array(
				'NOTICE'		=> implode('<br />', $error),
				'NOTICE_ERROR'	=> true,
			));
		}
		
		return true;
	}
	
	function manage_block($block_ids, $page_id, $action, $submit)
	{
		global $db, $user, $template, $phpbb_root_path, $phpEx, $blockgets;

		if(empty($block_ids[0]) && ($action != 'add' && $action != 'save_position'))
		{
			return false;
		}

		$error = array();
		
		$style_options = array(
			BLOCK_STYLE_DEFAULT			=> 'STYLE_DEFAULT',
			BLOCK_STYLE_ALTERNATIVE		=> 'STYLE_ALTERNATIVE',
			BLOCK_STYLE_CONTENT_FULL	=> 'STYLE_CONTENT_FULL',
			BLOCK_STYLE_CONTENT_SIMPLE	=> 'STYLE_CONTENT_SIMPLE',
		);
		
		$display_vars = array(
			'legend1'			=> 'BLOCK_SETTINGS',
			'block_title'		=> array('lang' => 'BLOCK_TITLE',		'validate' => 'string:1:100',	'type' => 'text:30:100'),

			'block_img'			=> array('lang' => 'BLOCK_CURRENT_ICON',	'type' => 'custom',		'function' => 'blg_img_template',	'params' => array('acp_block_form', '{KEY}', 'current', '{CONFIG_VALUE}', 'view_icons', 'ICON'),	'default' => 'small/blank.gif'),
			'block_img_new'		=> array('lang' => 'BLOCK_NEW_ICON',		'type' => 'custom',		'function' => 'blg_img_template',	'params' => array('acp_block_form', '{KEY}', 'new', '{CONFIG_VALUE}', 'view_icons', 'ICON')),
			'block_groups'		=> array('lang' => 'BLOCK_GROUP',		'type' => 'custom',		'function' => 'blg_groups_select',	'params' => array('block_groups', '{CONFIG_VALUE}'),	'default' => 'all'),
			'block_enabled'		=> array('lang' => 'BLOCK_ENABLED',		'validate' => 'bool',	'type' => 'radio:yes_no',	'default' => 1),
			'allow_collapse'	=> array('lang' => 'BLOCK_COLLAPSE',	'validate' => 'bool',	'type' => 'radio:yes_no',	'default' => 1),
			'block_style'		=> array('lang' => 'BLOCK_STYLE',		'type' => 'select',		'function' => 'blg_make_select',		'params' => array($style_options, '{CONFIG_VALUE}'),	'default' => 1),
		);
		
		if(!$submit && !in_array($action, array('enable', 'disable', 'remove', 'move')))
		{
			$this->u_action .= '&amp;p=' . $page_id;
		}
		
		/* Obtain the page title for logs */
		$sql = 'SELECT page_title
			FROM ' . BLG_PAGES_TABLE . "
			WHERE page_id = $page_id";
		$result = $db->sql_query($sql);
		$page_title = $db->sql_fetchfield('page_title');
		$db->sql_freeresult($result);
		
		$page_title = $user->lang($page_title);

		switch($action)
		{
			case 'edit':
				//Get the block data
				$sql = 'SELECT *
					FROM ' . BLG_BLOCK_TABLE . '
					WHERE block_id = ' . $block_ids[0];
				$result = $db->sql_query($sql);
				$block_data = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				//If no data, exit in this point
				if(!$block_data || $block_data['block_alias'] == 'forum_content')
				{
					break;
				}

				$page_id = (int)$block_data['block_page'];

			// no break;

			case 'add':
				$user->add_lang('mods/' . $blockgets->path . 'acp_blocks');
				
				if($action == 'add')
				{
					$block_alias = request_var('block_alias', '');
					
					if(!preg_match('#^([^&\'"<>]+)_(block|addon)+$#i', $block_alias, $match))
					{
						return false;
					}

					$block_info = $this->get_block_info($match[1], $match[2]);
					
					// Default data for new blocks
					$block_data = array(
						'block_id'			=> 0,
						'block_title'		=> $block_info['title'],
						'block_alias'		=> $block_alias,
						'block_content'		=> '',
						'block_page'		=> $page_id,
						'block_position'	=> 0,
						'allow_collapse'	=> 1,
						'block_style'		=> BLOCK_STYLE_DEFAULT,
						'bbcode_bitfield'	=> '',
						'bbcode_uid'		=> '',
					);

					$display_vars += array(
						'block_position'	=> array('lang' => 'BLOCK_POSITION',	'type' => 'select',		'method' => 'block_position_select',	'params' => array('{CONFIG_VALUE}')),
					);
				}
				
				$cfg_array = $block_data;

				if(isset($_REQUEST['config']))
				{
					$cfg_array = array_merge($cfg_array, utf8_normalize_nfc(request_var('config', array('' => ''), true)));
					$cfg_array['block_groups'] = request_var('block_groups', array(0));
				}
				
				$class_name		= $block_data['block_alias'];
				$block_filename	= $blockgets->root_path . "block/$class_name.$phpEx";

				if(file_exists($block_filename) && !class_exists($class_name))
				{
					include($block_filename);
				}

				if(!class_exists($class_name))
				{
					trigger_error($user->lang['BLOCK_NOT_EXISTS'] . adm_back_link($this->u_action), E_USER_WARNING);
				}
				
				// Initialize the block class
				$block_class = new $class_name($block_data);
				
				// Check for block requirements at install if neccesary
				if($action == 'add' && method_exists($block_class, 'check'))
				{
					if(!$block_class->check())
					{
						trigger_error($user->lang['BLOCK_NEED_REQUIREMENTS'] . adm_back_link($this->u_action), E_USER_WARNING);
					}
				}
				
				// Get extra vars and config from the block
				$has_config = $block_class->get_config();

				if($has_config && is_array($block_class->display_vars))
				{
					$display_vars['legend2'] = 'BLOCK_CONTENT_HEADER';
					$display_vars += $block_class->display_vars;
					
					// Load separate language file if exists (for addons)
					$block_class->setup($class_name);
				}
				
				$block_class->configure('validate', $block_data, $cfg_array, $submit);

				// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
				foreach($display_vars as $config_name => $vars)
				{
					if(strpos($config_name, 'legend') !== false)
					{
						continue;
					}

					if(!isset($cfg_array[$config_name]) && isset($vars['default']))
					{
						$cfg_array[$config_name] = $vars['default'];
						continue;
					}
				}
	
				if($submit)
				{
					// We validate the complete config if whished
					validate_config_vars($display_vars, $cfg_array, $error);

					// Do not write values if there is an error
					if(sizeof($error))
					{
						$submit = false;
					}
				}
				
				// Check the block extra config
				if($submit)
				{
					$block_class->configure('submit', $block_data, $cfg_array, $submit);
				}
				
				// Save the changes
				if($submit)
				{
					$new_img = request_var('block_img_new', '');

					$sql_ary = array(
						'block_title'		=> $cfg_array['block_title'],
						'block_content'		=> (isset($cfg_array['block_content']) ? $cfg_array['block_content'] : $block_data['block_content']),
						'block_alias'		=> $block_data['block_alias'],
						'block_img'			=> ($new_img) ? $new_img : $cfg_array['block_img'],
						'block_page'		=> $block_data['block_page'],
						'block_enabled'		=> $cfg_array['block_enabled'],
						'block_groups'		=> (isset($_POST['all_groups']) ? 'all' : implode(',', $cfg_array['block_groups'])),
						'allow_collapse'	=> $cfg_array['allow_collapse'],
						'block_style'		=> $cfg_array['block_style'],
						'bbcode_bitfield'	=> $block_class->config['bbcode_bitfield'],
						'bbcode_uid'		=> $block_class->config['bbcode_uid'],
					);

					if($action == 'add')
					{
						$block_position = $cfg_array['block_position'];

						$sql = 'SELECT MAX(block_order) as max_block_order
							FROM ' . BLG_BLOCK_TABLE . "
							WHERE block_position = $block_position
							AND block_page = $page_id";
						$result = $db->sql_query($sql);
						$max_block_order = (int) $db->sql_fetchfield('max_block_order');
						$db->sql_freeresult($result);

						$sql_ary += array(
							'block_position'	=> $block_position,
							'block_order'		=> $max_block_order + 1,
						);
					}

		            if($action == 'edit')
		            {               
		            	$sql = 'UPDATE ' . BLG_BLOCK_TABLE . '
							SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
							WHERE block_id = ' . $block_data['block_id'];

		                $message = 'UPDATED';
		            }
		            else
		            {
						$sql = 'INSERT INTO ' . BLG_BLOCK_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);

						$message = 'ADDED';
		            }

					$db->sql_query($sql);

					add_log('admin', "LOG_BLOCK_$message", $user->lang($sql_ary['block_title']), $page_title);
					$template->assign_var('NOTICE', $user->lang["BLOCK_$message"]);

					return false;
				}

				foreach($display_vars as $config_key => $vars)
				{
					if (strpos($config_key, 'legend') !== false)
					{
						$template->assign_block_vars('options', array(
							'S_LEGEND'		=> true,
							'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
						);
						continue;
					}
		
					$type = explode(':', $vars['type']);
					
					if(!isset($cfg_array[$config_key]) && isset($vars['default']))
					{
						$cfg_array[$config_key] = $vars['default'];
					}
		
					$content = build_cfg_template($type, $config_key, $cfg_array, $config_key, $vars);
					if (empty($content))
					{
						continue;
					}
		
					$template->assign_block_vars('options', array(
						'KEY'			=> $config_key,
						'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
						'S_EXPLAIN'		=> (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '',
						'CONTENT'		=> $content,
					));
		
					unset($display_vars[$config_key]);
				}
				
				$title = strtoupper($action) . '_BLOCK_TITLE';
				
				$block_info = $this->get_block_info($block_data['block_alias']);

				$template->assign_vars(array(
					'L_TITLE'			=> $user->lang($title, (($action == 'add') ? $block_info['title'] : $block_data['block_title'])),
					'L_TITLE_EXPLAIN'	=> $user->lang[$title . '_EXPLAIN'],

					'HAS_CONFIG'		=> $has_config,
					'CONFIG_TEMPLATE'	=> ($has_config && !empty($block_class->tpl_name)) ? $blockgets->path . "block/{$block_class->tpl_name}.html" : '',

					'S_HIDDEN_FIELDS'	=> build_hidden_fields(array(
						'p'				=> $page_id,
						'b'				=> $block_data['block_id'],
						'block_alias'	=> $block_data['block_alias'],
					)),

					'U_ACTION'			=> $this->u_action . '&amp;action=' . $action,
					'U_BACK'			=> $this->u_action,
				));
				
				if(sizeof($error))
				{
					$template->assign_vars(array(
						'NOTICE'		=> implode('<br />', $error),
						'NOTICE_ERROR'	=> true,
					));
				}

				$this->tpl_name = $blockgets->path . '/acp_block_edit';
			break;

			case 'save_position':
				$success = true;

				for($i = 1; $i < count($blockgets->block_position_names); $i++)
				{
					$block_name = $blockgets->block_position_names[$i] . '_block';

					$item_positions = request_var($block_name, array(0 => 0));

					if(empty($item_positions))
					{
						continue;
					}

					foreach($item_positions as $position => $block_id)
					{
						$sql = 'UPDATE ' . BLG_BLOCK_TABLE . '
							SET block_order = ' . ((int)$position + 1) . ", block_position = $i
							WHERE block_id = $block_id
							AND block_page = $page_id";

						if(!$db->sql_query($sql))
						{
							$success = false;
							break;
						}
					}
				}
				
				if(!$success)
				{
					$template->assign_vars(array(
						'NOTICE_ERROR'	=> true,
						'NOTICE'		=> $user->lang['BLOCK_POSITION_NOT_UPDATED'],
					));
				}
				else
				{
					add_log('admin', "LOG_BLOCK_MOVED", $page_title);
					$template->assign_var('NOTICE', $user->lang['BLOCK_POSITION_UPDATED']);
				}

				return false;
			break;

			case 'enable':
			case 'disable':
				$sql = 'UPDATE ' . BLG_BLOCK_TABLE . '
					SET block_enabled = ' . (($action == 'enable') ? 1 : 0) . '
					WHERE ' . $db->sql_in_set('block_id', $block_ids) . "
					AND block_page = $page_id";

				$db->sql_query($sql);
				
				return false;
			break;

			case 'delete':
				// Remove the blocks
				$sql = 'DELETE FROM ' . BLG_BLOCK_TABLE . '
					WHERE ' . $db->sql_in_set('block_id', $block_ids);
				$db->sql_query($sql);

				// Reajust the order of the blocks, prevent errors
				$positions = array();
				
				$sql = 'SELECT block_id, block_position
					FROM ' . BLG_BLOCK_TABLE . "
					WHERE block_page = $page_id
					ORDER BY block_order ASC";
				$result = $db->sql_query($sql);
				while($row = $db->sql_fetchrow($result))
				{
					$pos = (int)$row['block_position'];
					
					if(!isset($positions[$pos]))
					{
						$positions[$pos] = array();
					}
					
					$positions[$pos][] = $row['block_id'];
				}
				$db->sql_freeresult($result);
				
				if(!empty($positions))
				{
					foreach($positions as $pos => $blocks)
					{
						foreach($blocks as $id => $block)
						{
							$sql = 'UPDATE ' . BLG_BLOCK_TABLE . '
								SET block_order = ' . ($id + 1) . "
								WHERE block_id = $block
								AND block_position = $pos";
							$db->sql_query($sql);
						}
					}
				}
				
				add_log('admin', 'LOG_BLOCK_REMOVED', $page_title);
				$template->assign_var('NOTICE', $user->lang['BLOCK_REMOVED']);
				return false;
			break;
			
			case 'move':
			case 'copy':
				$target_page_id = request_var('target_page_id', 0);
				
				$max_orders = $block_positions = array();
				
				// Obtain the title of new page (for log)
				$sql = 'SELECT page_title
					FROM ' . BLG_PAGES_TABLE . '
					WHERE page_id = ' . $target_page_id;
				$result = $db->sql_query($sql);
				$new_page_title = $db->sql_fetchfield('page_title');
				$db->sql_freeresult($result);
				
				if(!$new_page_title)
				{
					break;
				}
				
				$new_page_title = (isset($user->lang[$new_page_title]) ? $user->lang[$new_page_title] : $new_page_title);

				// Obtain the last block order in the target page
				$sql = 'SELECT MAX(block_order) AS max_order, block_position
					FROM ' . BLG_BLOCK_TABLE . "
					WHERE block_page = $target_page_id
					GROUP BY block_position";
				$result = $db->sql_query($sql);
				while($row = $db->sql_fetchrow($result))
				{
					$position = (int)$row['block_position'];
					$max_orders[$position] = (int)$row['max_order'];
				}
				$db->sql_freeresult($result);
				
				// Get relevant data from selected blocks
				$sql = 'SELECT *
					FROM ' . BLG_BLOCK_TABLE . '
					WHERE ' . $db->sql_in_set('block_id', $block_ids) . '
					ORDER BY block_order ASC';
				$result = $db->sql_query($sql);
				while($row = $db->sql_fetchrow($result))
				{
					$position = (int)$row['block_position'];

					if(!isset($block_positions[$position]))
					{
						$block_positions[$position] = array();
					}
					
					$block_positions[$position][] = $row;
				}
				$db->sql_freeresult($result);
				
				// Apply the changes
				$copy_blocks = array();
				foreach($block_positions as $position => $data)
				{
					foreach($data as $order => $row)
					{
						$order = (isset($max_orders[$position]) ? $max_orders[$position] : 0) + $order + 1;

						if($action == 'move')
						{
							$sql_ary = array(
								'block_page'	=> $target_page_id,
								'block_order'	=> $order,
							);
							
							$sql = 'UPDATE ' . BLG_BLOCK_TABLE . '
								SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
								WHERE block_id = ' . $row['block_id'];
							$db->sql_query($sql);
						}
						else
						{
							unset($row['block_id']);
							
							$row = array_merge($row, array(
								'block_page'	=> $target_page_id,
								'block_order'	=> $order,
							));

							$copy_blocks[] = $row;
						}
					}
				}
				
				if($action == 'copy')
				{
					if(sizeof($copy_blocks))
					{
						$db->sql_multi_insert(BLG_BLOCK_TABLE, $copy_blocks);

						add_log('admin', 'LOG_BLOCK_COPY_PAGE', $page_title, $new_page_title);
						$template->assign_var('NOTICE', $user->lang['BLOCK_COPIED']);
					}
				}
				else
				{
					add_log('admin', 'LOG_BLOCK_MOVED_PAGE', $page_title, $new_page_title);
					$template->assign_var('NOTICE', $user->lang['BLOCK_MOVED']);
				}

				return false;
			break;
			
			case 'chg_groups':
				$new_groups = request_var('new_group_ids', '');

				$sql = 'UPDATE ' . BLG_BLOCK_TABLE . "
					SET block_groups = '" . $db->sql_escape($new_groups) . "'
					WHERE " . $db->sql_in_set('block_id', $block_ids);
				$db->sql_query($sql);
				
				$template->assign_var('NOTICE', $user->lang['GROUPS_CHANGED']);
				
				return false;
			break;
		}
		
		return true;
	}
	
	function get_block_info($block_alias = '', $block_type = '')
	{
		global $user;

		if(!$block_alias)
		{
			return '';
		}
		
		$title = $explain = '';
		
		if(preg_match('#^([^&\'"<>]+)_(block|addon)+$#i', $block_alias, $match))
		{
			$block_alias	= $match[1];
			$block_type		= $match[2];
		}
		
		if(isset($user->lang['blocks']["{$block_alias}_title"]))
		{
			$title = $user->lang['blocks']["{$block_alias}_title"];
		}
		
		if(isset($user->lang['blocks']["{$block_alias}_explain"]))
		{
			$explain = $user->lang['blocks']["{$block_alias}_explain"];
		}
		
		if(!$explain && strpos($block_type, 'addon') !== false)
		{
			$explain = 'AddOn';
		}
		
		return array(
			'title'		=> ($title) ? $title : ucfirst(str_replace('_', ' ', $block_alias)),
			'explain'	=> $explain,
			'type'		=> $block_type,
		);
	}
	
	function block_position_select($select_id = 0)
	{
		global $blockgets, $user;

		if(empty($blockgets->block_position_names))
		{
			return '';
		}

		$options = array();
		foreach($blockgets->block_position_names as $id => $name)
		{
			if($name)
			{
				$options[$id] = strtoupper($name) . '_COLUMN';
			}
		}

		return blg_make_select($options, $select_id);
	}
	
	function insert_forum_block($page_id, $check = false)
	{
		global $db, $blockgets;
		
		if($check)
		{
			$sql = 'SELECT block_id
				FROM ' . BLG_BLOCK_TABLE . "
				WHERE block_alias = 'forum_content'
				AND block_page = $page_id";
			$result = $db->sql_query($sql);
			$block_id = (int)$db->sql_fetchfield('block_id');
			$db->sql_freeresult($result);
			
			if($block_id)
			{
				return true;
			}
		}

		$sql_ary = array(
			'block_title'		=> 'FORUM',
			'block_content'		=> '',
			'block_alias'		=> 'forum_content',
			'block_img'			=> '',
			'block_page'		=> $page_id,
			'block_enabled'		=> 1,
			'block_groups'		=> 'all',
			'allow_collapse'	=> 0,
			'bbcode_bitfield'	=> '',
			'bbcode_uid'		=> '',
		);
		
		$block_position = array_search('center', $blockgets->block_position_names);

		$sql = 'SELECT MAX(block_order) as max_block_order
			FROM ' . BLG_BLOCK_TABLE . '
			WHERE block_position = ' . $block_position . "
			AND block_page = $page_id";
		$result = $db->sql_query($sql);
		$max_block_order = (int) $db->sql_fetchfield('max_block_order');
		$db->sql_freeresult($result);

		$sql_ary += array(
			'block_position'	=> $block_position,
			'block_order'		=> $max_block_order + 1,
		);

		$sql = 'INSERT INTO ' . BLG_BLOCK_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
		$db->sql_query($sql);
		
		$sql_ary['block_id'] = $db->sql_nextid();
		
		return $sql_ary;
	}
	
	function build_file_select()
	{
		global $phpbb_root_path, $phpEx, $user, $db;
	
		$exclude_files = array('common', 'config', 'cron', 'feed', 'home', 'style');
		
		// No show the already created pages
		$sql = 'SELECT page_alias 
			FROM ' . BLG_PAGES_TABLE . '
			WHERE page_type = ' . PAGE_FORUM;
		$result = $db->sql_query($sql);
		while($row = $db->sql_fetchrow($result))
		{
			$exclude_files[] = $row['page_alias'];
		}
		$db->sql_freeresult($result);

		$options = array(
			''	=> 'PAGE_CUSTOM_ONE',

			'legend1'	=> 'FORUM_FILES',
		);
		
		// Read all the avaliable files in phpbb root path
		if($dir = @opendir($phpbb_root_path))
		{
			$file_ary = array();

			while (($file = @readdir($dir)) !== false)
			{
				$pos = strpos($file, ".$phpEx");
				
				if($pos !== false)
				{
					$filename = substr($file, 0, $pos);
				
					if($filename && !in_array($filename, $exclude_files))
					{
						$file_ary[$filename] = $file;
					}
				}
			}
			closedir($dir);
			asort($file_ary);

			$options += $file_ary;
		}

		return blg_make_select($options);
	}
}