<?php
/** 
*
* installer.php [French [Fr]]
*
* @package language cBB Blockgets
* @version $Id: installer.php v1.0.3 20/10/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
* Translated by Mathieu M.
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

/* General */
$lang = array_merge($lang, array(
	'OVERVIEW_TITLE'		=> 'Bienvenue sur %1$s %2$s!',
	'OVERVIEW_BODY'			=> '%1$s est une nouvelle génération de CMS pour phpBB 3.0.x.<br />
		Il s’agit d’un MOD riche en fonctionnalités et en blocs, facile à prendre en mains et supporté par l’équipe CaniDev. Nous espérons que ce MOD réponde à toutes vos attentes. <br /><br />
		La procédure d’installation vous offre la possibilité d’installer, mettre à jouer ou désinstaller %1$s.<br />
		Pour plus d’informations, veuillez lire le guide d’installation qui se trouve dans le dossier <em>contrib</em>.<br /><br />
		Pour poursuivre, veuillez choisir l’une des options suivantes.',

	'INSTALLER_TITLE'		=> '%1$s %3$s &bull; %2$s',

	'BACK'					=> 'Retour',
	'FINAL'					=> 'Etape finale',
	'FORUM_GO'				=> 'Aller au forum',
	'HOME'					=> 'Accueil',
	'INTRO'					=> 'Intro',
	'INST_ERR'				=> 'Une erreur est survenue durant l’installation qui a dû s’arrêter.<br />Cette erreur peut être causée par des fichiers du forum modifiés incorrectement ou par des fichiers corrompus.',
	'LOADING'				=> 'Chargement',
	'NEED_HELP'				=> 'Besoin d’aide?',
	'NOMOD'					=> 'Le MOD n’est pas installé',
	'ONLINE_DOCUMENTATION'	=> 'Documentation',
	'OPTIONAL_CHECKS'		=> 'Prérequis supplémentaires',
	'REQUIRED_CHECKS'		=> 'Besoin des prérequis',
	'REQUIREMENTS'			=> 'Prérequis',
	'SUPPORT_FORUM'			=> 'Forum de support',
	'TRY_AGAIN'				=> 'Réessayer',
	'VERSION_INFO'			=> 'Version',
	'VERSION_NOT_UP_TO_DATE'	=> 'Une nouvelle version du MOD est disponible.<br />
		Pour plus d’informations sur la nouvelle version, cliquez sur <a href="%s">ce lien</a>.',
	'WELCOME'				=> 'Bienvenue',

	'CHK_VERSION_INSTALLED'		=> 'Version installée: %s',
	'CHK_VERSION_LATEST'		=> 'Dernière version: %s',
	'CHK_VERSION_PACKAGE'		=> 'Version du pack: %s',
	'CHK_PHPBB_VERSION'			=> 'phpBB %s ou supérieur.',
));

/* Install */
$lang = array_merge($lang, array(
	'INSTALL'				=> 'Installer',
	'INSTALL_CONGRATS'			=> 'Félicitations!',
	'INSTALL_CONGRATS_EXPLAIN'	=> 'L’installation de %1$s %2$s s’est déroulée avec succès.<br /><br />
		Rendez vous sur votre forum et configurez %1$s!<br />
		En cliquant sur le bouton suivant, vous serez redirigé sur la page de configuration générale de %1$s.',
	'INSTALL_ERROR'			=> 'Opss! Plusieurs erreurs sont survenues durant l’installation.<br />
		Vous pouvez essayer de réinstaller le MOD ou demander de l’aide sur <a href="http://www.canidev.com" onclick="window.open(this.href); return false;">www.CaniDev.com</a>.',
	'INSTALL_NOTICE'		=> 'L’installation s’est déroulée avec succès.<br />Passer à l’étape suivante pour la finaliser.',
	'INSTALL_RESULTS'		=> 'Résultats de l’installation',
	'INSTALL_START'			=> 'Installer',

	'CHK_DATABASE_INSTALL'		=> 'Créer les tables et insérer quelques données basiques dans la base de données.',
	'CHK_MODULES_INSTALL'		=> 'Insérer ou mettre à jour les modules.',
	'CHK_PERMISSIONS_INSTALL'	=> 'Insérer ou mettre à jour les permissions.',
	'CHK_MOD_CLASS'				=> 'Classe principale du MOD.',

	'REQUIREMENTS_TITLE'		=> 'Compatibilité de l’installation',
	'REQUIREMENTS_EXPLAIN'		=> 'Avant de procéder à l’installation complète, %1$s va effectuer certains tests sur votre serveur pour s’assurer que l’installation peut s’effectuer sans problème.<br />
		Veuillez lire attentivement les résultats et ne pas poursuivre jusqu’à ce que les tests sont concluant.',

	'REQ_INSTALL_NOTICE'	=> 'Votre système répond aux prérequis pour installer le MOD.',
	'REQ_INSTALL_ERROR'		=> 'Les prérequis ne sont pas respectés afin d’installer le MOD.<br />Veuillez vérifier si vous avez bien suivi toutes les étapes du fichier <em>install.xml</em>.',
));

/* Uninstall */
$lang = array_merge($lang, array(
	'UNINSTALL'				=> 'Désinstaller',
	'UNINSTALL_ERROR'		=> 'Opss! Plusieurs erreurs sont survenues durant la désinstallation.<br />
		Vous pouvez essayer de réinstaller le MOD ou demander de l’aide sur <a href="http://www.canidev.com" onclick="window.open(this.href); return false;">www.CaniDev.com</a>.',
	'UNINSTALL_INTRO'			=> 'Bienvenue sur l’assistant de désinstallation',
	'UNINSTALL_INTRO_BODY'		=> '<p>Avec cette option, vous allez supprimer complètement %1$s de votre forum phpBB 3.0.x.</p>
		<p>Le processus supprime les valeurs et les tables dans la base de données mais les modifications des fichiers de phpBB doivent être supprimées manuellement.</p><br />
		<p>Le processus ne peut pas revenir en arrière lorsqu’il débute.</p><br />
		<p>Pour lancer la désinstallation, veuillez appuyer sur le bouton suivant.</p>',
	'UNINSTALL_NOTICE'		=> 'La désinstallation s’est déroulée avec succès.<br />Passer à l’étape suivante pour la finaliser.',
	'UNINSTALL_RESULTS'		=> 'Désinstaller les résultats',
	'UNINSTALL_START'		=> 'Désinstaller',
	'UNINSTALL_SUCCEFULL'			=> 'La désinstallation est terminée!',
	'UNINSTALL_SUCCEFULL_EXPLAIN'	=> 'La désinstallation de %1$s %2$s s’est déroulée avec succès.<br /><br />
		Rendez vous sur votre forum et assurez vous que tout fonctionne correctement!<br />
		En cliquant sur le bouton suivant, vous serez redirigé vers l’index du forum.',

	'CHK_DATABASE_UNINSTALL'	=> 'Supprimer les tables et valeurs dans la base de données.',
	'CHK_MODULES_UNINSTALL'		=> 'Supprimer les modules.',
	'CHK_PERMISSIONS_UNINSTALL'	=> 'Supprimer les permissions d’utilisateur.',
	'CHK_MOD_INSTALLED'			=> 'Le MOD est installé.',

	'REQ_UNINSTALL_NOTICE'	=> 'Votre système répond aux prérequis pour désinstaller le MOD.',
	'REQ_UNINSTALL_ERROR'	=> 'Les prérequis ne sont pas respectés afin de désinstaller le MOD.',
));

/* Update */
$lang = array_merge($lang, array(
	'CHK_DATABASE_UPDATE'		=> 'Mettre à jour les tables et valeurs de la base de données.',
	
	'UPDATE'			=> 'Mettre à jour',
	'UPDATE_ERROR'		=> 'Opss! Plusieurs erreurs sont survenues durant la mise à jour.<br />
		Vous pouvez essayer de réinstaller le MOD ou demander de l’aide sur <a href="http://www.canidev.com" onclick="window.open(this.href); return false;">www.CaniDev.com</a>.',
	'UPDATE_INTRO'				=> 'Bienvenue sur l’assistant de mise à jour',
	'UPDATE_INTRO_BODY'			=> '<p>Avec cette option, vous allez mettre à jour %1$s vers la dernière version.</p><br />
		<p>Avant de continuer, assurez vous des points suivants:</p>
		<ol>
			<li>Vous avez copié/téléchargé les fichiers de la dernière version de %1$s dans le dossier de votre forum (en écrasant l’ancienne version).</li>
			<li>Vous avez effectué les modifications de fichiers phpBB nécessaires comme expliqué dans le fichier <em>contrib/update/%2$s_to_%3$s/update.xml</em>.</li>
		</ol><br />
		<p><strong>Note:</strong> Il est recommandé d’effectuer une sauvegarde de votre base de données avant de continuer.</p>
		<p>Pour lancer la mise à jour, veuillez appuyer sur le bouton suivant.</p>',
	'UPDATE_NOTICE'		=> 'La mise à jour s’est déroulée avec succès.<br />Passer à l’étape suivante pour la finaliser.',
	'UPDATE_RESULTS'	=> 'Résultats de la mise à jour',
	'UPDATE_START'		=> 'Mettre à jour',
	'UPDATE_SUCCEFULL'			=> 'Mise à jour effectuée!',
	'UPDATE_SUCCEFULL_EXPLAIN'	=> 'Rendez vous sur votre forum et testez le nouveau %1$s %2$s !<br />
		En cliquant sur le bouton suivant, vous serez redirigé vers la page de configuration générale de %1$s.',
));

/* Import from cBB Portal */
$lang = array_merge($lang, array(
	'CHK_BLG_INSTALLED'		=> 'Le MOD "cBB Blockgets %1$s" est installé sur le forum.',
	'CHK_PORTAL_INSTALLED'	=> 'Le MOD "cBB Portal %1$s" est installé sur le forum.',

	'IMPORT'				=> 'Importer',
	'IMPORT_CONGRATS'			=> 'Importation terminée!',
	'IMPORT_CONGRATS_EXPLAIN'	=> 'L’importation de %1$s %2$s s’est déroulée avec succès.<br /><br />
		Rendez vous sur votre forum et configurez %1$s!<br />
		En cliquant sur le bouton suivant, vous serez redirigé vers la page de configuration générale de %1$s.',
	'IMPORT_INTRO_BODY'		=> 'Avec cette option, vous allez importer tous les paramètres et blocs de cBB Portal vers %1$s.<br />
		Les données actuelles seront supprimées de %1$s et remplacées par les données de cBB Portal.<br />
		Le processus ne peut pas être annulé lorsqu’il a démarré.<br /><br />
		Pour lancer l’importation, veuillez appuyer sur le bouton suivant.',
	'IMPORT_RESULTS'		=> 'Résultats de l’importation',
	'IMPORT_START'			=> 'Lancer l’importation',
	'PORTAL_IMPORTER'		=> 'Importer les données depuis cBB Portal',
	
	'IMPORT_ERROR'			=> 'Opss! Plusieurs erreurs sont survenues durant l’importation.<br />
		Vous pouvez essayer d’importer le MOD à nouveau ou demander de l’aide sur <a href="http://www.canidev.com" onclick="window.open(this.href); return false;">www.CaniDev.com</a>.',
	'IMPORT_NOTICE'		=> 'L’importation s’est effectuée avec succès.<br />Passer à l’étape suivant pour la finaliser.',
	
	'CHK_DATABASE_IMPORT'	=> 'Copier les tables et les valeurs dans la base de données.',
	
	'REQ_IMPORT_NOTICE'		=> 'Votre système répond aux prérequis pour importer les données depuis cBB Portal.',
	'REQ_IMPORT_ERROR'		=> 'Les prérequis ne sont pas respectés pour importer les données depuis cBB Portal.',
));

// Local Variables
$lang = array_merge($lang, array(
	'PORTAL'			=> 'Portail',
	'DOCK_MENU'			=> 'Menu dock',
	'MAIN_MENU'			=> 'Menu principal',
	'RECOMMENDED'		=> 'Recommandé',

	'P_ADMIN'			=> 'Administration',
	'P_MAIN'			=> 'Principal',
	'P_MCP'				=> 'Panneau de modération',
	'P_ACP'				=> 'Panneau d’administration',

	'PHPBB_TITLE'		=> 'Site officiel phpBB',
	'XAMPP_TITLE'		=> 'Xampp',
	'SOURCEFORGE_TITLE'	=> 'Applications Open Source',

	'WELCOME_GUEST'		=> '<div style="text-align:center; font-size:1.2em;"><a href="http://www.canidev.com"><img src="{T_BLOCKGETS_PATH}images/cbb-blockgets-logo.png" alt="Logo" /></a><br /><strong><i>Forum équipé par cBB Blockgets</i><br /><br />Bienvenue sur notre forum!<br />Enregistrez vous pour un accès complet au contenu !</strong></div>',
	'WELCOME_MEMBER'	=> '<div style="text-align:center; font-size:1.2em;"><a href="http://www.canidev.com"><img src="{T_BLOCKGETS_PATH}images/cbb-blockgets-logo.png" alt="Logo" /></a><br /><strong><i>Forum équipé par cBB Blockgets</i><br /><br />Bienvenue sur notre forum {S_USERNAME}</strong></div>',
));

?>
