<?php
/** 
*
* installer.php [English [En]]
*
* @package language cBB Blockgets
* @version $Id: installer.php v1.0.3 01/11/2012 $
*
* @copyright (c) 2012 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

/* General */
$lang = array_merge($lang, array(
	'OVERVIEW_TITLE'		=> '¡ Welcome to %1$s %2$s!',
	'OVERVIEW_BODY'			=> '%1$s is the new generation of CMS for phpBB 3.0.x.<br />
		This is a mod rich in implementations and blocks, user friendly and fully supported by the CaniDev team. We hope this mod meets with your expectations too well. <br /><br />
		This installation system will guide you to install, update or uninstall %1$s.<br />
		For more information, please read the installation guide located in <em>contrib</em> directory.<br /><br />
		To continue, please select one of the options below.',

	'INSTALLER_TITLE'		=> '%1$s %3$s &bull; %2$s',

	'BACK'					=> 'Back',
	'FINAL'					=> 'Final step',
	'FORUM_GO'				=> 'Go to Forum',
	'HOME'					=> 'Home',
	'INTRO'					=> 'Intro',
	'INST_ERR'				=> 'There was an error during installation that forces to cancel.<br />This error may be due to changes made to the files incorrectly on the forum or has corrupted files.',
	'LOADING'				=> 'Loading',
	'NEED_HELP'				=> '¿Need Help?',
	'NOMOD'					=> 'Mod not installed',
	'ONLINE_DOCUMENTATION'	=> 'Online documentation',
	'OPTIONAL_CHECKS'		=> 'Additional requirements',
	'REQUIRED_CHECKS'		=> 'Need Requirements',
	'REQUIREMENTS'			=> 'Requirements',
	'SUPPORT_FORUM'			=> 'Support Forum',
	'TRY_AGAIN'				=> 'Try again',
	'VERSION_INFO'			=> 'Version Information',
	'VERSION_NOT_UP_TO_DATE'	=> 'A newer version of this MOD is available.<br />
		For more details about the new version click on <a href="%s">this link</a>.',
	'WELCOME'				=> 'Welcome',

	'CHK_VERSION_INSTALLED'		=> 'Installed version: %s',
	'CHK_VERSION_LATEST'		=> 'Latest version: %s',
	'CHK_VERSION_PACKAGE'		=> 'Package version: %s',
	'CHK_PHPBB_VERSION'			=> 'phpBB %s or higher.',
));

/* Install */
$lang = array_merge($lang, array(
	'INSTALL'				=> 'Install',
	'INSTALL_CONGRATS'			=> 'Congratulations!',
	'INSTALL_CONGRATS_EXPLAIN'	=> 'The installation of %1$s %2$s has successfully completed.<br /><br />
		Enter in your forum and configure %1$s!<br />
		By clicking the button below reach the main configuration screen of %1$s.',
	'INSTALL_ERROR'			=> 'Opss! Errors occurred during installation.<br />
		Try reinstalling the MOD or request help in <a href="http://www.canidev.com" onclick="window.open(this.href); return false;">www.CaniDev.com</a>.',
	'INSTALL_NOTICE'		=> 'The installation was completed successfully.<br />Proceed to the next step to terminate it.',
	'INSTALL_RESULTS'		=> 'Installation Results',
	'INSTALL_START'			=> 'Install',

	'CHK_DATABASE_INSTALL'		=> 'Create tables and insert basic values in the database.',
	'CHK_MODULES_INSTALL'		=> 'Insert or update modules.',
	'CHK_PERMISSIONS_INSTALL'	=> 'Insert or update Permissions.',
	'CHK_MOD_CLASS'				=> 'MOD Main Class.',

	'REQUIREMENTS_TITLE'		=> 'Installation Compatibility',
	'REQUIREMENTS_EXPLAIN'		=> 'Before proceeding with the full installation, %1$s will perform some tests on your server configuration to ensure that it can be installed without problems.<br />
		Please be sure to read carefully and thoroughly the results and not continue until all required tests are approved.',

	'REQ_INSTALL_NOTICE'	=> 'Your system meets the requirements to install the MOD.',
	'REQ_INSTALL_ERROR'		=> 'Not met the requirements to install the MOD.<br />Check if you followed all the steps of the <em>install.xml</em> file.',
));

/* Uninstall */
$lang = array_merge($lang, array(
	'UNINSTALL'				=> 'Uninstall',
	'UNINSTALL_ERROR'		=> 'Opss! Errors occurred during uninstall.<br />
		Try reinstalling the MOD or request help in <a href="http://www.canidev.com" onclick="window.open(this.href); return false;">www.CaniDev.com</a>.',
	'UNINSTALL_INTRO'			=> 'Welcome to the Uninstall',
	'UNINSTALL_INTRO_BODY'		=> '<p>With this option, you remove %1$s completely from your phpBB 3.0.x forum.</p>
		<p>This process eliminates the values and tables in the database but the changes in phpBB files must remove manually.</p><br />
		<p>This process can not be undone once started.</p><br />
		<p>To start the uninstallation, please press the button below.</p>',
	'UNINSTALL_NOTICE'		=> 'Uninstall was completed successfully.<br />Proceed to the next step to terminate it.',
	'UNINSTALL_RESULTS'		=> 'Uninstall Results',
	'UNINSTALL_START'		=> 'Uninstall',
	'UNINSTALL_SUCCEFULL'			=> 'Uninstall Complete!',
	'UNINSTALL_SUCCEFULL_EXPLAIN'	=> 'Successfully uninstalled %1$s %2$s.<br /><br />
		Enter in your forum and make sure everything works fine!<br />
		By clicking the button below you reach the General Index of the forum.',

	'CHK_DATABASE_UNINSTALL'	=> 'Delete Tables and Values in the Database.',
	'CHK_MODULES_UNINSTALL'		=> 'Delete modules.',
	'CHK_PERMISSIONS_UNINSTALL'	=> 'Remove user Permissions.',
	'CHK_MOD_INSTALLED'			=> 'MOD installed.',

	'REQ_UNINSTALL_NOTICE'	=> 'Your system meets the requirements to uninstall the MOD.',
	'REQ_UNINSTALL_ERROR'	=> 'Not met the requirements to uninstall the MOD.',
));

/* Update */
$lang = array_merge($lang, array(
	'CHK_DATABASE_UPDATE'		=> 'Update tables and values in the database.',

	'UPDATE'			=> 'Update',
	'UPDATE_ERROR'		=> 'Opss! Errors occurred during update.<br />
		Try reinstalling the MOD or request help in <a href="http://www.canidev.com" onclick="window.open(this.href); return false;">www.CaniDev.com</a>.',
	'UPDATE_INTRO'				=> 'Welcome to the Update',
	'UPDATE_INTRO_BODY'			=> '<p>With this option, you update %1$s to the latest version.</p><br />
		<p>Before proceeding, ensure that:</p>
		<ol>
			<li>You copied/uploaded the files of the latest version of %1$s in forum directory (overwriting the old version).</li>
			<li>You have made the necessary changes to phpBB files as explains in the update file <em>contrib/update/%2$s_to_%3$s/update.xml</em>.</li>
		</ol><br />
		<p><strong>Note:</strong> It is recommended to backup the database before continuing with this process.</p>
		<p>To start the update, please press the button below.</p>',
	'UPDATE_NOTICE'		=> 'The update has been successfully completed.<br />Proceed to the next step to terminate it.',
	'UPDATE_RESULTS'	=> 'Update Results',
	'UPDATE_START'		=> 'Update',
	'UPDATE_SUCCEFULL'			=> 'Update completed!',
	'UPDATE_SUCCEFULL_EXPLAIN'	=> 'Enter in your forum and test the new %1$s %2$s !<br />
		By clicking the button below reach the main configuration screen of %1$s.',
));

/* Import from cBB Portal */
$lang = array_merge($lang, array(
	'CHK_BLG_INSTALLED'		=> 'Mod "cBB Blockgets %1$s" installed in the forum.',
	'CHK_PORTAL_INSTALLED'	=> 'Mod "cBB Portal %1$s" installed in the forum.',

	'IMPORT'				=> 'Import',
	'IMPORT_CONGRATS'			=> 'Import completed!',
	'IMPORT_CONGRATS_EXPLAIN'	=> 'The import to %1$s %2$s has successfully completed.<br /><br />
		Enter in your forum and configure %1$s!<br />
		By clicking the button below reach the main configuration screen of de %1$s.',
	'IMPORT_INTRO_BODY'		=> 'With this option you will import all settings and blocks from cBB Portal to %1$s.<br />
		Current data will be deleted from %1$s and replaced by cBB Portal data.<br />
		This process can not be undone once started.<br /><br />
		To start the import, please press the button below.',
	'IMPORT_RESULTS'		=> 'Import Results',
	'IMPORT_START'			=> 'Start Import',
	'PORTAL_IMPORTER'		=> 'Import data from cBB Portal',
	
	'IMPORT_ERROR'			=> 'Opss! Errors occurred during import.<br />
		Try import the MOD again or request help in <a href="http://www.canidev.com" onclick="window.open(this.href); return false;">www.CaniDev.com</a>.',
	'IMPORT_NOTICE'		=> 'The import has been successfully completed.<br />Proceed to the next step to terminate it.',
	
	'CHK_DATABASE_IMPORT'	=> 'Copy tables and values in the database.',
	
	'REQ_IMPORT_NOTICE'		=> 'Your system meets the requirements for importing data from cBB Portal.',
	'REQ_IMPORT_ERROR'		=> 'Not met the requirements to import data from cBB Portal.',
));

// Local Variables
$lang = array_merge($lang, array(
	'PORTAL'			=> 'פורטל',
	'DOCK_MENU'			=> 'Dock menu',
	'MAIN_MENU'			=> 'Main Menu',
	'RECOMMENDED'		=> 'Recommended',

	'P_ADMIN'			=> 'Administration',
	'P_MAIN'			=> 'Main',
	'P_MCP'				=> 'Moderation Panel',
	'P_ACP'				=> 'Administration Panel',

	'PHPBB_TITLE'		=> 'phpBB official website',
	'XAMPP_TITLE'		=> 'Xampp',
	'SOURCEFORGE_TITLE'	=> 'Open source applications',

	'WELCOME_GUEST'		=> '<div style="text-align:center; font-size:1.2em;"><a href="http://www.canidev.com"><img src="{T_BLOCKGETS_PATH}images/cbb-blockgets-logo.png" alt="Logo" /></a><br /><strong><i>Forum equipped with cBB Blockgets</i><br /><br />Welcome to our forum!<br />Register to access all the content!.</strong></div>',
	'WELCOME_MEMBER'	=> '<div style="text-align:center; font-size:1.2em;"><a href="http://www.canidev.com"><img src="{T_BLOCKGETS_PATH}images/cbb-blockgets-logo.png" alt="Logo" /></a><br /><strong><i>Forum equipped with cBB Blockgets</i><br /><br />Welcome back to our forum {S_USERNAME}</strong></div>',
));

?>
